#include <stdlib.h>
#include <dlfcn.h>
#include <link.h>

static int (*axp_dn_comp)() = NULL;


int
do_dn_comp(char * exp_dn, char *comp_dn, int length,
		unsigned int *dnptrs, unsigned int *lastdnptr)
{
    int		alloc_count;
    char 	**alpha_dnptrs;
    char	**alpha_lastdnptr;
    int		retval;

    if(dnptrs) {
	if(lastdnptr) {
	    alloc_count = (lastdnptr - dnptrs);
	}
	else {
	    for(alloc_count = 0; dnptrs[alloc_count]; alloc_count++) ;
	    alloc_count++; /* Include NULL terminator */
	}
    }
    else {
    	alloc_count = 0;
    }

    if(alloc_count) {
	int i;
    	alpha_dnptrs = (char **)malloc(alloc_count * sizeof(char *));
        for(i = 0; dnptrs[i]; i++) {
	    alpha_dnptrs[i] = (char *)dnptrs[i];
	}
	alpha_dnptrs[i] = 0;
	if(lastdnptr) {
	    alpha_lastdnptr = alpha_dnptrs + alloc_count;
	}
	else {
	    alpha_lastdnptr = 0;
	}
    }

    if(!axp_dn_comp) {
	void *	resolv_handle;

	resolv_handle = dlopen("/usr/lib/libresolv.so", 0);
	if(!resolv_handle) {
	    perror("/usr/lib/libresolv.so");
	    exit(-1);
	}
	axp_dn_comp = dlsym(resolv_handle, "dn_comp");
	if(!axp_dn_comp) {
	    axp_dn_comp = dlsym(resolv_handle, "__dn_comp");
	    if(!axp_dn_comp) {
		perror("cannot resolve symbol __dn_comp");
		exit(-1);
	    }
	}
    }

    retval = (axp_dn_comp)(exp_dn, comp_dn, length, alpha_dnptrs,
						alpha_lastdnptr);
    

    if(alpha_lastdnptr) {
	int i;
        for(i = 0; alpha_dnptrs[i]; i++) {
	    dnptrs[i] = alpha_dnptrs[i];
	}
	dnptrs[i] = 0;
    }

    return(retval);
}



