#include <stdlib.h>

void do_qsort(void *base, size_t nmemb, size_t size, int (*compar)())
{
    void * compar_thunk;

    /* If the comparison function is an Alpha function, just do it.
     * Otherwise, we have to assume the comparison function is an
     * Intel function and build a reverse thunk for it...
     */
    if(is_alpha_code(compar)) {
	qsort(base, nmemb, size, compar);
    }
    else {
	compar_thunk = build_reverse_thunk(compar);
	qsort(base, nmemb, size, compar_thunk);
	free_reverse_thunk(compar_thunk);
    }
}
