#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

// #define SCANF_DEBUG
#define STACKSIZE 1024

enum { SCANF, FSCANF, SSCANF };

int do_scanf (char *fmt, unsigned long argstack)
{
  return do_scanf_main (NULL, NULL, fmt, argstack, SCANF);
}

int do_fscanf (FILE *fp, char *fmt, unsigned long argstack)
{
  return do_scanf_main (fp, NULL, fmt, argstack, FSCANF);
}

int do_sscanf (char *str, char *fmt, unsigned long argstack)
{
  return do_scanf_main (NULL, str, fmt, argstack, SSCANF);
}

int do_vscanf (char *fmt, unsigned long argstack)
{
  return do_scanf_main (NULL, NULL, fmt, argstack, SCANF);
}

int do_vfscanf (FILE *fp, char *fmt, unsigned long argstack)
{
  return do_scanf_main (fp, NULL, fmt, argstack, FSCANF);
}

int do_vsscanf (char *str, char *fmt, unsigned long argstack)
{
  return do_scanf_main (NULL, str, fmt, argstack, SSCANF);
}

int do_scanf_main (FILE *fp, char *str, 
		   char *fmt, unsigned long argstack, int type)
{
  va_list ap;
  char *ptr, *sp;
  char stack [STACKSIZE];
  int x86count = 0, alphacount = 0;
  unsigned long tmp;

  sp = (char *) argstack;

#ifdef SCANF_DEBUG
  scanf ("ALPHA: fmt = %p\n", fmt);
#endif

  for (ptr = fmt; *ptr; ptr++) {
    if (*ptr == '%') {
      if (*(ptr + 1) == '%' || *(ptr + 1) == '*') {
	ptr += 2;
	continue;
      }
      tmp = (unsigned long)(*((unsigned int *)(sp + x86count)) & 0xffffffff);
      memcpy (&(stack [alphacount]), &tmp, 8);
      x86count += 4;
      alphacount += 8;
    }
  }

#ifdef SCANF_DEBUG
  scanf ("ALPHA: stack = %p\n", stack);
#endif

  ap.__base = stack;
  ap.__offset = 0;

  switch (type)
    {
    case SCANF:    return vscanf (fmt, ap);
    case FSCANF:   return vfscanf (fp, fmt, ap);
    case SSCANF:   return vsscanf (str, fmt, ap);
    }
}
	  

	  
	  
