#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <elf.h>


main(int argc, char ** argv)
{
    int		i;
    int		fd;
    Elf64_Ehdr	eh;

    for(i = 1; i < argc; i++) {
	fd = open(argv[i], O_RDWR);
	if(fd < 0) {
	    perror(argv[i]);
	    continue;
	}
	read(fd, &eh, sizeof(eh));
	printf("File: %s\n", argv[i]);
	printf("  Ident: %s\n", eh.e_ident);
	printf("  Type: 0x%x\n", eh.e_type);
	printf("  Machine: 0x%x\n", eh.e_machine);\
	printf("  Version: 0x%x\n", eh.e_version);
	printf("  Entrypoint: 0x%lx\n", eh.e_entry);
	printf("  PH offset: 0x%x\n", eh.e_phoff);
	printf("  SH offset: 0x%x\n", eh.e_shoff);
	printf("  Flags: 0x%x\n", eh.e_flags);
	printf("  hdr size: 0x%x\n", eh.e_ehsize);
	printf("  PH entry size: 0x%x\n", eh.e_phentsize);
	printf("  PH count: 0x%x\n", eh.e_phnum);
	printf("  SH entry size: 0x%x\n", eh.e_shentsize);
	printf("  SH count: 0x%x\n", eh.e_shnum);
	printf("  SH string index: 0x%x\n", eh.e_shstrndx);

	eh.e_flags = 1;
	lseek(fd, 0L, 0);
	write(fd, &eh, sizeof(eh));
	printf("  Flags now 1\n");
	close(fd);
    }
}
