#include <stdio.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <syscall_thunk.h>
#include <errno.h>
#include <asm/unistd.h>

#define X86_MCL_CURRENT		1
#define X86_MCL_FUTURE		2

int do_mlockall(int a0, int a1, int a2, int a3, int a4, int a5)
{
    int		xflags = a0;
    int		flags = 0;
    int		retval;

    if(xflags & X86_MCL_CURRENT) {
	flags |= MCL_CURRENT;
    }
    if(xflags & X86_MCL_FUTURE) {
	flags |= MCL_FUTURE;
    }

    retval = mlockall(flags);
   
    if(retval == -1) {
	return(-alpha_to_intel_errno(errno));
    }
    else {
	return(retval);
    }
}

#ifdef RH_40
int mlock(__caddr_t addr, size_t len)
{
    return(syscall(__NR_mlock, addr, len));
}

int munlock(__caddr_t addr, size_t len)
{
    return(syscall(__NR_munlock, addr, len));
}

int mlockall(int flags)
{
    return(syscall(__NR_mlockall, flags));
}
#endif /* RH_40 */
