#include <stdio.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <syscall_thunk.h>
#include <errno.h>

#define X86_MS_ASYNC		1
#define X86_MS_INVALIDATE	2
#define X86_MS_SYNC		4

int do_msync(int a0, int a1, int a2, int a3, int a4, int a5)
{
    void *	start = ARG_TO_POINTER(a0);
    size_t	length = a1;
    int		flags, retval;

    flags = 0;
    if(a2 & X86_MS_ASYNC) {
	flags |= MS_ASYNC;
    }
    if(a2 & X86_MS_INVALIDATE) {
	flags |= MS_INVALIDATE;
    }
    if(a2 & X86_MS_SYNC) {
	flags |= MS_SYNC;
    }

    retval = msync(start, length, flags);
   
    if(retval == -1) {
	return(-alpha_to_intel_errno(errno));
    }
    else {
	return(retval);
    }
}

