/* This is where we select the CPU execution engine we're going to use.
 * Currently there are two supported execution engines; Bochs and FX!32
 * Bochs is slower but it's written in C++ and source is available.
 * FX!32 is fast, but it's written in assembler and source is not freely 
 * available.
 */
#ifndef X86_CPU_H
#define X86_CPU_H

#ifdef USE_BOCHS_CPU
#include "bochs.h"
#define X86_CPU bx_cpu_c
#endif

#ifdef USE_FX_CPU
#include "fx_cpu.h"
#define X86_CPU fx_cpu_c
#endif


#endif /* X86_CPU_H */
