/* x86 disassembler, modified from the gnu binutils sources
 * jim paradis, january, 1998
 */

/* Print i386 instructions for GDB, the GNU debugger.
   Copyright (C) 1988, 89, 91, 93, 94, 95, 96, 1997
   Free Software Foundation, Inc.

This file is part of GDB.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/*
 * 80386 instruction printer by Pace Willisson (pace@prep.ai.mit.edu)
 * July 1988
 *  modified by John Hassey (hassey@dg-rtp.dg.com)
 */

/*
 * The main tables describing the instructions is essentially a copy
 * of the "Opcode Map" chapter (Appendix A) of the Intel 80386
 * Programmers Manual.  Usually, there is a capital letter, followed
 * by a small letter.  The capital letter tell the addressing mode,
 * and the small letter tells about the operand size.  Refer to 
 * the Intel manual for details.
 */

/* Interface between the opcode library and its callers.
   Written by Cygnus Support, 1993.

   The opcode library (libopcodes.a) provides instruction decoders for
   a large variety of instruction sets, callable with an identical
   interface, for making instruction-processing programs more independent
   of the instruction set being processed.  */


#define DIS_ASM_H

/* This is part of the iostream/stdio library, providing -*- C -*- I/O.
   Define ANSI C stdio on top of C++ iostreams.
   Copyright (C) 1991, 1994, 1995, 1996, 1997 Free Software Foundation, Inc.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.


This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 *	ISO C Standard: 4.9 INPUT/OUTPUT	<stdio.h>
 */


#define _STDIO_H
#define _STDIO_USES_IOSTREAM

/*
Copyright (C) 1991, 1992, 1993, 1994, 1995 Free Software Foundation

This file is part of the GNU IO Library.  This library is free
software; you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option)
any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this library; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

As a special exception, if you link this library with files
compiled with a GNU compiler to produce an executable, this does not cause
the resulting executable to be covered by the GNU General Public License.
This exception does not however invalidate any other reasons why
the executable file might be covered by the GNU General Public License. */

/* This is part of the iostream library.  Written by Per Bothner. */


#define _IO_STDIO_H
/* Copyright (C) 1991, 92, 93, 95, 96, 97 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */



#define	_FEATURES_H	1

/* These are defined by the user (or the compiler)
   to specify the desired environment:

   __STRICT_ANSI__	ISO Standard C.
   _POSIX_SOURCE	IEEE Std 1003.1.
   _POSIX_C_SOURCE	If ==1, like _POSIX_SOURCE; if >=2 add IEEE Std 1003.2;
			if >=199309L, add IEEE Std 1003.1b-1993
   _XOPEN_SOURCE	Includes POSIX and XPG things.
   _XOPEN_SOURCE_EXTENDED XPG things and X/Open Unix extensions.
   _BSD_SOURCE		ISO C, POSIX, and 4.3BSD things.
   _SVID_SOURCE		ISO C, POSIX, and SVID things.
   _GNU_SOURCE		All of the above, plus GNU extensions.
   _REENTRANT		Select additionally reentrant object.
   _THREAD_SAFE		Same as _REENTRANT, often used by other systems.

   The `-ansi' switch to the GNU C compiler defines __STRICT_ANSI__.
   If none of these are defined, the default is all but _GNU_SOURCE.
   If more than one of these are defined, they accumulate.
   For example __STRICT_ANSI__, _POSIX_SOURCE and _POSIX_C_SOURCE
   together give you ISO C, 1003.1, and 1003.2, but nothing else.

   These are defined by this file and are used by the
   header files to decide what to declare or define:

   __USE_POSIX		Define IEEE Std 1003.1 things.
   __USE_POSIX2		Define IEEE Std 1003.2 things.
   __USE_POSIX199309	Define IEEE Std 1003.1b things.
   __USE_XOPEN		Define XPG things.
   __USE_XOPEN_EXTENDED	Define X/Open Unix things.
   __USE_BSD		Define 4.3BSD things.
   __USE_SVID		Define SVID things.
   __USE_MISC		Define things common to BSD and System V Unix.
   __USE_GNU		Define GNU extensions.
   __USE_REENTRANT	Define reentrant/thread-safe *_r functions.
   __FAVOR_BSD		Favor 4.3BSD things in cases of conflict.

   The macros `__GNU_LIBRARY__', `__GLIBC__', and `__GLIBC_MINOR__' are
   defined by this file unconditionally.  `__GNU_LIBRARY__' is provided
   only for compatibility.  All new code should use the other symbols
   to test for features.

   All macros listed above as possibly being defined by this file are
   explicitly undefined if they are not explicitly defined.
   Feature-test macros that are not defined by the user or compiler
   but are implied by the other feature-test macros defined (or by the
   lack of any definitions) are defined by the file.  */


/* Undefine everything, so we get a clean slate.  */













/* Suppress kernel-name space pollution unless user expressedly asks
   for it.  */

#define __KERNEL_STRICT_NAMES


/* Always use ISO C things.  */
#define	__USE_ANSI	1


/* If _BSD_SOURCE was defined by the user, favor BSD over POSIX.  */


/* If _GNU_SOURCE was defined by the user, turn on all the other features.  */


#define	_POSIX_SOURCE	1

#define	_POSIX_C_SOURCE	199309L

#define	_XOPEN_SOURCE	1

#define	_XOPEN_SOURCE_EXTENDED	1

#define	_BSD_SOURCE	1

#define	_SVID_SOURCE	1


/* If nothing (other than _GNU_SOURCE) is defined,
   define _BSD_SOURCE and _SVID_SOURCE.  */


/* If none of the ANSI/POSIX macros are defined, use POSIX.1 and POSIX.2
   (and IEEE Std 1003.1b-1993 unless _XOPEN_SOURCE is defined).  */



#define	__USE_POSIX	1



#define	__USE_POSIX2	1



#define	__USE_POSIX199309	1



#define	__USE_XOPEN	1

#define	__USE_XOPEN_EXTENDED	1




#define	__USE_MISC	1



#define	__USE_BSD	1



#define	__USE_SVID	1



#define	__USE_GNU	1





/* This macro indicates that the installed library is the GNU C Library.
   For historic reasons the value now is 6 and this will stay from now
   on.  The use of this variable is deprecated.  Use __GLIBC__ and
   __GLIBC_MINOR__ now (see below) when you want to test for a specific
   GNU C library version and use the values in <gnu/lib-names.h> to get
   the sonames of the shared libraries.  */

#define __GNU_LIBRARY__ 6

/* Major and minor version number of the GNU C library package.  Use
   these macros to test for features in specific releases.  */
#define	__GLIBC__	2
#define	__GLIBC_MINOR__	0





/* This is here only because every header file already includes this one.  */

/* Copyright (C) 1992, 93, 94, 95, 96 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */



#define	_SYS_CDEFS_H	1
/* Copyright (C) 1991, 92, 93, 95, 96, 97 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */




/* Some user header file might have defined this before.  */




#define	__P(args)	args	
#define	__DOTS		, ...



/* For these things, GCC behaves the ANSI way normally,
   and the non-ANSI way under -traditional.  */



#define	__CONCAT(x,y)	x ## y
#define	__STRING(x)	#x

/* This is not a typedef so `const __ptr_t' does the right thing.  */
#define __ptr_t void *
#define __long_double_t  long double




/* C++ needs to know that types and declarations are C, not C++.  */

#define	__BEGIN_DECLS
#define	__END_DECLS


/* GCC2 has various useful declarations that can be made with the
   `__attribute__' syntax.  All of the ways we use this do fine if
   they are omitted for compilers that don't understand it.  */






/* This is here only because every header file already includes this one.  */

/* Get the definitions of all the appropriate `__stub_FUNCTION' symbols.
   <gnu/stubs.h> contains `#define __stub_FUNCTION' when FUNCTION is a stub
   which will always return failure (and set errno to ENOSYS).

   We avoid including <gnu/stubs.h> when compiling the C library itself to
   avoid a dependency loop.  stubs.h depends on every object file.  If
   this #include were done for the library source code, then every object
   file would depend on stubs.h.  */

/* This file is automatically generated.
   It defines a symbol `__stub_FUNCTION' for each function
   in the C library which is a stub, meaning it will fail
   every time called, usually setting errno to ENOSYS.  */
#define __stub_chflags
#define __stub_fchflags
#define __stub_fexecve
#define __stub_gtty
#define __stub_lchown
#define __stub_madvise
#define __stub_revoke
#define __stub_setlogin
#define __stub_sigaltstack
#define __stub_sigstack
#define __stub_sstk
#define __stub_stty






/* This file is needed by libio to define various configuration parameters.
   These are always the same in the GNU C library.  */


#define _G_config_h 1

/* Define types for libio in terms of the standard internal type names.  */

/* Copyright (C) 1991, 92, 94, 95, 96, 97 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */


#define	_GNU_TYPES_H	1



/* Convenience types.  */
typedef unsigned char __u_char;
typedef unsigned short __u_short;
typedef unsigned int __u_int;
typedef unsigned long __u_long;

typedef unsigned long long int __u_quad_t;
typedef long long int __quad_t;

typedef __quad_t *__qaddr_t;

typedef __u_long __dev_t;		/* Type of device numbers.  */
typedef __u_int __uid_t;		/* Type of user identifications.  */
typedef __u_int __gid_t;		/* Type of group identifications.  */
typedef __u_int __ino_t;		/* Type of file serial numbers.  */
typedef __u_int __mode_t;		/* Type of file attribute bitmasks.  */
typedef __u_int __nlink_t; 		/* Type of file link counts.  */
typedef long int __off_t;		/* Type of file sizes and offsets.  */
typedef __quad_t __loff_t;		/* Type of file sizes and offsets.  */
typedef int __pid_t;			/* Type of process identifications.  */
typedef long int __ssize_t;		/* Type of a byte count, or error.  */

typedef struct
  {
    int __val[2];
  } __fsid_t;				/* Type of file system IDs.  */

/* Everythin' else.  */
typedef int __daddr_t;			/* The type of a disk address.  */
typedef char *__caddr_t;
typedef long int __time_t;
typedef long int __swblk_t;		/* Type of a swap block maybe?  */

typedef long int __clock_t;

/* One element in the file descriptor mask array.  */
typedef unsigned long int __fd_mask;

/* Due to incaution, we may have gotten these from a kernel header file.  */




/* Number of descriptors that can fit in an `fd_set'.  */
#define __FD_SETSIZE	1024

/* It's easier to assume 8-bit bytes than to get CHAR_BIT.  */
#define __NFDBITS	(8 * sizeof (__fd_mask))
#define	__FDELT(d)	((d) / __NFDBITS)
#define	__FDMASK(d)	(1 << ((d) % __NFDBITS))

/* fd_set for select and pselect.  */
typedef struct
  {
    /* XPG4.2 requires this member name.  */
    __fd_mask fds_bits[1024  / (8 * sizeof (__fd_mask)) ];
  } __fd_set;


typedef int __key_t;



#define __need_size_t
#define __need_wint_t





/* Any one of these symbols __need_* means that GNU libc
   wants us just to define one data type.  So don't define
   the symbols that indicate this file's entire job has been done.  */



/* This avoids lossage on SunOS but only if stdtypes.h comes first.
   There's no way to win with the other order!  Sun lossage.  */

/* On 4.3bsd-net2, make sure ansi.h is included, so we have
   one less case to deal with in the following.  */


/* In 4.3bsd-net2, machine/ansi.h defines these symbols, which are
   defined if the corresponding type is *not* defined.
   FreeBSD-2.1 defines _MACHINE_ANSI_H_ instead of _ANSI_H_ */


/* Sequent's header files use _PTRDIFF_T_ in some conflicting way.
   Just ignore it.  */


/* On VxWorks, <type/vxTypesBase.h> may have defined macros like
   _TYPE_size_t which will typedef size_t.  fixincludes patched the
   vxTypesBase.h so that this macro is only defined if _GCC_SIZE_T is
   not defined, and so that defining this macro defines _GCC_SIZE_T.
   If we find that the macros are still defined at this point, we must
   invoke them so that the type is defined as expected.  */




/* In case nobody has defined these types, but we aren't running under
   GCC 2.00, make sure that __PTRDIFF_TYPE__, __SIZE__TYPE__, and
   __WCHAR_TYPE__ have reasonable values.  This can happen if the
   parts of GCC is compiled by an older compiler, that actually
   include gstddef.h, such as collect2.  */

/* Signed type of difference of two pointers.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */


/* Unsigned type of `sizeof' something.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */














#define _SIZE_T
#define _SYS_SIZE_T_H
#define _T_SIZE_
#define _T_SIZE
#define __SIZE_T
#define _SIZE_T_
#define _BSD_SIZE_T_
#define _SIZE_T_DEFINED_
#define _SIZE_T_DEFINED
#define ___int_size_t_h
#define _GCC_SIZE_T
#define _SIZET_
#define __size_t


typedef long unsigned int size_t;


















/* Wide character type.
   Locale-writers should change this as necessary to
   be big enough to hold unique values not between 0 and 127,
   and not (wchar_t) -1, for each defined multibyte character.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */




#define _WINT_T


#define __WINT_TYPE__ unsigned int

typedef unsigned int  wint_t;




/*  In 4.3bsd-net2, leave these undefined to indicate that size_t, etc.
    are already defined.  */




/* A null pointer constant.  */












#define _G_size_t	size_t
#define _G_fpos_t	__off_t
#define _G_ssize_t	__ssize_t
#define _G_off_t	__off_t
#define	_G_pid_t	__pid_t
#define	_G_uid_t	__uid_t
#define _G_wint_t	wint_t

typedef int _G_int16_t __attribute__ ((__mode__ (__HI__)));
typedef int _G_int32_t __attribute__ ((__mode__ (__SI__)));
typedef unsigned int _G_uint16_t __attribute__ ((__mode__ (__HI__)));
typedef unsigned int _G_uint32_t __attribute__ ((__mode__ (__SI__)));

#define _G_HAVE_BOOL 1


/* These library features are always available in the GNU C library.  */
#define _G_HAVE_ATEXIT 1
#define _G_HAVE_SYS_CDEFS 1
#define _G_HAVE_SYS_WAIT 1
#define _G_NEED_STDARG_H 1
#define _G_va_list __gnuc_va_list

#define _G_HAVE_PRINTF_FP 1
#define _G_HAVE_MMAP 1
#define _G_HAVE_LONG_DOUBLE_IO 1

/* This is defined by <bits/stat.h> if `st_blksize' exists.  */
#define _G_HAVE_ST_BLKSIZE defined (_STATBUF_ST_BLKSIZE)

#define _G_BUFSIZ 8192

/* These are the vtbl details for ELF.  */
#define _G_NAMES_HAVE_UNDERSCORE 0
#define _G_VTABLE_LABEL_HAS_LENGTH 1
#define _G_USING_THUNKS
#define _G_VTABLE_LABEL_PREFIX "__vt_"
#define _G_VTABLE_LABEL_PREFIX_ID __vt_



#define _G_ARGS(ARGLIST) ARGLIST




#define _IO_pos_t _G_fpos_t 
#define _IO_fpos_t _G_fpos_t
#define _IO_size_t _G_size_t
#define _IO_ssize_t _G_ssize_t
#define _IO_off_t _G_off_t
#define _IO_pid_t _G_pid_t
#define _IO_uid_t _G_uid_t
#define _IO_HAVE_SYS_WAIT _G_HAVE_SYS_WAIT
#define _IO_HAVE_ST_BLKSIZE _G_HAVE_ST_BLKSIZE
#define _IO_BUFSIZ _G_BUFSIZ
/* #define _IO_va_list _G_va_list */


/* This define avoids name pollution if we're using GNU stdarg.h */
#define __need___va_list
/* stdarg.h for GNU.
   Note that the type used in va_arg is supposed to match the
   actual type **after default promotions**.
   Thus, va_arg (..., short) is not valid.  */














/* GNU C varargs and stdargs support for the DEC Alpha.  */

/* Note:  We must use the name __builtin_savregs.  GCC attaches special
   significance to that name.  In particular, regardless of where in a
   function __builtin_saveregs is called, GCC moves the call up to the
   very start of the function.  */

/* Define __gnuc_va_list.  */


#define __GNUC_VA_LIST

typedef struct {
  char *__base;			/* Pointer to first integer register. */
  int __offset;			/* Byte offset of args so far. */
} __gnuc_va_list;


/* If this is for internal libc use, don't define anything but
   __gnuc_va_list.  */



















#define _IO_va_list __gnuc_va_list





/* For backward compatibility */

#define _PARAMS(protos) __P(protos)



#define _IO_UNIFIED_JUMPTABLES 1




#define EOF (-1)




#define NULL ((void*)0)




#define _IOS_INPUT	1
#define _IOS_OUTPUT	2
#define _IOS_ATEND	4
#define _IOS_APPEND	8
#define _IOS_TRUNC	16
#define _IOS_NOCREATE	32
#define _IOS_NOREPLACE	64
#define _IOS_BIN	128

/* Magic numbers and bits for the _flags field.
   The magic numbers use the high-order bits of _flags;
   the remaining bits are available for variable flags.
   Note: The magic numbers must all be negative if stdio
   emulation is desired. */

#define _IO_MAGIC 0xFBAD0000 
#define _OLD_STDIO_MAGIC 0xFABC0000 
#define _IO_MAGIC_MASK 0xFFFF0000
#define _IO_USER_BUF 1 
#define _IO_UNBUFFERED 2
#define _IO_NO_READS 4 
#define _IO_NO_WRITES 8 
#define _IO_EOF_SEEN 0x10
#define _IO_ERR_SEEN 0x20
#define _IO_DELETE_DONT_CLOSE 0x40 
#define _IO_LINKED 0x80 
#define _IO_IN_BACKUP 0x100
#define _IO_LINE_BUF 0x200
#define _IO_TIED_PUT_GET 0x400 
#define _IO_CURRENTLY_PUTTING 0x800
#define _IO_IS_APPENDING 0x1000
#define _IO_IS_FILEBUF 0x2000
#define _IO_BAD_SEEN 0x4000

/* These are "formatting flags" matching the iostream fmtflags enum values. */
#define _IO_SKIPWS 01
#define _IO_LEFT 02
#define _IO_RIGHT 04
#define _IO_INTERNAL 010
#define _IO_DEC 020
#define _IO_OCT 040
#define _IO_HEX 0100
#define _IO_SHOWBASE 0200
#define _IO_SHOWPOINT 0400
#define _IO_UPPERCASE 01000
#define _IO_SHOWPOS 02000
#define _IO_SCIENTIFIC 04000
#define _IO_FIXED 010000
#define _IO_UNITBUF 020000
#define _IO_STDIO 040000
#define _IO_DONT_CLOSE 0100000
#define _IO_BOOLALPHA 0200000


struct _IO_jump_t;  struct _IO_FILE;

/* Handle lock.  */

typedef void _IO_lock_t;



/* A streammarker remembers a position in a buffer. */

struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  /* If _pos >= 0
 it points to _buf->Gbase()+_pos. FIXME comment */
  /* if _pos < 0, it points to _buf->eBptr()+_pos. FIXME comment */
  int _pos;

};

struct _IO_FILE {
  int _flags;		/* High-order word is _IO_MAGIC; rest is flags. */
#define _IO_file_flags _flags

  /* The following pointers correspond to the C++ streambuf protocol. */
  /* Note:  Tk uses the _IO_read_ptr and _IO_read_end fields directly. */
  char* _IO_read_ptr;	/* Current read pointer */
  char* _IO_read_end;	/* End of get area. */
  char* _IO_read_base;	/* Start of putback+get area. */
  char* _IO_write_base;	/* Start of put area. */
  char* _IO_write_ptr;	/* Current put pointer. */
  char* _IO_write_end;	/* End of put area. */
  char* _IO_buf_base;	/* Start of reserve area. */
  char* _IO_buf_end;	/* End of reserve area. */
  /* The following fields are used to support backing up and undo. */
  char *_IO_save_base; /* Pointer to start of non-current get area. */
  char *_IO_backup_base;  /* Pointer to first valid character of backup area */
  char *_IO_save_end; /* Pointer to end of non-current get area. */

  struct _IO_marker *_markers;

  struct _IO_FILE *_chain;

  int _fileno;
  int _blksize;
  __off_t   _offset;

#define __HAVE_COLUMN 
  /* 1+column number of pbase(); 0 is unknown. */
  unsigned short _cur_column;
  char _unused;
  char _shortbuf[1];

  /*  char* _save_gptr;  char* _save_egptr; */

  _IO_lock_t *_lock;
};


typedef struct _IO_FILE _IO_FILE;


struct _IO_FILE_plus;
extern struct _IO_FILE_plus _IO_stdin_, _IO_stdout_, _IO_stderr_;
#define _IO_stdin ((_IO_FILE*)(&_IO_stdin_))
#define _IO_stdout ((_IO_FILE*)(&_IO_stdout_))
#define _IO_stderr ((_IO_FILE*)(&_IO_stderr_))


/* Define the user-visible type, with user-friendly member names.  */
typedef struct
{
  __ssize_t   (*read)  (struct _IO_FILE *, void *, __ssize_t  )  ;
  __ssize_t   (*write)  (struct _IO_FILE *, const void *, __ssize_t  )  ;
  __off_t   (*seek)  (struct _IO_FILE *, __off_t  , int)  ;
  int (*close)  (struct _IO_FILE *)  ;
} _IO_cookie_io_functions_t;

/* Special file type for fopencookie function.  */
struct _IO_cookie_file {
  struct _IO_FILE file;
  const void *vtable;
  void *cookie;
  _IO_cookie_io_functions_t io_functions;
};




extern int __underflow  (_IO_FILE*)  ;
extern int __uflow  (_IO_FILE*)  ;
extern int __overflow  (_IO_FILE*, int)  ;

#define _IO_getc_unlocked(_fp) ((_fp)->_IO_read_ptr >= (_fp)->_IO_read_end ? __uflow(_fp) : *(unsigned char*)(_fp)->_IO_read_ptr++)
#define _IO_peekc_unlocked(_fp) ((_fp)->_IO_read_ptr >= (_fp)->_IO_read_end && __underflow(_fp) == EOF ? EOF : *(unsigned char*)(_fp)->_IO_read_ptr)

#define _IO_putc_unlocked(_ch, _fp) (((_fp)->_IO_write_ptr >= (_fp)->_IO_write_end) ? __overflow(_fp, (unsigned char)(_ch)) : (unsigned char)(*(_fp)->_IO_write_ptr++ = (_ch)))

#define _IO_feof_unlocked(__fp) (((__fp)->_flags & _IO_EOF_SEEN) != 0)
#define _IO_ferror_unlocked(__fp) (((__fp)->_flags & _IO_ERR_SEEN) != 0)

extern int _IO_getc  (_IO_FILE *__fp)  ;
extern int _IO_putc  (int __c, _IO_FILE *__fp)  ;
extern int _IO_feof  (_IO_FILE *__fp)  ;
extern int _IO_ferror  (_IO_FILE *__fp)  ;

extern int _IO_peekc_locked  (_IO_FILE *__fp)  ;

/* This one is for Emacs. */
#define _IO_PENDING_OUTPUT_COUNT(_fp)	((_fp)->_IO_write_ptr - (_fp)->_IO_write_base)

extern void _IO_flockfile  (_IO_FILE *)  ;
extern void _IO_funlockfile  (_IO_FILE *)  ;
extern int _IO_ftrylockfile  (_IO_FILE *)  ;


#define _IO_flockfile(_fp) 
#define _IO_funlockfile(_fp) 
#define _IO_ftrylockfile(_fp) 
#define _IO_cleanup_region_start(_fct, _fp) 
#define _IO_cleanup_region_end(_Doit) 


/* XXX Should we allow a symbol to be defined which selects the efficient
  implementation when the user is really sure no threaded functions ever
  will be used?  */

#define _IO_getc(_fp) _IO_getc (_fp)
#define _IO_peekc(_fp) _IO_peekc_locked (_fp)
#define _IO_putc(_ch, _fp) _IO_putc (_ch, _fp)
#define _IO_feof(_fp) _IO_feof (_fp)
#define _IO_ferror(_fp) _IO_ferror (_fp)


extern int _IO_vfscanf  (_IO_FILE*, const char*, __gnuc_va_list , int*)  ;
extern int _IO_vfprintf  (_IO_FILE*, const char*, __gnuc_va_list )  ;
extern __ssize_t   _IO_padn  (_IO_FILE *, int, __ssize_t  )  ;
extern size_t   _IO_sgetn  (_IO_FILE *, void*, size_t  )  ;

extern __off_t   _IO_seekoff  (_IO_FILE*, __off_t  , int, int)  ;
extern __off_t   _IO_seekpos  (_IO_FILE*, __off_t  , int)  ;

extern void _IO_free_backup_area  (_IO_FILE*)  ;










#define BUFSIZ _IO_BUFSIZ


#define _IOFBF 0 
#define _IOLBF 1 
#define _IONBF 2 

#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2

 /* define size_t.  Crud in case <sys/types.h> has defined it. */


typedef struct _IO_FILE FILE;
typedef __off_t   fpos_t;

#define L_tmpnam 19
#define TMP_MAX 238328

#define L_ctermid 9
#define L_cuserid 9

#define FOPEN_MAX 256
#define FILENAME_MAX 4095



/* Default path prefix for `tempnam' and `tmpnam'.  */
#define P_tmpdir      "/tmp"


/* For use by debuggers. These are linked in if printf or fprintf are used. */
extern FILE *stdin, *stdout, *stderr; /* TODO */

#define stdin _IO_stdin
#define stdout _IO_stdout
#define stderr _IO_stderr





extern void clearerr  (FILE*)  ;
extern int fclose  (FILE*)  ;
extern int feof  (FILE*)  ;
extern int ferror  (FILE*)  ;
extern int fflush  (FILE*)  ;
extern int fgetc  (FILE *)  ;
extern int fgetpos  (FILE* fp, fpos_t *pos)  ;
extern char* fgets  (char*, int, FILE*)  ;
extern FILE* fopen  (__const char*, __const char*)  ;
extern FILE* fopencookie  (void *cookie, __const char *mode,
			       _IO_cookie_io_functions_t io_functions)  ;
extern int fprintf  (FILE*, __const char* format, ...)  ;
extern int fputc  (int, FILE*)  ;
extern int fputs  (__const char *str, FILE *fp)  ;
extern size_t fread  (void*, size_t, size_t, FILE*)  ;
extern FILE* freopen  (__const char*, __const char*, FILE*)  ;
extern int fscanf  (FILE *fp, __const char* format, ...)  ;
extern int fseek  (FILE* fp, long int offset, int whence)  ;
extern int fsetpos  (FILE* fp, __const fpos_t *pos)  ;
extern long int ftell  (FILE* fp)  ;
extern size_t fwrite  (__const void*, size_t, size_t, FILE*)  ;
extern int getc  (FILE *)  ;
extern int getchar  (void)  ;
extern char* gets  (char*)  ;
extern void perror  (__const char *)  ;
extern int printf  (__const char* format, ...)  ;
extern int putc  (int, FILE *)  ;
extern int putchar  (int)  ;
extern int puts  (__const char *str)  ;
extern int remove  (__const char*)  ;
extern int rename  (__const char* _old, __const char* _new)  ;
extern void rewind  (FILE*)  ;
extern int scanf  (__const char* format, ...)  ;
extern void setbuf  (FILE*, char*)  ;
extern void setlinebuf  (FILE*)  ;
extern void setbuffer  (FILE*, char*, int)  ;
extern int setvbuf  (FILE*, char*, int mode, size_t size)  ;
extern int sprintf  (char*, __const char* format, ...)  ;
extern int sscanf  (__const char* string, __const char* format, ...)  ;
extern FILE* tmpfile  (void)  ;
extern char* tmpnam  (char*)  ;

extern char* tmpnam_r  (char*)  ;


extern char *tempnam  (__const char *__dir, __const char *__pfx)  ;

extern char *__stdio_gen_tempname  (char *__buf, size_t bufsize,
					__const char *dir, __const char *pfx,
					int dir_search, size_t *lenptr,
					FILE **streamptr)  ;
extern int ungetc  (int c, FILE* fp)  ;
extern int vfprintf  (FILE *fp, char __const *fmt0, __gnuc_va_list )  ;
extern int vprintf  (char __const *fmt, __gnuc_va_list )  ;
extern int vsprintf  (char* string, __const char* format, __gnuc_va_list )  ;
extern void __libc_fatal  (__const char *__message)  
     __attribute__ ((__noreturn__));


extern int dprintf  (int, __const char *, ...)  ;
extern int vdprintf  (int, __const char *, __gnuc_va_list )  ;
extern int vfscanf  (FILE*, __const char *, __gnuc_va_list )  ;
extern int __vfscanf  (FILE*, __const char *, __gnuc_va_list )  ;
extern int vscanf  (__const char *, __gnuc_va_list )  ;
extern int vsscanf  (__const char *, __const char *, __gnuc_va_list )  ;
extern int __vsscanf  (__const char *, __const char *, __gnuc_va_list )  ;



extern int __fcloseall  (void)  ;
extern int fcloseall  (void)  ;

struct obstack;
extern int obstack_vprintf  (struct obstack *__obstack,
				 __const char *__fmt, __gnuc_va_list )  ;
extern int obstack_printf  (struct obstack *__obstack, __const char *__fmt,
				...)  ;



extern FILE *fdopen  (int, __const char *)  ;
extern int fileno  (FILE*)  ;
extern FILE* popen  (__const char*, __const char*)  ;
extern int pclose  (FILE*)  ;

#define L_ctermid     9
#define L_cuserid     9

/* Return the name of the controlling terminal.  */
extern char *ctermid  (char *__buf)  ;

/* Get character login name of the user.  */
extern char *cuserid  (char * __buf)  ;



extern int snprintf  (char *, size_t, __const char *, ...)  ;
extern int __snprintf  (char *, size_t, __const char *, ...)  ;
extern int vsnprintf  (char *, size_t, __const char *, __gnuc_va_list )  ;
extern int __vsnprintf  (char *, size_t, __const char *, __gnuc_va_list )  ;



extern __ssize_t   getdelim  (char **, size_t *, int, FILE*)  ;
extern __ssize_t   getline  (char **, size_t *, FILE *)  ;
extern __ssize_t   __getline  (char **, size_t *, FILE *)  ;

extern int asprintf  (char **, const char *, ...)  ;
extern int vasprintf  (char **, const char *, __gnuc_va_list )  ;

/* Open a stream that writes into a malloc'd buffer that is expanded as
   necessary.  *BUFLOC and *SIZELOC are updated with the buffer's location
   and the number of characters written on fflush or fclose.  */
extern FILE *open_memstream  (char **__bufloc, size_t *__sizeloc)  ;


extern int __underflow  (struct _IO_FILE*)  ;
extern int __overflow  (struct _IO_FILE*, int)  ;


extern int sys_nerr;
extern const char *const sys_errlist[];


extern int _sys_nerr;
extern const char *const _sys_errlist[];


/* Handle locking of streams.  */

extern void clearerr_locked  (FILE *)  ;
extern void clearerr_unlocked  (FILE *)  ;
extern int feof_locked  (FILE *)  ;
extern int feof_unlocked  (FILE *)  ;
extern int ferror_locked  (FILE*)  ;
extern int ferror_unlocked  (FILE*)  ;
extern int fileno_locked  (FILE *)  ;
extern int fileno_unlocked  (FILE *)  ;
extern int fclose_unlocked  (FILE *)  ;
extern int fflush_locked  (FILE *)  ;
extern int fflush_unlocked  (FILE *)  ;
extern size_t fread_unlocked  (void *, size_t, size_t, FILE *)  ;
extern size_t fwrite_unlocked  (const void *, size_t, size_t, FILE *)  ;

extern int fputc_locked  (int, FILE*)  ;
extern int fputc_unlocked  (int, FILE*)  ;
extern int getc_locked  (FILE *)  ;
extern int getchar_locked  (void)  ;
extern int putc_locked  (int, FILE *)  ;
extern int putchar_locked  (int)  ;


#define getc_locked(fp) _IO_getc (fp)
#define getchar_locked() _IO_getc (stdin)
#define putchar_locked(c) _IO_putc (c, stdout)




/* These are defined in POSIX.1:1996.  */
extern void flockfile  (FILE *)  ;
extern void funlockfile  (FILE *)  ;
extern int ftrylockfile  (FILE *)  ;

extern int getc_unlocked  (FILE *)  ;
extern int getchar_unlocked  (void)  ;
extern int putc_unlocked  (int, FILE *)  ;
extern int putchar_unlocked  (int)  ;


#define getc_unlocked(fp) _IO_getc_unlocked (fp)
#define getchar_unlocked() _IO_getc_unlocked (stdin)
#define putc_unlocked(c, fp) _IO_putc_unlocked ((c), (fp))
#define putchar_unlocked(c) _IO_putc_unlocked ((c), stdout)



#define getc(_fp) _IO_getc (_fp)
#define putc(_ch, _fp) _IO_putc (_ch, _fp)
#define putchar(_ch) _IO_putc (_ch, stdout)
#define getchar() _IO_getc (stdin)








/* Main header file for the bfd library -- portable access to object files.
   Copyright 1990, 91, 92, 93, 94, 95, 96, 1997 Free Software Foundation, Inc.
   Contributed by Cygnus Support.

** NOTE: bfd.h and bfd-in2.h are GENERATED files.  Don't change them;
** instead, change bfd-in.h or the other BFD source files processed to
** generate these files.

This file is part of BFD, the Binary File Descriptor library.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/* bfd.h -- The only header file required by users of the bfd library 

The bfd.h file is generated from bfd-in.h and various .c files; if you
change it, your changes will probably be lost.

All the prototypes and definitions following the comment "THE FOLLOWING
IS EXTRACTED FROM THE SOURCE" are extracted from the source files for
BFD.  If you change it, someone oneday will extract it from the source
again, and your changes will be lost.  To save yourself from this bind,
change the definitions in the source in the bfd directory.  Type "make
docs" and then "make headers" in that directory, and magically this file
will change to reflect your changes.

If you don't have the tools to perform the extraction, then you are
safe from someone on your system trampling over your header files.
You should still maintain the equivalence between the source and this
file though; every change you make to the .c file should be reflected
here.  */


#define __BFD_H_SEEN__



/* ANSI and traditional C compatability macros
   Copyright 1991, 1992, 1996 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/* ANSI and traditional C compatibility macros

   ANSI C is assumed if __STDC__ is #defined.

   Macro	ANSI C definition	Traditional C definition
   -----	---- - ----------	----------- - ----------
   PTR		`void *'		`char *'
   LONG_DOUBLE	`long double'		`double'
   VOLATILE	`volatile'		`'
   SIGNED	`signed'		`'
   PTRCONST	`void *const'		`char *'
   ANSI_PROTOTYPES  1			not defined

   CONST is also defined, but is obsolete.  Just use const.

   obsolete --     DEFUN (name, arglist, args)

	Defines function NAME.

	ARGLIST lists the arguments, separated by commas and enclosed in
	parentheses.  ARGLIST becomes the argument list in traditional C.

	ARGS list the arguments with their types.  It becomes a prototype in
	ANSI C, and the type declarations in traditional C.  Arguments should
	be separated with `AND'.  For functions with a variable number of
	arguments, the last thing listed should be `DOTS'.

   obsolete --     DEFUN_VOID (name)

	Defines a function NAME, which takes no arguments.

   obsolete --     EXFUN (name, (prototype))	-- obsolete.

	Replaced by PARAMS.  Do not use; will disappear someday soon.
	Was used in external function declarations.
	In ANSI C it is `NAME PROTOTYPE' (so PROTOTYPE should be enclosed in
	parentheses).  In traditional C it is `NAME()'.
	For a function that takes no arguments, PROTOTYPE should be `(void)'.

   obsolete --     PROTO (type, name, (prototype)    -- obsolete.

	This one has also been replaced by PARAMS.  Do not use.

   PARAMS ((args))

	We could use the EXFUN macro to handle prototype declarations, but
	the name is misleading and the result is ugly.  So we just define a
	simple macro to handle the parameter lists, as in:

	      static int foo PARAMS ((int, char));

	This produces:  `static int foo();' or `static int foo (int, char);'

	EXFUN would have done it like this:

	      static int EXFUN (foo, (int, char));

	but the function is not external...and it's hard to visually parse
	the function name out of the mess.   EXFUN should be considered
	obsolete; new code should be written to use PARAMS.

   DOTS is also obsolete.

   Examples:

	extern int printf PARAMS ((const char *format, ...));
*/



#define	_ANSIDECL_H	1


/* Every source file includes this file,
   so they will all get the switch for lint.  */
/* LINTLIBRARY */



/* All known AIX compilers implement these things (but don't always
   define __STDC__).  The RISC/OS MIPS compiler defines these things
   in SVR4 mode, but does not define __STDC__.  */

#define	PTR		void *
#define	PTRCONST	void *CONST
#define	LONG_DOUBLE	long double

#define	AND		,
#define	NOARGS		void
#define	VOLATILE	volatile
#define	SIGNED		signed

#define PARAMS(paramlist)		paramlist
#define ANSI_PROTOTYPES			1

#define VPARAMS(ARGS)			ARGS
#define VA_START(va_list,var)		va_start(va_list,var)

/* These are obsolete.  Do not use.  */
#define CONST				const
#define DOTS				, ...
#define PROTO(type, name, arglist)	type name arglist
#define EXFUN(name, proto)		name proto
#define DEFUN(name, arglist, args)	name(args)
#define DEFUN_VOID(name)		name(void)






/* These two lines get substitutions done by commands in Makefile.in.  */
#define BFD_VERSION  "2.8.1"
#define BFD_ARCH_SIZE 64
#define BFD_HOST_64BIT_LONG 1



#define BFD64




#define INLINE __inline__



/* forward declaration */
typedef struct _bfd bfd;

/* To squelch erroneous compiler warnings ("illegal pointer
   combination") from the SVR3 compiler, we would like to typedef
   boolean to int (it doesn't like functions which return boolean.
   Making sure they are never implicitly declared to return int
   doesn't seem to help).  But this file is not configured based on
   the host.  */
/* General rules: functions which are boolean return true on success
   and false on failure (unless they're a predicate).   -- bfd.doc */
/* I'm sure this is going to break something and someone is going to
   force me to change it. */
/* typedef enum boolean {false, true} boolean; */
/* Yup, SVR4 has a "typedef enum boolean" in <sys/types.h>  -fnf */
/* It gets worse if the host also defines a true/false enum... -sts */
/* And even worse if your compiler has built-in boolean types... -law */



typedef enum bfd_boolean {false, true} boolean;
#define BFD_TRUE_FALSE


/* A pointer to a position in a file.  */
/* FIXME:  This should be using off_t from <sys/types.h>.
   For now, try to avoid breaking stuff by not including <sys/types.h> here.
   This will break on systems with 64-bit file offsets (e.g. 4.4BSD).
   Probably the best long-term answer is to avoid using file_ptr AND off_t 
   in this header file, and to handle this in the BFD implementation
   rather than in its interface.  */
/* typedef off_t	file_ptr; */
typedef long int file_ptr;

/* Support for different sizes of target format ints and addresses.
   If the type `long' is at least 64 bits, BFD_HOST_64BIT_LONG will be
   set to 1 above.  Otherwise, if gcc is being used, this code will
   use gcc's "long long" type.  Otherwise, BFD_HOST_64_BIT must be
   defined above.  */





#define BFD_HOST_64_BIT long
#define BFD_HOST_U_64_BIT unsigned long



typedef unsigned long  bfd_vma;
typedef long  bfd_signed_vma;
typedef unsigned long  bfd_size_type;
typedef unsigned long  symvalue;



#define sprintf_vma(s,x) sprintf (s, "%016lx", x)
#define fprintf_vma(f,x) fprintf (f, "%016lx", x)




#define printf_vma(x) fprintf_vma(stdout,x)

typedef unsigned int flagword;	/* 32 bits of flags */
typedef unsigned char bfd_byte;

/** File formats */

typedef enum bfd_format {
	      bfd_unknown = 0,	/* file format is unknown */
	      bfd_object,	/* linker/assember/compiler output */
	      bfd_archive,	/* object archive file */
	      bfd_core,		/* core dump */
	      bfd_type_end}	/* marks the end; don't use it! */
         bfd_format;

/* Values that may appear in the flags field of a BFD.  These also
   appear in the object_flags field of the bfd_target structure, where
   they indicate the set of flags used by that backend (not all flags
   are meaningful for all object file formats) (FIXME: at the moment,
   the object_flags values have mostly just been copied from backend
   to another, and are not necessarily correct).  */

/* No flags.  */
#define BFD_NO_FLAGS   	0x00

/* BFD contains relocation entries.  */
#define HAS_RELOC   	0x01

/* BFD is directly executable.  */
#define EXEC_P      	0x02

/* BFD has line number information (basically used for F_LNNO in a
   COFF header).  */
#define HAS_LINENO  	0x04

/* BFD has debugging information.  */
#define HAS_DEBUG   	0x08

/* BFD has symbols.  */
#define HAS_SYMS    	0x10

/* BFD has local symbols (basically used for F_LSYMS in a COFF
   header).  */
#define HAS_LOCALS  	0x20

/* BFD is a dynamic object.  */
#define DYNAMIC     	0x40

/* Text section is write protected (if D_PAGED is not set, this is
   like an a.out NMAGIC file) (the linker sets this by default, but
   clears it for -r or -N).  */
#define WP_TEXT     	0x80

/* BFD is dynamically paged (this is like an a.out ZMAGIC file) (the
   linker sets this by default, but clears it for -r or -n or -N).  */
#define D_PAGED     	0x100

/* BFD is relaxable (this means that bfd_relax_section may be able to
   do something) (sometimes bfd_relax_section can do something even if
   this is not set).  */
#define BFD_IS_RELAXABLE 0x200

/* This may be set before writing out a BFD to request using a
   traditional format.  For example, this is used to request that when
   writing out an a.out object the symbols not be hashed to eliminate
   duplicates.  */
#define BFD_TRADITIONAL_FORMAT 0x400

/* This flag indicates that the BFD contents are actually cached in
   memory.  If this is set, iostream points to a bfd_in_memory struct.  */
#define BFD_IN_MEMORY 0x800

/* symbols and relocation */

/* A count of carsyms (canonical archive symbols).  */
typedef unsigned long symindex;

/* How to perform a relocation.  */
typedef const struct reloc_howto_struct reloc_howto_type;

#define BFD_NO_MORE_SYMBOLS ((symindex) ~0)

/* General purpose part of a symbol X;
   target specific parts are in libcoff.h, libaout.h, etc.  */

#define bfd_get_section(x) ((x)->section)
#define bfd_get_output_section(x) ((x)->section->output_section)
#define bfd_set_section(x,y) ((x)->section) = (y)
#define bfd_asymbol_base(x) ((x)->section->vma)
#define bfd_asymbol_value(x) (bfd_asymbol_base(x) + (x)->value)
#define bfd_asymbol_name(x) ((x)->name)
/*Perhaps future: #define bfd_asymbol_bfd(x) ((x)->section->owner)*/
#define bfd_asymbol_bfd(x) ((x)->the_bfd)
#define bfd_asymbol_flavour(x) (bfd_asymbol_bfd(x)->xvec->flavour)

/* A canonical archive symbol.  */
/* This is a type pun with struct ranlib on purpose! */
typedef struct carsym {
  char *name;
  file_ptr file_offset;		/* look here to find the file */
} carsym;			/* to make these you call a carsymogen */

  
/* Used in generating armaps (archive tables of contents).
   Perhaps just a forward definition would do? */
struct orl {			/* output ranlib */
  char **name;			/* symbol name */ 
  file_ptr pos;			/* bfd* or file position */
  int namidx;			/* index into string table */
};


/* Linenumber stuff */
typedef struct lineno_cache_entry {
  unsigned int line_number;	/* Linenumber from start of function*/  
  union {
    struct symbol_cache_entry *sym; /* Function name */
    unsigned long offset;	/* Offset into section */
  } u;
} alent;

/* object and core file sections */

#define	align_power(addr, align)	( ((addr) + ((1<<(align))-1)) & (-1 << (align)))

typedef struct sec *sec_ptr;

#define bfd_get_section_name(bfd, ptr) ((ptr)->name + 0)
#define bfd_get_section_vma(bfd, ptr) ((ptr)->vma + 0)
#define bfd_get_section_alignment(bfd, ptr) ((ptr)->alignment_power + 0)
#define bfd_section_name(bfd, ptr) ((ptr)->name)
#define bfd_section_size(bfd, ptr) (bfd_get_section_size_before_reloc(ptr))
#define bfd_section_vma(bfd, ptr) ((ptr)->vma)
#define bfd_section_alignment(bfd, ptr) ((ptr)->alignment_power)
#define bfd_get_section_flags(bfd, ptr) ((ptr)->flags + 0)
#define bfd_get_section_userdata(bfd, ptr) ((ptr)->userdata)

#define bfd_is_com_section(ptr) (((ptr)->flags & SEC_IS_COMMON) != 0)

#define bfd_set_section_vma(bfd, ptr, val) (((ptr)->vma = (ptr)->lma= (val)), ((ptr)->user_set_vma = (boolean)true), true)
#define bfd_set_section_alignment(bfd, ptr, val) (((ptr)->alignment_power = (val)),true)
#define bfd_set_section_userdata(bfd, ptr, val) (((ptr)->userdata = (val)),true)

typedef struct stat stat_type; 

typedef enum bfd_print_symbol
{ 
  bfd_print_symbol_name,
  bfd_print_symbol_more,
  bfd_print_symbol_all
} bfd_print_symbol_type;
    
/* Information about a symbol that nm needs.  */

typedef struct _symbol_info
{
  symvalue value;
  char type;
  const  char *name;            /* Symbol name.  */
  unsigned char stab_type;     /* Stab type.  */
  char stab_other;             /* Stab other. */
  short stab_desc;             /* Stab desc.  */
  const  char *stab_name;       /* String for stab type.  */
} symbol_info;

/* Get the name of a stabs type code.  */

extern const char *bfd_get_stab_name  (int)  ;

/* Hash table routines.  There is no way to free up a hash table.  */

/* An element in the hash table.  Most uses will actually use a larger
   structure, and an instance of this will be the first field.  */

struct bfd_hash_entry
{
  /* Next entry for this hash code.  */
  struct bfd_hash_entry *next;
  /* String being hashed.  */
  const char *string;
  /* Hash code.  This is the full hash code, not the index into the
     table.  */
  unsigned long hash;
};

/* A hash table.  */

struct bfd_hash_table
{
  /* The hash array.  */
  struct bfd_hash_entry **table;
  /* The number of slots in the hash table.  */
  unsigned int size;
  /* A function used to create new elements in the hash table.  The
     first entry is itself a pointer to an element.  When this
     function is first invoked, this pointer will be NULL.  However,
     having the pointer permits a hierarchy of method functions to be
     built each of which calls the function in the superclass.  Thus
     each function should be written to allocate a new block of memory
     only if the argument is NULL.  */
  struct bfd_hash_entry *(*newfunc)  (struct bfd_hash_entry *,
					     struct bfd_hash_table *,
					     const char *)  ;
   /* An objalloc for this hash table.  This is a struct objalloc *,
     but we use PTR to avoid requiring the inclusion of objalloc.h.  */
  void *  memory;
};

/* Initialize a hash table.  */
extern boolean bfd_hash_table_init
   (struct bfd_hash_table *,
	   struct bfd_hash_entry *(*) (struct bfd_hash_entry *,
				       struct bfd_hash_table *,
				       const char *))  ;

/* Initialize a hash table specifying a size.  */
extern boolean bfd_hash_table_init_n
   (struct bfd_hash_table *,
	   struct bfd_hash_entry *(*) (struct bfd_hash_entry *,
				       struct bfd_hash_table *,
				       const char *),
	   unsigned int size)  ;

/* Free up a hash table.  */
extern void bfd_hash_table_free  (struct bfd_hash_table *)  ;

/* Look up a string in a hash table.  If CREATE is true, a new entry
   will be created for this string if one does not already exist.  The
   COPY argument must be true if this routine should copy the string
   into newly allocated memory when adding an entry.  */
extern struct bfd_hash_entry *bfd_hash_lookup
   (struct bfd_hash_table *, const char *, boolean create,
	   boolean copy)  ;

/* Replace an entry in a hash table.  */
extern void bfd_hash_replace
   (struct bfd_hash_table *, struct bfd_hash_entry *old,
	   struct bfd_hash_entry *nw)  ;

/* Base method for creating a hash table entry.  */
extern struct bfd_hash_entry *bfd_hash_newfunc
   (struct bfd_hash_entry *, struct bfd_hash_table *,
	   const char *)  ;

/* Grab some space for a hash table entry.  */
extern void *  bfd_hash_allocate  (struct bfd_hash_table *,
				      unsigned int)  ;

/* Traverse a hash table in a random order, calling a function on each
   element.  If the function returns false, the traversal stops.  The
   INFO argument is passed to the function.  */
extern void bfd_hash_traverse  (struct bfd_hash_table *,
				       boolean (*) (struct bfd_hash_entry *,
						    void * ),
				       void *  info)  ;

/* Semi-portable string concatenation in cpp.
   The CAT4 hack is to avoid a problem with some strict ANSI C preprocessors.
   The problem is, "32_" is not a valid preprocessing token, and we don't
   want extra underscores (e.g., "nlm_32_").  The XCAT2 macro will cause the
   inner CAT macros to be evaluated first, producing still-valid pp-tokens.
   Then the final concatenation can be done.  (Sigh.)  */



#define CAT(a,b) a##b
#define CAT3(a,b,c) a##b##c
#define XCAT2(a,b)	CAT(a,b)
#define CAT4(a,b,c,d)	XCAT2(CAT(a,b),CAT(c,d))




#define COFF_SWAP_TABLE (PTR) &bfd_coff_std_swap_table

/* User program access to BFD facilities */

/* Direct I/O routines, for programs which know more about the object
   file than BFD does.  Use higher level routines if possible.  */

extern bfd_size_type bfd_read
   (void * , bfd_size_type size, bfd_size_type nitems, bfd *abfd)  ;
extern bfd_size_type bfd_write
   (const void * , bfd_size_type size, bfd_size_type nitems, bfd *abfd)  ;
extern int bfd_seek  (bfd *abfd, file_ptr fp, int direction)  ;
extern long bfd_tell  (bfd *abfd)  ;
extern int bfd_flush  (bfd *abfd)  ;
extern int bfd_stat  (bfd *abfd, struct stat *)  ;


/* Cast from const char * to char * so that caller can assign to
   a char * without a warning.  */
#define bfd_get_filename(abfd) ((char *) (abfd)->filename)
#define bfd_get_cacheable(abfd) ((abfd)->cacheable)
#define bfd_get_format(abfd) ((abfd)->format)
#define bfd_get_target(abfd) ((abfd)->xvec->name)
#define bfd_get_flavour(abfd) ((abfd)->xvec->flavour)
#define bfd_big_endian(abfd) ((abfd)->xvec->byteorder == BFD_ENDIAN_BIG)
#define bfd_little_endian(abfd) ((abfd)->xvec->byteorder == BFD_ENDIAN_LITTLE)
#define bfd_header_big_endian(abfd) ((abfd)->xvec->header_byteorder == BFD_ENDIAN_BIG)
#define bfd_header_little_endian(abfd) ((abfd)->xvec->header_byteorder == BFD_ENDIAN_LITTLE)
#define bfd_get_file_flags(abfd) ((abfd)->flags)
#define bfd_applicable_file_flags(abfd) ((abfd)->xvec->object_flags)
#define bfd_applicable_section_flags(abfd) ((abfd)->xvec->section_flags)
#define bfd_my_archive(abfd) ((abfd)->my_archive)
#define bfd_has_map(abfd) ((abfd)->has_armap)

#define bfd_valid_reloc_types(abfd) ((abfd)->xvec->valid_reloc_types)
#define bfd_usrdata(abfd) ((abfd)->usrdata)

#define bfd_get_start_address(abfd) ((abfd)->start_address)
#define bfd_get_symcount(abfd) ((abfd)->symcount)
#define bfd_get_outsymbols(abfd) ((abfd)->outsymbols)
#define bfd_count_sections(abfd) ((abfd)->section_count)

#define bfd_get_symbol_leading_char(abfd) ((abfd)->xvec->symbol_leading_char)

#define bfd_set_cacheable(abfd,bool) (((abfd)->cacheable = (boolean)(bool)), true)

extern boolean bfd_record_phdr
   (bfd *, unsigned long, boolean, flagword, boolean, bfd_vma,
	   boolean, boolean, unsigned int, struct sec **)  ;

/* Byte swapping routines.  */

bfd_vma		bfd_getb64	    (const unsigned char *)  ;
bfd_vma 	bfd_getl64	    (const unsigned char *)  ;
bfd_signed_vma	bfd_getb_signed_64  (const unsigned char *)  ;
bfd_signed_vma	bfd_getl_signed_64  (const unsigned char *)  ;
bfd_vma		bfd_getb32	    (const unsigned char *)  ;
bfd_vma		bfd_getl32	    (const unsigned char *)  ;
bfd_signed_vma	bfd_getb_signed_32  (const unsigned char *)  ;
bfd_signed_vma	bfd_getl_signed_32  (const unsigned char *)  ;
bfd_vma		bfd_getb16	    (const unsigned char *)  ;
bfd_vma		bfd_getl16	    (const unsigned char *)  ;
bfd_signed_vma	bfd_getb_signed_16  (const unsigned char *)  ;
bfd_signed_vma	bfd_getl_signed_16  (const unsigned char *)  ;
void		bfd_putb64	    (bfd_vma, unsigned char *)  ;
void		bfd_putl64	    (bfd_vma, unsigned char *)  ;
void		bfd_putb32	    (bfd_vma, unsigned char *)  ;
void		bfd_putl32	    (bfd_vma, unsigned char *)  ;
void		bfd_putb16	    (bfd_vma, unsigned char *)  ;
void		bfd_putl16	    (bfd_vma, unsigned char *)  ;

/* Externally visible ECOFF routines.  */


struct ecoff_debug_info;
struct ecoff_debug_swap;
struct ecoff_extr;
struct symbol_cache_entry;
struct bfd_link_info;
struct bfd_link_hash_entry;
struct bfd_elf_version_tree;

extern bfd_vma bfd_ecoff_get_gp_value  (bfd * abfd)  ;
extern boolean bfd_ecoff_set_gp_value  (bfd *abfd, bfd_vma gp_value)  ;
extern boolean bfd_ecoff_set_regmasks
   (bfd *abfd, unsigned long gprmask, unsigned long fprmask,
	   unsigned long *cprmask)  ;
extern void *  bfd_ecoff_debug_init
   (bfd *output_bfd, struct ecoff_debug_info *output_debug,
	   const struct ecoff_debug_swap *output_swap,
	   struct bfd_link_info *)  ;
extern void bfd_ecoff_debug_free
   (void *  handle, bfd *output_bfd, struct ecoff_debug_info *output_debug,
	   const struct ecoff_debug_swap *output_swap,
	   struct bfd_link_info *)  ;
extern boolean bfd_ecoff_debug_accumulate
   (void *  handle, bfd *output_bfd, struct ecoff_debug_info *output_debug,
	   const struct ecoff_debug_swap *output_swap,
	   bfd *input_bfd, struct ecoff_debug_info *input_debug,
	   const struct ecoff_debug_swap *input_swap,
	   struct bfd_link_info *)  ;
extern boolean bfd_ecoff_debug_accumulate_other
   (void *  handle, bfd *output_bfd, struct ecoff_debug_info *output_debug,
	   const struct ecoff_debug_swap *output_swap, bfd *input_bfd,
	   struct bfd_link_info *)  ;
extern boolean bfd_ecoff_debug_externals
   (bfd *abfd, struct ecoff_debug_info *debug,
	   const struct ecoff_debug_swap *swap,
	   boolean relocateable,
	   boolean (*get_extr) (struct symbol_cache_entry *,
				struct ecoff_extr *),
	   void (*set_index) (struct symbol_cache_entry *,
			      bfd_size_type))  ;
extern boolean bfd_ecoff_debug_one_external
   (bfd *abfd, struct ecoff_debug_info *debug,
	   const struct ecoff_debug_swap *swap,
	   const char *name, struct ecoff_extr *esym)  ;
extern bfd_size_type bfd_ecoff_debug_size
   (bfd *abfd, struct ecoff_debug_info *debug,
	   const struct ecoff_debug_swap *swap)  ;
extern boolean bfd_ecoff_write_debug
   (bfd *abfd, struct ecoff_debug_info *debug,
	   const struct ecoff_debug_swap *swap, file_ptr where)  ;
extern boolean bfd_ecoff_write_accumulated_debug
   (void *  handle, bfd *abfd, struct ecoff_debug_info *debug,
	   const struct ecoff_debug_swap *swap,
	   struct bfd_link_info *info, file_ptr where)  ;
extern boolean bfd_mips_ecoff_create_embedded_relocs
   (bfd *, struct bfd_link_info *, struct sec *, struct sec *,
	   char **)  ;

/* Externally visible ELF routines.  */

struct bfd_link_needed_list
{
  struct bfd_link_needed_list *next;
  bfd *by;
  const char *name;
};

extern boolean bfd_elf32_record_link_assignment
   (bfd *, struct bfd_link_info *, const char *, boolean)  ;
extern boolean bfd_elf64_record_link_assignment
   (bfd *, struct bfd_link_info *, const char *, boolean)  ;
extern struct bfd_link_needed_list *bfd_elf_get_needed_list
   (bfd *, struct bfd_link_info *)  ;
extern boolean bfd_elf32_size_dynamic_sections
   (bfd *, const char *, const char *, boolean, const char *,
	   const char * const *, struct bfd_link_info *, struct sec **,
	   struct bfd_elf_version_tree *)  ;
extern boolean bfd_elf64_size_dynamic_sections
   (bfd *, const char *, const char *, boolean, const char *,
	   const char * const *, struct bfd_link_info *, struct sec **,
	   struct bfd_elf_version_tree *)  ;
extern void bfd_elf_set_dt_needed_name  (bfd *, const char *)  ;
extern const char *bfd_elf_get_dt_soname  (bfd *)  ;

/* SunOS shared library support routines for the linker.  */

extern struct bfd_link_needed_list *bfd_sunos_get_needed_list
   (bfd *, struct bfd_link_info *)  ;
extern boolean bfd_sunos_record_link_assignment
   (bfd *, struct bfd_link_info *, const char *)  ;
extern boolean bfd_sunos_size_dynamic_sections
   (bfd *, struct bfd_link_info *, struct sec **, struct sec **,
	   struct sec **)  ;

/* Linux shared library support routines for the linker.  */

extern boolean bfd_i386linux_size_dynamic_sections
   (bfd *, struct bfd_link_info *)  ;
extern boolean bfd_m68klinux_size_dynamic_sections
   (bfd *, struct bfd_link_info *)  ;
extern boolean bfd_sparclinux_size_dynamic_sections
   (bfd *, struct bfd_link_info *)  ;

/* mmap hacks */

struct _bfd_window_internal;
typedef struct _bfd_window_internal bfd_window_internal;

typedef struct _bfd_window {
  /* What the user asked for.  */
  void *  data;
  bfd_size_type size;
  /* The actual window used by BFD.  Small user-requested read-only
     regions sharing a page may share a single window into the object
     file.  Read-write versions shouldn't until I've fixed things to
     keep track of which portions have been claimed by the
     application; don't want to give the same region back when the
     application wants two writable copies!  */
  struct _bfd_window_internal *i;
} bfd_window;

extern void bfd_init_window  (bfd_window *)  ;
extern void bfd_free_window  (bfd_window *)  ;
extern boolean bfd_get_file_window
   (bfd *, file_ptr, bfd_size_type, bfd_window *, boolean)  ;

/* XCOFF support routines for the linker.  */

extern boolean bfd_xcoff_link_record_set
   (bfd *, struct bfd_link_info *, struct bfd_link_hash_entry *,
	   bfd_size_type)  ;
extern boolean bfd_xcoff_import_symbol
   (bfd *, struct bfd_link_info *, struct bfd_link_hash_entry *,
	   bfd_vma, const char *, const char *, const char *)  ;
extern boolean bfd_xcoff_export_symbol
   (bfd *, struct bfd_link_info *, struct bfd_link_hash_entry *,
	   boolean)  ;
extern boolean bfd_xcoff_link_count_reloc
   (bfd *, struct bfd_link_info *, const char *)  ;
extern boolean bfd_xcoff_record_link_assignment
   (bfd *, struct bfd_link_info *, const char *)  ;
extern boolean bfd_xcoff_size_dynamic_sections
   (bfd *, struct bfd_link_info *, const char *, const char *,
	   unsigned long, unsigned long, unsigned long, boolean,
	   int, boolean, boolean, struct sec **)  ;

/* Externally visible COFF routines.  */


struct internal_syment;
union internal_auxent;


extern boolean bfd_coff_get_syment
   (bfd *, struct symbol_cache_entry *, struct internal_syment *)  ;
extern boolean bfd_coff_get_auxent
   (bfd *, struct symbol_cache_entry *, int, union internal_auxent *)  ;

/* And more from the source.  */
void 
bfd_init  (void)  ;

bfd *
bfd_openr  (const  char *filename, const  char *target)  ;

bfd *
bfd_fdopenr  (const  char *filename, const  char *target, int fd)  ;

bfd *
bfd_openstreamr  (const char *, const char *, void * )  ;

bfd *
bfd_openw  (const  char *filename, const  char *target)  ;

boolean 
bfd_close  (bfd *abfd)  ;

boolean 
bfd_close_all_done  (bfd *)  ;

bfd *
bfd_create  (const  char *filename, bfd *templ)  ;


 /* Byte swapping macros for user section data.  */

#define bfd_put_8(abfd, val, ptr) (*((unsigned char *)(ptr)) = (unsigned char)(val))
#define bfd_put_signed_8 bfd_put_8
#define bfd_get_8(abfd, ptr) (*(unsigned char *)(ptr))
#define bfd_get_signed_8(abfd, ptr) ((*(unsigned char *)(ptr) ^ 0x80) - 0x80)

#define bfd_put_16(abfd, val, ptr) BFD_SEND(abfd, bfd_putx16, ((val),(ptr)))
#define bfd_put_signed_16 bfd_put_16
#define bfd_get_16(abfd, ptr) BFD_SEND(abfd, bfd_getx16, (ptr))
#define bfd_get_signed_16(abfd, ptr) BFD_SEND (abfd, bfd_getx_signed_16, (ptr))

#define bfd_put_32(abfd, val, ptr) BFD_SEND(abfd, bfd_putx32, ((val),(ptr)))
#define bfd_put_signed_32 bfd_put_32
#define bfd_get_32(abfd, ptr) BFD_SEND(abfd, bfd_getx32, (ptr))
#define bfd_get_signed_32(abfd, ptr) BFD_SEND(abfd, bfd_getx_signed_32, (ptr))

#define bfd_put_64(abfd, val, ptr) BFD_SEND(abfd, bfd_putx64, ((val), (ptr)))
#define bfd_put_signed_64 bfd_put_64
#define bfd_get_64(abfd, ptr) BFD_SEND(abfd, bfd_getx64, (ptr))
#define bfd_get_signed_64(abfd, ptr) BFD_SEND(abfd, bfd_getx_signed_64, (ptr))


 /* Byte swapping macros for file header data.  */

#define bfd_h_put_8(abfd, val, ptr) bfd_put_8 (abfd, val, ptr)
#define bfd_h_put_signed_8(abfd, val, ptr) bfd_put_8 (abfd, val, ptr)
#define bfd_h_get_8(abfd, ptr) bfd_get_8 (abfd, ptr)
#define bfd_h_get_signed_8(abfd, ptr) bfd_get_signed_8 (abfd, ptr)

#define bfd_h_put_16(abfd, val, ptr) BFD_SEND(abfd, bfd_h_putx16,(val,ptr))
#define bfd_h_put_signed_16 bfd_h_put_16
#define bfd_h_get_16(abfd, ptr) BFD_SEND(abfd, bfd_h_getx16,(ptr))
#define bfd_h_get_signed_16(abfd, ptr) BFD_SEND(abfd, bfd_h_getx_signed_16, (ptr))

#define bfd_h_put_32(abfd, val, ptr) BFD_SEND(abfd, bfd_h_putx32,(val,ptr))
#define bfd_h_put_signed_32 bfd_h_put_32
#define bfd_h_get_32(abfd, ptr) BFD_SEND(abfd, bfd_h_getx32,(ptr))
#define bfd_h_get_signed_32(abfd, ptr) BFD_SEND(abfd, bfd_h_getx_signed_32, (ptr))

#define bfd_h_put_64(abfd, val, ptr) BFD_SEND(abfd, bfd_h_putx64,(val, ptr))
#define bfd_h_put_signed_64 bfd_h_put_64
#define bfd_h_get_64(abfd, ptr) BFD_SEND(abfd, bfd_h_getx64,(ptr))
#define bfd_h_get_signed_64(abfd, ptr) BFD_SEND(abfd, bfd_h_getx_signed_64, (ptr))

typedef struct sec
{
         /* The name of the section; the name isn't a copy, the pointer is
        the same as that passed to bfd_make_section. */

    const  char *name;

         /* Which section is it; 0..nth.      */

   int index;

         /* The next section in the list belonging to the BFD, or NULL. */

    struct sec *next;

         /* The field flags contains attributes of the section. Some
           flags are read in from the object file, and some are
           synthesized from other information.  */

    flagword flags;

#define SEC_NO_FLAGS   0x000

         /* Tells the OS to allocate space for this section when loading.
           This is clear for a section containing debug information
           only. */
#define SEC_ALLOC      0x001

         /* Tells the OS to load the section from the file when loading.
           This is clear for a .bss section. */
#define SEC_LOAD       0x002

         /* The section contains data still to be relocated, so there is
           some relocation information too. */
#define SEC_RELOC      0x004



         /* A signal to the OS that the section contains read only
          data. */
#define SEC_READONLY   0x010

         /* The section contains code only. */
#define SEC_CODE       0x020

         /* The section contains data only. */
#define SEC_DATA       0x040

         /* The section will reside in ROM. */
#define SEC_ROM        0x080

         /* The section contains constructor information. This section
           type is used by the linker to create lists of constructors and
           destructors used by <<g++>>. When a back end sees a symbol
           which should be used in a constructor list, it creates a new
           section for the type of name (e.g., <<__CTOR_LIST__>>), attaches
           the symbol to it, and builds a relocation. To build the lists
           of constructors, all the linker has to do is catenate all the
           sections called <<__CTOR_LIST__>> and relocate the data
           contained within - exactly the operations it would peform on
           standard data. */
#define SEC_CONSTRUCTOR 0x100

         /* The section is a constuctor, and should be placed at the
          end of the text, data, or bss section(?). */
#define SEC_CONSTRUCTOR_TEXT 0x1100
#define SEC_CONSTRUCTOR_DATA 0x2100
#define SEC_CONSTRUCTOR_BSS  0x3100

         /* The section has contents - a data section could be
           <<SEC_ALLOC>> | <<SEC_HAS_CONTENTS>>; a debug section could be
           <<SEC_HAS_CONTENTS>> */
#define SEC_HAS_CONTENTS 0x200

         /* An instruction to the linker to not output the section
           even if it has information which would normally be written. */
#define SEC_NEVER_LOAD 0x400

         /* The section is a COFF shared library section.  This flag is
           only for the linker.  If this type of section appears in
           the input file, the linker must copy it to the output file
           without changing the vma or size.  FIXME: Although this
           was originally intended to be general, it really is COFF
           specific (and the flag was renamed to indicate this).  It
           might be cleaner to have some more general mechanism to
           allow the back end to control what the linker does with
           sections. */
#define SEC_COFF_SHARED_LIBRARY 0x800

         /* The section contains common symbols (symbols may be defined
           multiple times, the value of a symbol is the amount of
           space it requires, and the largest symbol value is the one
           used).  Most targets have exactly one of these (which we
	    translate to bfd_com_section_ptr), but ECOFF has two. */
#define SEC_IS_COMMON 0x8000

         /* The section contains only debugging information.  For
           example, this is set for ELF .debug and .stab sections.
           strip tests this flag to see if a section can be
           discarded. */
#define SEC_DEBUGGING 0x10000

         /* The contents of this section are held in memory pointed to
           by the contents field.  This is checked by
           bfd_get_section_contents, and the data is retrieved from
           memory if appropriate.  */
#define SEC_IN_MEMORY 0x20000

         /* The contents of this section are to be excluded by the
	    linker for executable and shared objects unless those
	    objects are to be further relocated.  */
#define SEC_EXCLUDE 0x40000

	 /* The contents of this section are to be sorted by the
	   based on the address specified in the associated symbol
	   table.  */
#define SEC_SORT_ENTRIES 0x80000

	 /* When linking, duplicate sections of the same name should be
	   discarded, rather than being combined into a single section as
	   is usually done.  This is similar to how common symbols are
	   handled.  See SEC_LINK_DUPLICATES below.  */
#define SEC_LINK_ONCE 0x100000

	 /* If SEC_LINK_ONCE is set, this bitfield describes how the linker
	   should handle duplicate sections.  */
#define SEC_LINK_DUPLICATES 0x600000

	 /* This value for SEC_LINK_DUPLICATES means that duplicate
	   sections with the same name should simply be discarded. */
#define SEC_LINK_DUPLICATES_DISCARD 0x0

	 /* This value for SEC_LINK_DUPLICATES means that the linker
	   should warn if there are any duplicate sections, although
	   it should still only link one copy.  */
#define SEC_LINK_DUPLICATES_ONE_ONLY 0x200000

	 /* This value for SEC_LINK_DUPLICATES means that the linker
	   should warn if any duplicate sections are a different size.  */
#define SEC_LINK_DUPLICATES_SAME_SIZE 0x400000

	 /* This value for SEC_LINK_DUPLICATES means that the linker
	   should warn if any duplicate sections contain different
	   contents.  */
#define SEC_LINK_DUPLICATES_SAME_CONTENTS 0x600000

	 /* This section was created by the linker as part of dynamic
	   relocation or other arcane processing.  It is skipped when
	   going through the first-pass output, trusting that someone
	   else up the line will take care of it later.  */
#define SEC_LINKER_CREATED 0x800000

	 /*  End of section flags.  */

	 /* Some internal packed boolean fields.  */

	 /* See the vma field.  */
	unsigned int user_set_vma : 1;

	 /* Whether relocations have been processed.  */
	unsigned int reloc_done : 1;

	 /* A mark flag used by some of the linker backends.  */
	unsigned int linker_mark : 1;

	 /* End of internal packed boolean fields.  */

        /*  The virtual memory address of the section - where it will be
           at run time.  The symbols are relocated against this.  The
	    user_set_vma flag is maintained by bfd; if it's not set, the
	    backend can assign addresses (for example, in <<a.out>>, where
	    the default address for <<.data>> is dependent on the specific
	    target and various flags).  */

   bfd_vma vma;

        /*  The load address of the section - where it would be in a
           rom image; really only used for writing section header
	    information. */

   bfd_vma lma;

         /* The size of the section in bytes, as it will be output.
           contains a value even if the section has no contents (e.g., the
           size of <<.bss>>). This will be filled in after relocation */

   bfd_size_type _cooked_size;

         /* The original size on disk of the section, in bytes.  Normally this
	    value is the same as the size, but if some relaxing has
	    been done, then this value will be bigger.  */

   bfd_size_type _raw_size;

         /* If this section is going to be output, then this value is the
           offset into the output section of the first byte in the input
           section. E.g., if this was going to start at the 100th byte in
           the output section, this value would be 100. */

   bfd_vma output_offset;

         /* The output section through which to map on output. */

   struct sec *output_section;

         /* The alignment requirement of the section, as an exponent of 2 -
           e.g., 3 aligns to 2^3 (or 8). */

   unsigned int alignment_power;

         /* If an input section, a pointer to a vector of relocation
           records for the data in this section. */

   struct reloc_cache_entry *relocation;

         /* If an output section, a pointer to a vector of pointers to
           relocation records for the data in this section. */

   struct reloc_cache_entry **orelocation;

         /* The number of relocation records in one of the above  */

   unsigned reloc_count;

         /* Information below is back end specific - and not always used
           or updated.  */

         /* File position of section data    */

   file_ptr filepos;

         /* File position of relocation info */

   file_ptr rel_filepos;

         /* File position of line data       */

   file_ptr line_filepos;

         /* Pointer to data for applications */

   void *  userdata;

         /* If the SEC_IN_MEMORY flag is set, this points to the actual
           contents.  */
   unsigned char *contents;

         /* Attached line number information */

   alent *lineno;

         /* Number of line number records   */

   unsigned int lineno_count;

         /* When a section is being output, this value changes as more
           linenumbers are written out */

   file_ptr moving_line_filepos;

         /* What the section number is in the target world  */

   int target_index;

   void *  used_by_bfd;

         /* If this is a constructor section then here is a list of the
           relocations created to relocate items within it. */

   struct relent_chain *constructor_chain;

         /* The BFD which owns the section. */

   bfd *owner;

	  /* A symbol which points at this section only */
   struct symbol_cache_entry *symbol;
   struct symbol_cache_entry **symbol_ptr_ptr;

   struct bfd_link_order *link_order_head;
   struct bfd_link_order *link_order_tail;
} asection ;

     /* These sections are global, and are managed by BFD.  The application
       and target back end are not permitted to change the values in
	these sections.  New code should use the section_ptr macros rather
       than referring directly to the const sections.  The const sections
       may eventually vanish.  */
#define BFD_ABS_SECTION_NAME "*ABS*"
#define BFD_UND_SECTION_NAME "*UND*"
#define BFD_COM_SECTION_NAME "*COM*"
#define BFD_IND_SECTION_NAME "*IND*"

     /* the absolute section */
extern const asection bfd_abs_section;
#define bfd_abs_section_ptr ((asection *) &bfd_abs_section)
#define bfd_is_abs_section(sec) ((sec) == bfd_abs_section_ptr)
     /* Pointer to the undefined section */
extern const asection bfd_und_section;
#define bfd_und_section_ptr ((asection *) &bfd_und_section)
#define bfd_is_und_section(sec) ((sec) == bfd_und_section_ptr)
     /* Pointer to the common section */
extern const asection bfd_com_section;
#define bfd_com_section_ptr ((asection *) &bfd_com_section)
     /* Pointer to the indirect section */
extern const asection bfd_ind_section;
#define bfd_ind_section_ptr ((asection *) &bfd_ind_section)
#define bfd_is_ind_section(sec) ((sec) == bfd_ind_section_ptr)

extern const struct symbol_cache_entry * const bfd_abs_symbol;
extern const struct symbol_cache_entry * const bfd_com_symbol;
extern const struct symbol_cache_entry * const bfd_und_symbol;
extern const struct symbol_cache_entry * const bfd_ind_symbol;
#define bfd_get_section_size_before_reloc(section) (section->reloc_done ? (abort(),1): (section)->_raw_size)
#define bfd_get_section_size_after_reloc(section) ((section->reloc_done) ? (section)->_cooked_size: (abort(),1))
asection *
bfd_get_section_by_name  (bfd *abfd, const  char *name)  ;

asection *
bfd_make_section_old_way  (bfd *abfd, const  char *name)  ;

asection *
bfd_make_section_anyway  (bfd *abfd, const  char *name)  ;

asection *
bfd_make_section  (bfd *, const  char *name)  ;

boolean 
bfd_set_section_flags  (bfd *abfd, asection *sec, flagword flags)  ;

void 
bfd_map_over_sections  (bfd *abfd,
    void (*func)(bfd *abfd,
    asection *sect,
    void *  obj),
    void *  obj)  ;

boolean 
bfd_set_section_size  (bfd *abfd, asection *sec, bfd_size_type val)  ;

boolean 
bfd_set_section_contents
  (bfd *abfd,
    asection *section,
    void *  data,
    file_ptr offset,
    bfd_size_type count)  ;

boolean 
bfd_get_section_contents
  (bfd *abfd, asection *section, void *  location,
    file_ptr offset, bfd_size_type count)  ;

boolean 
bfd_copy_private_section_data  (bfd *ibfd, asection *isec, bfd *obfd, asection *osec)  ;

#define bfd_copy_private_section_data(ibfd, isection, obfd, osection) BFD_SEND (obfd, _bfd_copy_private_section_data, (ibfd, isection, obfd, osection))
enum bfd_architecture 
{
  bfd_arch_unknown,    /* File arch not known */
  bfd_arch_obscure,    /* Arch known, not one of these */
  bfd_arch_m68k,       /* Motorola 68xxx */
  bfd_arch_vax,        /* DEC Vax */   
  bfd_arch_i960,       /* Intel 960 */
     /* The order of the following is important.
       lower number indicates a machine type that 
       only accepts a subset of the instructions
       available to machines with higher numbers.
       The exception is the "ca", which is
       incompatible with all other machines except 
       "core". */

#define bfd_mach_i960_core      1
#define bfd_mach_i960_ka_sa     2
#define bfd_mach_i960_kb_sb     3
#define bfd_mach_i960_mc        4
#define bfd_mach_i960_xa        5
#define bfd_mach_i960_ca        6
#define bfd_mach_i960_jx	 7
#define bfd_mach_i960_hx        8

  bfd_arch_a29k,       /* AMD 29000 */
  bfd_arch_sparc,      /* SPARC */
#define bfd_mach_sparc			1
 /* The difference between v8plus and v9 is that v9 is a true 64 bit env.  */
#define bfd_mach_sparc_sparclet	2
#define bfd_mach_sparc_sparclite	3
#define bfd_mach_sparc_v8plus		4
#define bfd_mach_sparc_v8plusa		5  
#define bfd_mach_sparc_v9		6
#define bfd_mach_sparc_v9a		7  
 /* Nonzero if MACH has the v9 instruction set.  */
#define bfd_mach_sparc_v9_p(mach) ((mach) >= bfd_mach_sparc_v8plus && (mach) <= bfd_mach_sparc_v9a)
  bfd_arch_mips,       /* MIPS Rxxxx */
  bfd_arch_i386,       /* Intel 386 */
#define bfd_mach_i386_i386 0
#define bfd_mach_i386_i8086 1
  bfd_arch_we32k,      /* AT&T WE32xxx */
  bfd_arch_tahoe,      /* CCI/Harris Tahoe */
  bfd_arch_i860,       /* Intel 860 */
  bfd_arch_romp,       /* IBM ROMP PC/RT */
  bfd_arch_alliant,    /* Alliant */
  bfd_arch_convex,     /* Convex */
  bfd_arch_m88k,       /* Motorola 88xxx */
  bfd_arch_pyramid,    /* Pyramid Technology */
  bfd_arch_h8300,      /* Hitachi H8/300 */
#define bfd_mach_h8300   1
#define bfd_mach_h8300h  2
#define bfd_mach_h8300s  3
  bfd_arch_powerpc,    /* PowerPC */
  bfd_arch_rs6000,     /* IBM RS/6000 */
  bfd_arch_hppa,       /* HP PA RISC */
  bfd_arch_d10v,       /* Mitsubishi D10V */
  bfd_arch_z8k,        /* Zilog Z8000 */
#define bfd_mach_z8001		1
#define bfd_mach_z8002		2
  bfd_arch_h8500,      /* Hitachi H8/500 */
  bfd_arch_sh,         /* Hitachi SH */
  bfd_arch_alpha,      /* Dec Alpha */
  bfd_arch_arm,        /* Advanced Risc Machines ARM */
  bfd_arch_ns32k,      /* National Semiconductors ns32000 */
  bfd_arch_w65,        /* WDC 65816 */
  bfd_arch_m32r,       /* Mitsubishi M32R/D */
  bfd_arch_mn10200,    /* Matsushita MN10200 */
  bfd_arch_mn10300,    /* Matsushita MN10300 */
  bfd_arch_last
  };

typedef struct bfd_arch_info 
{
  int bits_per_word;
  int bits_per_address;
  int bits_per_byte;
  enum bfd_architecture arch;
  unsigned long mach;
  const char *arch_name;
  const char *printable_name;
  unsigned int section_align_power;
  /* true if this is the default machine for the architecture */
  boolean the_default;	
  const struct bfd_arch_info * (*compatible)
	 (const struct bfd_arch_info *a,
	         const struct bfd_arch_info *b)  ;

  boolean (*scan)  (const struct bfd_arch_info *, const char *)  ;

  const struct bfd_arch_info *next;
} bfd_arch_info_type;
const char *
bfd_printable_name  (bfd *abfd)  ;

const bfd_arch_info_type *
bfd_scan_arch  (const char *string)  ;

const bfd_arch_info_type *
bfd_arch_get_compatible  (
    const bfd *abfd,
    const bfd *bbfd)  ;

void 
bfd_set_arch_info  (bfd *abfd, const bfd_arch_info_type *arg)  ;

enum bfd_architecture 
bfd_get_arch  (bfd *abfd)  ;

unsigned long 
bfd_get_mach  (bfd *abfd)  ;

unsigned int 
bfd_arch_bits_per_byte  (bfd *abfd)  ;

unsigned int 
bfd_arch_bits_per_address  (bfd *abfd)  ;

const bfd_arch_info_type * 
bfd_get_arch_info  (bfd *abfd)  ;

const bfd_arch_info_type *
bfd_lookup_arch
  (enum bfd_architecture
    arch,
    unsigned long machine)  ;

const char *
bfd_printable_arch_mach
  (enum bfd_architecture arch, unsigned long machine)  ;

typedef enum bfd_reloc_status
{
        /* No errors detected */
  bfd_reloc_ok,

        /* The relocation was performed, but there was an overflow. */
  bfd_reloc_overflow,

        /* The address to relocate was not within the section supplied. */
  bfd_reloc_outofrange,

        /* Used by special functions */
  bfd_reloc_continue,

        /* Unsupported relocation size requested. */
  bfd_reloc_notsupported,

        /* Unused */
  bfd_reloc_other,

        /* The symbol to relocate against was undefined. */
  bfd_reloc_undefined,

        /* The relocation was performed, but may not be ok - presently
          generated only when linking i960 coff files with i960 b.out
          symbols.  If this type is returned, the error_message argument
          to bfd_perform_relocation will be set.  */
  bfd_reloc_dangerous
 }
 bfd_reloc_status_type;


typedef struct reloc_cache_entry
{
        /* A pointer into the canonical table of pointers  */
  struct symbol_cache_entry **sym_ptr_ptr;

        /* offset in section */
  bfd_size_type address;

        /* addend for relocation value */
  bfd_vma addend;

        /* Pointer to how to perform the required relocation */
  reloc_howto_type *howto;

} arelent;
enum complain_overflow
{
	 /* Do not complain on overflow. */
  complain_overflow_dont,

	 /* Complain if the bitfield overflows, whether it is considered
	   as signed or unsigned. */
  complain_overflow_bitfield,

	 /* Complain if the value overflows when considered as signed
	   number. */
  complain_overflow_signed,

	 /* Complain if the value overflows when considered as an
	   unsigned number. */
  complain_overflow_unsigned
};

struct reloc_howto_struct
{
        /*  The type field has mainly a documentary use - the back end can
           do what it wants with it, though normally the back end's
           external idea of what a reloc number is stored
           in this field. For example, a PC relative word relocation
           in a coff environment has the type 023 - because that's
           what the outside world calls a R_PCRWORD reloc. */
  unsigned int type;

        /*  The value the final relocation is shifted right by. This drops
           unwanted data from the relocation.  */
  unsigned int rightshift;

	 /*  The size of the item to be relocated.  This is *not* a
	    power-of-two measure.  To get the number of bytes operated
	    on by a type of relocation, use bfd_get_reloc_size.  */
  int size;

        /*  The number of bits in the item to be relocated.  This is used
	    when doing overflow checking.  */
  unsigned int bitsize;

        /*  Notes that the relocation is relative to the location in the
           data section of the addend. The relocation function will
           subtract from the relocation value the address of the location
           being relocated. */
  boolean pc_relative;

	 /*  The bit position of the reloc value in the destination.
	    The relocated value is left shifted by this amount. */
  unsigned int bitpos;

	 /* What type of overflow error should be checked for when
	   relocating. */
  enum complain_overflow complain_on_overflow;

        /* If this field is non null, then the supplied function is
          called rather than the normal function. This allows really
          strange relocation methods to be accomodated (e.g., i960 callj
          instructions). */
  bfd_reloc_status_type (*special_function)
				     (bfd *abfd,
					     arelent *reloc_entry,
                                            struct symbol_cache_entry *symbol,
                                            void *  data,
                                            asection *input_section,
                                            bfd *output_bfd,
                                            char **error_message)  ;

        /* The textual name of the relocation type. */
  char *name;

        /* When performing a partial link, some formats must modify the
          relocations rather than the data - this flag signals this.*/
  boolean partial_inplace;

        /* The src_mask selects which parts of the read in data
          are to be used in the relocation sum.  E.g., if this was an 8 bit
          bit of data which we read and relocated, this would be
          0x000000ff. When we have relocs which have an addend, such as
          sun4 extended relocs, the value in the offset part of a
          relocating field is garbage so we never use it. In this case
          the mask would be 0x00000000. */
  bfd_vma src_mask;

        /* The dst_mask selects which parts of the instruction are replaced
          into the instruction. In most cases src_mask == dst_mask,
          except in the above special case, where dst_mask would be
          0x000000ff, and src_mask would be 0x00000000.   */
  bfd_vma dst_mask;

        /* When some formats create PC relative instructions, they leave
          the value of the pc of the place being relocated in the offset
          slot of the instruction, so that a PC relative relocation can
          be made just by adding in an ordinary offset (e.g., sun3 a.out).
          Some formats leave the displacement part of an instruction
          empty (e.g., m88k bcs); this flag signals the fact.*/
  boolean pcrel_offset;

};
#define HOWTO(C, R,S,B, P, BI, O, SF, NAME, INPLACE, MASKSRC, MASKDST, PC) {(unsigned)C,R,S,B, P, BI, O,SF,NAME,INPLACE,MASKSRC,MASKDST,PC}
#define NEWHOWTO( FUNCTION, NAME,SIZE,REL,IN) HOWTO(0,0,SIZE,0,REL,0,complain_overflow_dont,FUNCTION, NAME,false,0,0,IN)

#define HOWTO_PREPARE(relocation, symbol) { if (symbol != (asymbol *)NULL) { if (bfd_is_com_section (symbol->section)) { relocation = 0; } else { relocation = symbol->value; } } }
int 
bfd_get_reloc_size   (reloc_howto_type *)  ;

typedef struct relent_chain {
  arelent relent;
  struct   relent_chain *next;
} arelent_chain;
bfd_reloc_status_type

bfd_perform_relocation
  (bfd *abfd,
    arelent *reloc_entry,
    void *  data,
    asection *input_section,
    bfd *output_bfd,
    char **error_message)  ;

bfd_reloc_status_type

bfd_install_relocation
  (bfd *abfd,
    arelent *reloc_entry,
    void *  data, bfd_vma data_start,
    asection *input_section,
    char **error_message)  ;

enum bfd_reloc_code_real {
  _dummy_first_bfd_reloc_code_real,


/* Basic absolute relocations of N bits. */
  BFD_RELOC_64,
  BFD_RELOC_32,
  BFD_RELOC_26,
  BFD_RELOC_24,
  BFD_RELOC_16,
  BFD_RELOC_14,
  BFD_RELOC_8,

/* PC-relative relocations.  Sometimes these are relative to the address
of the relocation itself; sometimes they are relative to the start of
the section containing the relocation.  It depends on the specific target.

The 24-bit relocation is used in some Intel 960 configurations. */
  BFD_RELOC_64_PCREL,
  BFD_RELOC_32_PCREL,
  BFD_RELOC_24_PCREL,
  BFD_RELOC_16_PCREL,
  BFD_RELOC_12_PCREL,
  BFD_RELOC_8_PCREL,

/* For ELF. */
  BFD_RELOC_32_GOT_PCREL,
  BFD_RELOC_16_GOT_PCREL,
  BFD_RELOC_8_GOT_PCREL,
  BFD_RELOC_32_GOTOFF,
  BFD_RELOC_16_GOTOFF,
  BFD_RELOC_LO16_GOTOFF,
  BFD_RELOC_HI16_GOTOFF,
  BFD_RELOC_HI16_S_GOTOFF,
  BFD_RELOC_8_GOTOFF,
  BFD_RELOC_32_PLT_PCREL,
  BFD_RELOC_24_PLT_PCREL,
  BFD_RELOC_16_PLT_PCREL,
  BFD_RELOC_8_PLT_PCREL,
  BFD_RELOC_32_PLTOFF,
  BFD_RELOC_16_PLTOFF,
  BFD_RELOC_LO16_PLTOFF,
  BFD_RELOC_HI16_PLTOFF,
  BFD_RELOC_HI16_S_PLTOFF,
  BFD_RELOC_8_PLTOFF,

/* Relocations used by 68K ELF. */
  BFD_RELOC_68K_GLOB_DAT,
  BFD_RELOC_68K_JMP_SLOT,
  BFD_RELOC_68K_RELATIVE,

/* Linkage-table relative. */
  BFD_RELOC_32_BASEREL,
  BFD_RELOC_16_BASEREL,
  BFD_RELOC_LO16_BASEREL,
  BFD_RELOC_HI16_BASEREL,
  BFD_RELOC_HI16_S_BASEREL,
  BFD_RELOC_8_BASEREL,
  BFD_RELOC_RVA,

/* Absolute 8-bit relocation, but used to form an address like 0xFFnn. */
  BFD_RELOC_8_FFnn,

/* These PC-relative relocations are stored as word displacements --
i.e., byte displacements shifted right two bits.  The 30-bit word
displacement (<<32_PCREL_S2>> -- 32 bits, shifted 2) is used on the
SPARC.  (SPARC tools generally refer to this as <<WDISP30>>.)  The
signed 16-bit displacement is used on the MIPS, and the 23-bit
displacement is used on the Alpha. */
  BFD_RELOC_32_PCREL_S2,
  BFD_RELOC_16_PCREL_S2,
  BFD_RELOC_23_PCREL_S2,

/* High 22 bits and low 10 bits of 32-bit value, placed into lower bits of
the target word.  These are used on the SPARC. */
  BFD_RELOC_HI22,
  BFD_RELOC_LO10,

/* For systems that allocate a Global Pointer register, these are
displacements off that register.  These relocation types are
handled specially, because the value the register will have is
decided relatively late. */
  BFD_RELOC_GPREL16,
  BFD_RELOC_GPREL32,

/* Reloc types used for i960/b.out. */
  BFD_RELOC_I960_CALLJ,

/* SPARC ELF relocations.  There is probably some overlap with other
relocation types already defined. */
  BFD_RELOC_NONE,
  BFD_RELOC_SPARC_WDISP22,
  BFD_RELOC_SPARC22,
  BFD_RELOC_SPARC13,
  BFD_RELOC_SPARC_GOT10,
  BFD_RELOC_SPARC_GOT13,
  BFD_RELOC_SPARC_GOT22,
  BFD_RELOC_SPARC_PC10,
  BFD_RELOC_SPARC_PC22,
  BFD_RELOC_SPARC_WPLT30,
  BFD_RELOC_SPARC_COPY,
  BFD_RELOC_SPARC_GLOB_DAT,
  BFD_RELOC_SPARC_JMP_SLOT,
  BFD_RELOC_SPARC_RELATIVE,
  BFD_RELOC_SPARC_UA32,

/* I think these are specific to SPARC a.out (e.g., Sun 4). */
  BFD_RELOC_SPARC_BASE13,
  BFD_RELOC_SPARC_BASE22,

/* Some relocations we're using for SPARC V9 -- subject to change. */
#define BFD_RELOC_SPARC_64 BFD_RELOC_64
  BFD_RELOC_SPARC_10,
  BFD_RELOC_SPARC_11,
  BFD_RELOC_SPARC_OLO10,
  BFD_RELOC_SPARC_HH22,
  BFD_RELOC_SPARC_HM10,
  BFD_RELOC_SPARC_LM22,
  BFD_RELOC_SPARC_PC_HH22,
  BFD_RELOC_SPARC_PC_HM10,
  BFD_RELOC_SPARC_PC_LM22,
  BFD_RELOC_SPARC_WDISP16,
  BFD_RELOC_SPARC_WDISP19,
  BFD_RELOC_SPARC_GLOB_JMP,
  BFD_RELOC_SPARC_7,
  BFD_RELOC_SPARC_6,
  BFD_RELOC_SPARC_5,

/* Alpha ECOFF and ELF relocations.  Some of these treat the symbol or
"addend" in some special way.
For GPDISP_HI16 ("gpdisp") relocations, the symbol is ignored when
writing; when reading, it will be the absolute section symbol.  The
addend is the displacement in bytes of the "lda" instruction from
the "ldah" instruction (which is at the address of this reloc). */
  BFD_RELOC_ALPHA_GPDISP_HI16,

/* For GPDISP_LO16 ("ignore") relocations, the symbol is handled as
with GPDISP_HI16 relocs.  The addend is ignored when writing the
relocations out, and is filled in with the file's GP value on
reading, for convenience. */
  BFD_RELOC_ALPHA_GPDISP_LO16,

/* The ELF GPDISP relocation is exactly the same as the GPDISP_HI16
relocation except that there is no accompanying GPDISP_LO16
relocation. */
  BFD_RELOC_ALPHA_GPDISP,

/* The Alpha LITERAL/LITUSE relocs are produced by a symbol reference;
the assembler turns it into a LDQ instruction to load the address of
the symbol, and then fills in a register in the real instruction.

The LITERAL reloc, at the LDQ instruction, refers to the .lita
section symbol.  The addend is ignored when writing, but is filled
in with the file's GP value on reading, for convenience, as with the
GPDISP_LO16 reloc.

The ELF_LITERAL reloc is somewhere between 16_GOTOFF and GPDISP_LO16.
It should refer to the symbol to be referenced, as with 16_GOTOFF,
but it generates output not based on the position within the .got
section, but relative to the GP value chosen for the file during the
final link stage.

The LITUSE reloc, on the instruction using the loaded address, gives
information to the linker that it might be able to use to optimize
away some literal section references.  The symbol is ignored (read
as the absolute section symbol), and the "addend" indicates the type
of instruction using the register:
1 - "memory" fmt insn
2 - byte-manipulation (byte offset reg)
3 - jsr (target of branch)

The GNU linker currently doesn't do any of this optimizing. */
  BFD_RELOC_ALPHA_LITERAL,
  BFD_RELOC_ALPHA_ELF_LITERAL,
  BFD_RELOC_ALPHA_LITUSE,

/* The HINT relocation indicates a value that should be filled into the
"hint" field of a jmp/jsr/ret instruction, for possible branch-
prediction logic which may be provided on some processors. */
  BFD_RELOC_ALPHA_HINT,

/* The LINKAGE relocation outputs a linkage pair in the object file,
which is filled by the linker. */
  BFD_RELOC_ALPHA_LINKAGE,

/* The CODEADDR relocation outputs a STO_CA in the object file,
which is filled by the linker. */
  BFD_RELOC_ALPHA_CODEADDR,

/* Bits 27..2 of the relocation address shifted right 2 bits;
simple reloc otherwise. */
  BFD_RELOC_MIPS_JMP,

/* The MIPS16 jump instruction. */
  BFD_RELOC_MIPS16_JMP,

/* MIPS16 GP relative reloc. */
  BFD_RELOC_MIPS16_GPREL,

/* High 16 bits of 32-bit value; simple reloc. */
  BFD_RELOC_HI16,

/* High 16 bits of 32-bit value but the low 16 bits will be sign
extended and added to form the final result.  If the low 16
bits form a negative number, we need to add one to the high value
to compensate for the borrow when the low bits are added. */
  BFD_RELOC_HI16_S,

/* Low 16 bits. */
  BFD_RELOC_LO16,

/* Like BFD_RELOC_HI16_S, but PC relative. */
  BFD_RELOC_PCREL_HI16_S,

/* Like BFD_RELOC_LO16, but PC relative. */
  BFD_RELOC_PCREL_LO16,

/* Relocation relative to the global pointer. */
#define BFD_RELOC_MIPS_GPREL BFD_RELOC_GPREL16

/* Relocation against a MIPS literal section. */
  BFD_RELOC_MIPS_LITERAL,

/* MIPS ELF relocations. */
  BFD_RELOC_MIPS_GOT16,
  BFD_RELOC_MIPS_CALL16,
#define BFD_RELOC_MIPS_GPREL32 BFD_RELOC_GPREL32
  BFD_RELOC_MIPS_GOT_HI16,
  BFD_RELOC_MIPS_GOT_LO16,
  BFD_RELOC_MIPS_CALL_HI16,
  BFD_RELOC_MIPS_CALL_LO16,

/* i386/elf relocations */
  BFD_RELOC_386_GOT32,
  BFD_RELOC_386_PLT32,
  BFD_RELOC_386_COPY,
  BFD_RELOC_386_GLOB_DAT,
  BFD_RELOC_386_JUMP_SLOT,
  BFD_RELOC_386_RELATIVE,
  BFD_RELOC_386_GOTOFF,
  BFD_RELOC_386_GOTPC,

/* ns32k relocations */
  BFD_RELOC_NS32K_IMM_8,
  BFD_RELOC_NS32K_IMM_16,
  BFD_RELOC_NS32K_IMM_32,
  BFD_RELOC_NS32K_IMM_8_PCREL,
  BFD_RELOC_NS32K_IMM_16_PCREL,
  BFD_RELOC_NS32K_IMM_32_PCREL,
  BFD_RELOC_NS32K_DISP_8,
  BFD_RELOC_NS32K_DISP_16,
  BFD_RELOC_NS32K_DISP_32,
  BFD_RELOC_NS32K_DISP_8_PCREL,
  BFD_RELOC_NS32K_DISP_16_PCREL,
  BFD_RELOC_NS32K_DISP_32_PCREL,

/* Power(rs6000) and PowerPC relocations. */
  BFD_RELOC_PPC_B26,
  BFD_RELOC_PPC_BA26,
  BFD_RELOC_PPC_TOC16,
  BFD_RELOC_PPC_B16,
  BFD_RELOC_PPC_B16_BRTAKEN,
  BFD_RELOC_PPC_B16_BRNTAKEN,
  BFD_RELOC_PPC_BA16,
  BFD_RELOC_PPC_BA16_BRTAKEN,
  BFD_RELOC_PPC_BA16_BRNTAKEN,
  BFD_RELOC_PPC_COPY,
  BFD_RELOC_PPC_GLOB_DAT,
  BFD_RELOC_PPC_JMP_SLOT,
  BFD_RELOC_PPC_RELATIVE,
  BFD_RELOC_PPC_LOCAL24PC,
  BFD_RELOC_PPC_EMB_NADDR32,
  BFD_RELOC_PPC_EMB_NADDR16,
  BFD_RELOC_PPC_EMB_NADDR16_LO,
  BFD_RELOC_PPC_EMB_NADDR16_HI,
  BFD_RELOC_PPC_EMB_NADDR16_HA,
  BFD_RELOC_PPC_EMB_SDAI16,
  BFD_RELOC_PPC_EMB_SDA2I16,
  BFD_RELOC_PPC_EMB_SDA2REL,
  BFD_RELOC_PPC_EMB_SDA21,
  BFD_RELOC_PPC_EMB_MRKREF,
  BFD_RELOC_PPC_EMB_RELSEC16,
  BFD_RELOC_PPC_EMB_RELST_LO,
  BFD_RELOC_PPC_EMB_RELST_HI,
  BFD_RELOC_PPC_EMB_RELST_HA,
  BFD_RELOC_PPC_EMB_BIT_FLD,
  BFD_RELOC_PPC_EMB_RELSDA,

/* The type of reloc used to build a contructor table - at the moment
probably a 32 bit wide absolute relocation, but the target can choose.
It generally does map to one of the other relocation types. */
  BFD_RELOC_CTOR,

/* ARM 26 bit pc-relative branch.  The lowest two bits must be zero and are
not stored in the instruction. */
  BFD_RELOC_ARM_PCREL_BRANCH,

/* These relocs are only used within the ARM assembler.  They are not
(at present) written to any object files. */
  BFD_RELOC_ARM_IMMEDIATE,
  BFD_RELOC_ARM_OFFSET_IMM,
  BFD_RELOC_ARM_SHIFT_IMM,
  BFD_RELOC_ARM_SWI,
  BFD_RELOC_ARM_MULTI,
  BFD_RELOC_ARM_CP_OFF_IMM,
  BFD_RELOC_ARM_ADR_IMM,
  BFD_RELOC_ARM_LDR_IMM,
  BFD_RELOC_ARM_LITERAL,
  BFD_RELOC_ARM_IN_POOL,
  BFD_RELOC_ARM_OFFSET_IMM8,
  BFD_RELOC_ARM_HWLITERAL,
  BFD_RELOC_ARM_THUMB_ADD,
  BFD_RELOC_ARM_THUMB_IMM,
  BFD_RELOC_ARM_THUMB_SHIFT,
  BFD_RELOC_ARM_THUMB_OFFSET,

/* Hitachi SH relocs.  Not all of these appear in object files. */
  BFD_RELOC_SH_PCDISP8BY2,
  BFD_RELOC_SH_PCDISP12BY2,
  BFD_RELOC_SH_IMM4,
  BFD_RELOC_SH_IMM4BY2,
  BFD_RELOC_SH_IMM4BY4,
  BFD_RELOC_SH_IMM8,
  BFD_RELOC_SH_IMM8BY2,
  BFD_RELOC_SH_IMM8BY4,
  BFD_RELOC_SH_PCRELIMM8BY2,
  BFD_RELOC_SH_PCRELIMM8BY4,
  BFD_RELOC_SH_SWITCH16,
  BFD_RELOC_SH_SWITCH32,
  BFD_RELOC_SH_USES,
  BFD_RELOC_SH_COUNT,
  BFD_RELOC_SH_ALIGN,
  BFD_RELOC_SH_CODE,
  BFD_RELOC_SH_DATA,
  BFD_RELOC_SH_LABEL,


/* Mitsubishi D10V relocs.
This is a 10-bit reloc with the right 2 bits
assumed to be 0. */
  BFD_RELOC_D10V_10_PCREL_R,

/* Mitsubishi D10V relocs.
This is a 10-bit reloc with the right 2 bits
assumed to be 0.  This is the same as the previous reloc
except it is in the left container, i.e.,
shifted left 15 bits. */
  BFD_RELOC_D10V_10_PCREL_L,

/* This is an 18-bit reloc with the right 2 bits
assumed to be 0. */
  BFD_RELOC_D10V_18,

/* This is an 18-bit reloc with the right 2 bits
assumed to be 0. */
  BFD_RELOC_D10V_18_PCREL,



/* Mitsubishi M32R relocs.
This is a 24 bit absolute address. */
  BFD_RELOC_M32R_24,

/* This is a 10-bit pc-relative reloc with the right 2 bits assumed to be 0. */
  BFD_RELOC_M32R_10_PCREL,

/* This is an 18-bit reloc with the right 2 bits assumed to be 0. */
  BFD_RELOC_M32R_18_PCREL,

/* This is a 26-bit reloc with the right 2 bits assumed to be 0. */
  BFD_RELOC_M32R_26_PCREL,

/* This is a 16-bit reloc containing the high 16 bits of an address
used when the lower 16 bits are treated as unsigned. */
  BFD_RELOC_M32R_HI16_ULO,

/* This is a 16-bit reloc containing the high 16 bits of an address
used when the lower 16 bits are treated as signed. */
  BFD_RELOC_M32R_HI16_SLO,

/* This is a 16-bit reloc containing the lower 16 bits of an address. */
  BFD_RELOC_M32R_LO16,

/* This is a 16-bit reloc containing the small data area offset for use in
add3, load, and store instructions. */
  BFD_RELOC_M32R_SDA16,


/* This is a 32bit pcrel reloc for the mn10300, offset by two bytes in the
instruction. */
  BFD_RELOC_MN10300_32_PCREL,

/* This is a 16bit pcrel reloc for the mn10300, offset by two bytes in the
instruction. */
  BFD_RELOC_MN10300_16_PCREL,
  BFD_RELOC_UNUSED };
typedef enum bfd_reloc_code_real bfd_reloc_code_real_type;
reloc_howto_type *

bfd_reloc_type_lookup   (bfd *abfd, bfd_reloc_code_real_type code)  ;

const char *
bfd_get_reloc_code_name   (bfd_reloc_code_real_type code)  ;


typedef struct symbol_cache_entry
{
	 /* A pointer to the BFD which owns the symbol. This information
	   is necessary so that a back end can work out what additional
   	   information (invisible to the application writer) is carried
	   with the symbol.

	   This field is *almost* redundant, since you can use section->owner
	   instead, except that some symbols point to the global sections
	   bfd_{abs,com,und}_section.  This could be fixed by making
	   these globals be per-bfd (or per-target-flavor).  FIXME. */

  struct _bfd *the_bfd;  /* Use bfd_asymbol_bfd(sym) to access this field. */

	 /* The text of the symbol. The name is left alone, and not copied; the
	   application may not alter it. */
  const  char *name;

	 /* The value of the symbol.  This really should be a union of a
          numeric value with a pointer, since some flags indicate that
          a pointer to another symbol is stored here.  */
  symvalue value;

	 /* Attributes of a symbol: */

#define BSF_NO_FLAGS    0x00

	 /* The symbol has local scope; <<static>> in <<C>>. The value
 	   is the offset into the section of the data. */
#define BSF_LOCAL	0x01

	 /* The symbol has global scope; initialized data in <<C>>. The
	   value is the offset into the section of the data. */
#define BSF_GLOBAL	0x02

	 /* The symbol has global scope and is exported. The value is
	   the offset into the section of the data. */
#define BSF_EXPORT	BSF_GLOBAL  

	 /* A normal C symbol would be one of:
	   <<BSF_LOCAL>>, <<BSF_FORT_COMM>>,  <<BSF_UNDEFINED>> or
	   <<BSF_GLOBAL>> */

	 /* The symbol is a debugging record. The value has an arbitary
	   meaning. */
#define BSF_DEBUGGING	0x08

	 /* The symbol denotes a function entry point.  Used in ELF,
	   perhaps others someday.  */
#define BSF_FUNCTION    0x10

	 /* Used by the linker. */
#define BSF_KEEP        0x20
#define BSF_KEEP_G      0x40

	 /* A weak global symbol, overridable without warnings by
	   a regular global symbol of the same name.  */
#define BSF_WEAK        0x80

        /* This symbol was created to point to a section, e.g. ELF's
	   STT_SECTION symbols.  */
#define BSF_SECTION_SYM 0x100

	 /* The symbol used to be a common symbol, but now it is
	   allocated. */
#define BSF_OLD_COMMON  0x200

	 /* The default value for common data. */
#define BFD_FORT_COMM_DEFAULT_VALUE 0

	 /* In some files the type of a symbol sometimes alters its
	   location in an output file - ie in coff a <<ISFCN>> symbol
	   which is also <<C_EXT>> symbol appears where it was
	   declared and not at the end of a section.  This bit is set
  	   by the target BFD part to convey this information. */

#define BSF_NOT_AT_END    0x400

	 /* Signal that the symbol is the label of constructor section. */
#define BSF_CONSTRUCTOR   0x800

	 /* Signal that the symbol is a warning symbol.  The name is a
	   warning.  The name of the next symbol is the one to warn about;
	   if a reference is made to a symbol with the same name as the next
	   symbol, a warning is issued by the linker. */
#define BSF_WARNING       0x1000

	 /* Signal that the symbol is indirect.  This symbol is an indirect
	   pointer to the symbol with the same name as the next symbol. */
#define BSF_INDIRECT      0x2000

	 /* BSF_FILE marks symbols that contain a file name.  This is used
	   for ELF STT_FILE symbols.  */
#define BSF_FILE          0x4000

	 /* Symbol is from dynamic linking information.  */
#define BSF_DYNAMIC	   0x8000

        /* The symbol denotes a data object.  Used in ELF, and perhaps
          others someday.  */
#define BSF_OBJECT	   0x10000

  flagword flags;

	 /* A pointer to the section to which this symbol is
	   relative.  This will always be non NULL, there are special
          sections for undefined and absolute symbols.  */
  struct sec *section;

	 /* Back end special data.  */
  union
    {
      void *  p;
      bfd_vma i;
    } udata;

} asymbol;
#define bfd_get_symtab_upper_bound(abfd) BFD_SEND (abfd, _bfd_get_symtab_upper_bound, (abfd))
boolean 
bfd_is_local_label  (bfd *abfd, asymbol *sym)  ;

boolean 
bfd_is_local_label_name  (bfd *abfd, const char *name)  ;

#define bfd_is_local_label_name(abfd, name) BFD_SEND (abfd, _bfd_is_local_label_name, (abfd, name))
#define bfd_canonicalize_symtab(abfd, location) BFD_SEND (abfd, _bfd_canonicalize_symtab, (abfd, location))
boolean 
bfd_set_symtab   (bfd *abfd, asymbol **location, unsigned int count)  ;

void 
bfd_print_symbol_vandf  (void *  file, asymbol *symbol)  ;

#define bfd_make_empty_symbol(abfd) BFD_SEND (abfd, _bfd_make_empty_symbol, (abfd))
#define bfd_make_debug_symbol(abfd,ptr,size) BFD_SEND (abfd, _bfd_make_debug_symbol, (abfd, ptr, size))
int 
bfd_decode_symclass  (asymbol *symbol)  ;

void 
bfd_symbol_info  (asymbol *symbol, symbol_info *ret)  ;

boolean 
bfd_copy_private_symbol_data  (bfd *ibfd, asymbol *isym, bfd *obfd, asymbol *osym)  ;

#define bfd_copy_private_symbol_data(ibfd, isymbol, obfd, osymbol) BFD_SEND (obfd, _bfd_copy_private_symbol_data, (ibfd, isymbol, obfd, osymbol))
struct _bfd 
{
     /* The filename the application opened the BFD with.  */
    const  char *filename;                

     /* A pointer to the target jump table.             */
    const struct bfd_target *xvec;

     /* To avoid dragging too many header files into every file that
       includes `<<bfd.h>>', IOSTREAM has been declared as a "char
       *", and MTIME as a "long".  Their correct types, to which they
       are cast when used, are "FILE *" and "time_t".    The iostream
       is the result of an fopen on the filename.  However, if the
       BFD_IN_MEMORY flag is set, then iostream is actually a pointer
       to a bfd_in_memory struct.  */
    void *  iostream;

     /* Is the file descriptor being cached?  That is, can it be closed as
       needed, and re-opened when accessed later?  */

    boolean cacheable;

     /* Marks whether there was a default target specified when the
       BFD was opened. This is used to select which matching algorithm
       to use to choose the back end. */

    boolean target_defaulted;

     /* The caching routines use these to maintain a
       least-recently-used list of BFDs */

    struct _bfd *lru_prev, *lru_next;

     /* When a file is closed by the caching routines, BFD retains
       state information on the file here: */

    file_ptr where;              

     /* and here: (``once'' means at least once) */

    boolean opened_once;

     /* Set if we have a locally maintained mtime value, rather than
       getting it from the file each time: */

    boolean mtime_set;

     /* File modified time, if mtime_set is true: */

    long mtime;          

     /* Reserved for an unimplemented file locking extension.*/

    int ifd;

     /* The format which belongs to the BFD. (object, core, etc.) */

    bfd_format format;

     /* The direction the BFD was opened with*/

    enum bfd_direction {no_direction = 0,
                        read_direction = 1,
                        write_direction = 2,
                        both_direction = 3} direction;

     /* Format_specific flags*/

    flagword flags;              

     /* Currently my_archive is tested before adding origin to
       anything. I believe that this can become always an add of
       origin, with origin set to 0 for non archive files.   */

    file_ptr origin;             

     /* Remember when output has begun, to stop strange things
       from happening. */
    boolean output_has_begun;

     /* Pointer to linked list of sections*/
    struct sec  *sections;

     /* The number of sections */
    unsigned int section_count;

     /* Stuff only useful for object files: 
       The start address. */
    bfd_vma start_address;

     /* Used for input and output*/
    unsigned int symcount;

     /* Symbol table for output BFD (with symcount entries) */
    struct symbol_cache_entry  **outsymbols;             

     /* Pointer to structure which contains architecture information*/
    const struct bfd_arch_info *arch_info;

     /* Stuff only useful for archives:*/
    void *  arelt_data;              
    struct _bfd *my_archive;      /* The containing archive BFD.  */
    struct _bfd *next;            /* The next BFD in the archive.  */
    struct _bfd *archive_head;    /* The first BFD in the archive.  */
    boolean has_armap;           

     /* A chain of BFD structures involved in a link.  */
    struct _bfd *link_next;

     /* A field used by _bfd_generic_link_add_archive_symbols.  This will
       be used only for archive elements.  */
    int archive_pass;

     /* Used by the back end to hold private data. */

    union 
      {
      struct aout_data_struct *aout_data;
      struct artdata *aout_ar_data;
      struct _oasys_data *oasys_obj_data;
      struct _oasys_ar_data *oasys_ar_data;
      struct coff_tdata *coff_obj_data;
      struct pe_tdata *pe_obj_data;
      struct xcoff_tdata *xcoff_obj_data;
      struct ecoff_tdata *ecoff_obj_data;
      struct ieee_data_struct *ieee_data;
      struct ieee_ar_data_struct *ieee_ar_data;
      struct srec_data_struct *srec_data;
      struct ihex_data_struct *ihex_data;
      struct tekhex_data_struct *tekhex_data;
      struct elf_obj_tdata *elf_obj_data;
      struct nlm_obj_tdata *nlm_obj_data;
      struct bout_data_struct *bout_data;
      struct sun_core_struct *sun_core_data;
      struct trad_core_struct *trad_core_data;
      struct som_data_struct *som_data;
      struct hpux_core_struct *hpux_core_data;
      struct hppabsd_core_struct *hppabsd_core_data;
      struct sgi_core_struct *sgi_core_data;
      struct lynx_core_struct *lynx_core_data;
      struct osf_core_struct *osf_core_data;
      struct cisco_core_struct *cisco_core_data;
      struct versados_data_struct *versados_data;
      struct netbsd_core_struct *netbsd_core_data;
      void *  any;
      } tdata;
  
     /* Used by the application to hold private data*/
    void *  usrdata;

   /* Where all the allocated stuff under this BFD goes.  This is a
     struct objalloc *, but we use PTR to avoid requiring the inclusion of
     objalloc.h.  */
    void *  memory;
};

typedef enum bfd_error
{
  bfd_error_no_error = 0,
  bfd_error_system_call,
  bfd_error_invalid_target,
  bfd_error_wrong_format,
  bfd_error_invalid_operation,
  bfd_error_no_memory,
  bfd_error_no_symbols,
  bfd_error_no_armap,
  bfd_error_no_more_archived_files,
  bfd_error_malformed_archive,
  bfd_error_file_not_recognized,
  bfd_error_file_ambiguously_recognized,
  bfd_error_no_contents,
  bfd_error_nonrepresentable_section,
  bfd_error_no_debug_section,
  bfd_error_bad_value,
  bfd_error_file_truncated,
  bfd_error_file_too_big,
  bfd_error_invalid_error_code
} bfd_error_type;

bfd_error_type 
bfd_get_error   (void)  ;

void 
bfd_set_error   (bfd_error_type error_tag)  ;

const  char *
bfd_errmsg   (bfd_error_type error_tag)  ;

void 
bfd_perror   (const  char *message)  ;

typedef void (*bfd_error_handler_type)  (const char *, ...)  ;

bfd_error_handler_type 
bfd_set_error_handler   (bfd_error_handler_type)  ;

void 
bfd_set_error_program_name   (const char *)  ;

long 
bfd_get_reloc_upper_bound  (bfd *abfd, asection *sect)  ;

long 
bfd_canonicalize_reloc
  (bfd *abfd,
    asection *sec,
    arelent **loc,
    asymbol	**syms)  ;

void 
bfd_set_reloc
  (bfd *abfd, asection *sec, arelent **rel, unsigned int count)
    
      ;

boolean 
bfd_set_file_flags  (bfd *abfd, flagword flags)  ;

boolean 
bfd_set_start_address  (bfd *abfd, bfd_vma vma)  ;

long 
bfd_get_mtime  (bfd *abfd)  ;

long 
bfd_get_size  (bfd *abfd)  ;

int 
bfd_get_gp_size  (bfd *abfd)  ;

void 
bfd_set_gp_size  (bfd *abfd, int i)  ;

bfd_vma 
bfd_scan_vma  (const  char *string, const  char **end, int base)  ;

boolean 
bfd_copy_private_bfd_data  (bfd *ibfd, bfd *obfd)  ;

#define bfd_copy_private_bfd_data(ibfd, obfd) BFD_SEND (obfd, _bfd_copy_private_bfd_data, (ibfd, obfd))
boolean 
bfd_merge_private_bfd_data  (bfd *ibfd, bfd *obfd)  ;

#define bfd_merge_private_bfd_data(ibfd, obfd) BFD_SEND (obfd, _bfd_merge_private_bfd_data, (ibfd, obfd))
boolean 
bfd_set_private_flags  (bfd *abfd, flagword flags)  ;

#define bfd_set_private_flags(abfd, flags) BFD_SEND (abfd, _bfd_set_private_flags, (abfd, flags))
#define bfd_sizeof_headers(abfd, reloc) BFD_SEND (abfd, _bfd_sizeof_headers, (abfd, reloc))

#define bfd_find_nearest_line(abfd, sec, syms, off, file, func, line) BFD_SEND (abfd, _bfd_find_nearest_line,  (abfd, sec, syms, off, file, func, line))

        /* Do these three do anything useful at all, for any back end?  */
#define bfd_debug_info_start(abfd) BFD_SEND (abfd, _bfd_debug_info_start, (abfd))

#define bfd_debug_info_end(abfd) BFD_SEND (abfd, _bfd_debug_info_end, (abfd))

#define bfd_debug_info_accumulate(abfd, section) BFD_SEND (abfd, _bfd_debug_info_accumulate, (abfd, section))


#define bfd_stat_arch_elt(abfd, stat) BFD_SEND (abfd, _bfd_stat_arch_elt,(abfd, stat))

#define bfd_update_armap_timestamp(abfd) BFD_SEND (abfd, _bfd_update_armap_timestamp, (abfd))

#define bfd_set_arch_mach(abfd, arch, mach) BFD_SEND ( abfd, _bfd_set_arch_mach, (abfd, arch, mach))

#define bfd_relax_section(abfd, section, link_info, again) BFD_SEND (abfd, _bfd_relax_section, (abfd, section, link_info, again))

#define bfd_link_hash_table_create(abfd) BFD_SEND (abfd, _bfd_link_hash_table_create, (abfd))

#define bfd_link_add_symbols(abfd, info) BFD_SEND (abfd, _bfd_link_add_symbols, (abfd, info))

#define bfd_final_link(abfd, info) BFD_SEND (abfd, _bfd_final_link, (abfd, info))

#define bfd_free_cached_info(abfd) BFD_SEND (abfd, _bfd_free_cached_info, (abfd))

#define bfd_get_dynamic_symtab_upper_bound(abfd) BFD_SEND (abfd, _bfd_get_dynamic_symtab_upper_bound, (abfd))

#define bfd_print_private_bfd_data(abfd, file)	BFD_SEND (abfd, _bfd_print_private_bfd_data, (abfd, file))

#define bfd_canonicalize_dynamic_symtab(abfd, asymbols) BFD_SEND (abfd, _bfd_canonicalize_dynamic_symtab, (abfd, asymbols))

#define bfd_get_dynamic_reloc_upper_bound(abfd) BFD_SEND (abfd, _bfd_get_dynamic_reloc_upper_bound, (abfd))

#define bfd_canonicalize_dynamic_reloc(abfd, arels, asyms) BFD_SEND (abfd, _bfd_canonicalize_dynamic_reloc, (abfd, arels, asyms))

extern bfd_byte *bfd_get_relocated_section_contents
	 (bfd *, struct bfd_link_info *,
		  struct bfd_link_order *, bfd_byte *,
		  boolean, asymbol **)  ;

symindex 
bfd_get_next_mapent  (bfd *abfd, symindex previous, carsym **sym)  ;

boolean 
bfd_set_archive_head  (bfd *output, bfd *new_head)  ;

bfd *
bfd_openr_next_archived_file  (bfd *archive, bfd *previous)  ;

const  char *
bfd_core_file_failing_command  (bfd *abfd)  ;

int 
bfd_core_file_failing_signal  (bfd *abfd)  ;

boolean 
core_file_matches_executable_p
  (bfd *core_bfd, bfd *exec_bfd)  ;

#define BFD_SEND(bfd, message, arglist) ((*((bfd)->xvec->message)) arglist)


#define BFD_SEND_FMT(bfd, message, arglist) (((bfd)->xvec->message[(int)((bfd)->format)]) arglist)


enum bfd_flavour {
  bfd_target_unknown_flavour,
  bfd_target_aout_flavour,
  bfd_target_coff_flavour,
  bfd_target_ecoff_flavour,
  bfd_target_elf_flavour,
  bfd_target_ieee_flavour,
  bfd_target_nlm_flavour,
  bfd_target_oasys_flavour,
  bfd_target_tekhex_flavour,
  bfd_target_srec_flavour,
  bfd_target_ihex_flavour,
  bfd_target_som_flavour,
  bfd_target_os9k_flavour,
  bfd_target_versados_flavour,
  bfd_target_msdos_flavour,
  bfd_target_evax_flavour
};

enum bfd_endian { BFD_ENDIAN_BIG, BFD_ENDIAN_LITTLE, BFD_ENDIAN_UNKNOWN };

 /* Forward declaration.  */
typedef struct bfd_link_info _bfd_link_info;

typedef struct bfd_target
{
  char *name;
  enum bfd_flavour flavour;
  enum bfd_endian byteorder;
  enum bfd_endian header_byteorder;
  flagword object_flags;       
  flagword section_flags;
  char symbol_leading_char;
  char ar_pad_char;            
  unsigned short ar_max_namelen;
  bfd_vma      (*bfd_getx64)  (const bfd_byte *)  ;
  bfd_signed_vma (*bfd_getx_signed_64)  (const bfd_byte *)  ;
  void         (*bfd_putx64)  (bfd_vma, bfd_byte *)  ;
  bfd_vma      (*bfd_getx32)  (const bfd_byte *)  ;
  bfd_signed_vma (*bfd_getx_signed_32)  (const bfd_byte *)  ;
  void         (*bfd_putx32)  (bfd_vma, bfd_byte *)  ;
  bfd_vma      (*bfd_getx16)  (const bfd_byte *)  ;
  bfd_signed_vma (*bfd_getx_signed_16)  (const bfd_byte *)  ;
  void         (*bfd_putx16)  (bfd_vma, bfd_byte *)  ;
  bfd_vma      (*bfd_h_getx64)  (const bfd_byte *)  ;
  bfd_signed_vma (*bfd_h_getx_signed_64)  (const bfd_byte *)  ;
  void         (*bfd_h_putx64)  (bfd_vma, bfd_byte *)  ;
  bfd_vma      (*bfd_h_getx32)  (const bfd_byte *)  ;
  bfd_signed_vma (*bfd_h_getx_signed_32)  (const bfd_byte *)  ;
  void         (*bfd_h_putx32)  (bfd_vma, bfd_byte *)  ;
  bfd_vma      (*bfd_h_getx16)  (const bfd_byte *)  ;
  bfd_signed_vma (*bfd_h_getx_signed_16)  (const bfd_byte *)  ;
  void         (*bfd_h_putx16)  (bfd_vma, bfd_byte *)  ;
  const struct bfd_target *(*_bfd_check_format[bfd_type_end])  (bfd *)  ;
  boolean             (*_bfd_set_format[bfd_type_end])  (bfd *)  ;
  boolean             (*_bfd_write_contents[bfd_type_end])  (bfd *)  ;

   /* Generic entry points.  */
#define BFD_JUMP_TABLE_GENERIC(NAME)CAT(NAME,_close_and_cleanup),CAT(NAME,_bfd_free_cached_info),CAT(NAME,_new_section_hook),CAT(NAME,_get_section_contents),CAT(NAME,_get_section_contents_in_window)

   /* Called when the BFD is being closed to do any necessary cleanup.  */
  boolean       (*_close_and_cleanup)  (bfd *)  ;
   /* Ask the BFD to free all cached information.  */
  boolean (*_bfd_free_cached_info)  (bfd *)  ;
   /* Called when a new section is created.  */
  boolean       (*_new_section_hook)  (bfd *, sec_ptr)  ;
   /* Read the contents of a section.  */
  boolean       (*_bfd_get_section_contents)  (bfd *, sec_ptr, void * , 
                                            file_ptr, bfd_size_type)  ;
  boolean       (*_bfd_get_section_contents_in_window)
                           (bfd *, sec_ptr, bfd_window *,
                                   file_ptr, bfd_size_type)  ;

   /* Entry points to copy private data.  */
#define BFD_JUMP_TABLE_COPY(NAME)CAT(NAME,_bfd_copy_private_bfd_data),CAT(NAME,_bfd_merge_private_bfd_data),CAT(NAME,_bfd_copy_private_section_data),CAT(NAME,_bfd_copy_private_symbol_data),CAT(NAME,_bfd_set_private_flags),CAT(NAME,_bfd_print_private_bfd_data) 
  boolean	 (*_bfd_copy_private_bfd_data)  (bfd *, bfd *)  ;
   /* Called to merge BFD general private data from one object file
     to a common output file when linking.  */
  boolean	 (*_bfd_merge_private_bfd_data)  (bfd *, bfd *)  ;
   /* Called to copy BFD private section data from one object file
     to another.  */
  boolean       (*_bfd_copy_private_section_data)  (bfd *, sec_ptr,
                                                       bfd *, sec_ptr)  ;
   /* Called to copy BFD private symbol data from one symbol 
     to another.  */
  boolean       (*_bfd_copy_private_symbol_data)  (bfd *, asymbol *,
							   bfd *, asymbol *)  ;
   /* Called to set private backend flags */
  boolean	 (*_bfd_set_private_flags)  (bfd *, flagword)  ;

   /* Called to print private BFD data */
  boolean       (*_bfd_print_private_bfd_data)  (bfd *, void * )  ;

   /* Core file entry points.  */
#define BFD_JUMP_TABLE_CORE(NAME)CAT(NAME,_core_file_failing_command),CAT(NAME,_core_file_failing_signal),CAT(NAME,_core_file_matches_executable_p)
  char *   (*_core_file_failing_command)  (bfd *)  ;
  int      (*_core_file_failing_signal)  (bfd *)  ;
  boolean  (*_core_file_matches_executable_p)  (bfd *, bfd *)  ;

   /* Archive entry points.  */
#define BFD_JUMP_TABLE_ARCHIVE(NAME)CAT(NAME,_slurp_armap),CAT(NAME,_slurp_extended_name_table),CAT(NAME,_construct_extended_name_table),CAT(NAME,_truncate_arname),CAT(NAME,_write_armap),CAT(NAME,_read_ar_hdr),CAT(NAME,_openr_next_archived_file),CAT(NAME,_get_elt_at_index),CAT(NAME,_generic_stat_arch_elt),CAT(NAME,_update_armap_timestamp)
  boolean  (*_bfd_slurp_armap)  (bfd *)  ;
  boolean  (*_bfd_slurp_extended_name_table)  (bfd *)  ;
  boolean  (*_bfd_construct_extended_name_table)
              (bfd *, char **, bfd_size_type *, const char **)  ;
  void     (*_bfd_truncate_arname)  (bfd *, const  char *, char *)  ;
  boolean  (*write_armap)  (bfd *arch, 
                              unsigned int elength,
                              struct orl *map,
                              unsigned int orl_count, 
                              int stridx)  ;
  void *  (*_bfd_read_ar_hdr_fn)  (bfd *)  ;
  bfd *    (*openr_next_archived_file)  (bfd *arch, bfd *prev)  ;
#define bfd_get_elt_at_index(b,i) BFD_SEND(b, _bfd_get_elt_at_index, (b,i))
  bfd *    (*_bfd_get_elt_at_index)  (bfd *, symindex)  ;
  int      (*_bfd_stat_arch_elt)  (bfd *, struct stat *)  ;
  boolean  (*_bfd_update_armap_timestamp)  (bfd *)  ;

   /* Entry points used for symbols.  */
#define BFD_JUMP_TABLE_SYMBOLS(NAME)CAT(NAME,_get_symtab_upper_bound),CAT(NAME,_get_symtab),CAT(NAME,_make_empty_symbol),CAT(NAME,_print_symbol),CAT(NAME,_get_symbol_info),CAT(NAME,_bfd_is_local_label_name),CAT(NAME,_get_lineno),CAT(NAME,_find_nearest_line),CAT(NAME,_bfd_make_debug_symbol),CAT(NAME,_read_minisymbols),CAT(NAME,_minisymbol_to_symbol)
  long  (*_bfd_get_symtab_upper_bound)  (bfd *)  ;
  long  (*_bfd_canonicalize_symtab)  (bfd *,
                                             struct symbol_cache_entry **)  ;
  struct symbol_cache_entry  *
                (*_bfd_make_empty_symbol)  (bfd *)  ;
  void          (*_bfd_print_symbol)  (bfd *, void * ,
                                      struct symbol_cache_entry *,
                                      bfd_print_symbol_type)  ;
#define bfd_print_symbol(b,p,s,e) BFD_SEND(b, _bfd_print_symbol, (b,p,s,e))
  void          (*_bfd_get_symbol_info)  (bfd *,
                                      struct symbol_cache_entry *,
                                      symbol_info *)  ;
#define bfd_get_symbol_info(b,p,e) BFD_SEND(b, _bfd_get_symbol_info, (b,p,e))
  boolean	 (*_bfd_is_local_label_name)  (bfd *, const char *)  ;

  alent *    (*_get_lineno)  (bfd *, struct symbol_cache_entry *)  ;
  boolean    (*_bfd_find_nearest_line)  (bfd *abfd,
                    struct sec *section, struct symbol_cache_entry **symbols,
                    bfd_vma offset, const  char **file, const  char **func,
                    unsigned int *line)  ;
  /* Back-door to allow format-aware applications to create debug symbols
    while using BFD for everything else.  Currently used by the assembler
    when creating COFF files.  */
  asymbol *  (*_bfd_make_debug_symbol)  (
       bfd *abfd,
       void *ptr,
       unsigned long size)  ;
#define bfd_read_minisymbols(b, d, m, s) BFD_SEND (b, _read_minisymbols, (b, d, m, s))
  long  (*_read_minisymbols)  (bfd *, boolean, void *  *,
                                      unsigned int *)  ;
#define bfd_minisymbol_to_symbol(b, d, m, f) BFD_SEND (b, _minisymbol_to_symbol, (b, d, m, f))
  asymbol *(*_minisymbol_to_symbol)  (bfd *, boolean, const void * ,
                                             asymbol *)  ;

   /* Routines for relocs.  */
#define BFD_JUMP_TABLE_RELOCS(NAME)CAT(NAME,_get_reloc_upper_bound),CAT(NAME,_canonicalize_reloc),CAT(NAME,_bfd_reloc_type_lookup)
  long  (*_get_reloc_upper_bound)  (bfd *, sec_ptr)  ;
  long  (*_bfd_canonicalize_reloc)  (bfd *, sec_ptr, arelent **,
                                            struct symbol_cache_entry **)  ;
   /* See documentation on reloc types.  */
  reloc_howto_type *
       (*reloc_type_lookup)  (bfd *abfd,
                                     bfd_reloc_code_real_type code)  ;

   /* Routines used when writing an object file.  */
#define BFD_JUMP_TABLE_WRITE(NAME)CAT(NAME,_set_arch_mach),CAT(NAME,_set_section_contents)
  boolean    (*_bfd_set_arch_mach)  (bfd *, enum bfd_architecture,
                    unsigned long)  ;
  boolean       (*_bfd_set_section_contents)  (bfd *, sec_ptr, void * ,
                                            file_ptr, bfd_size_type)  ;

   /* Routines used by the linker.  */
#define BFD_JUMP_TABLE_LINK(NAME)CAT(NAME,_sizeof_headers),CAT(NAME,_bfd_get_relocated_section_contents),CAT(NAME,_bfd_relax_section),CAT(NAME,_bfd_link_hash_table_create),CAT(NAME,_bfd_link_add_symbols),CAT(NAME,_bfd_final_link),CAT(NAME,_bfd_link_split_section)
  int        (*_bfd_sizeof_headers)  (bfd *, boolean)  ;
  bfd_byte * (*_bfd_get_relocated_section_contents)  (bfd *,
                    struct bfd_link_info *, struct bfd_link_order *,
                    bfd_byte *data, boolean relocateable,
                    struct symbol_cache_entry **)  ;

  boolean    (*_bfd_relax_section)  (bfd *, struct sec *,
                    struct bfd_link_info *, boolean *again)  ;

   /* Create a hash table for the linker.  Different backends store
     different information in this table.  */
  struct bfd_link_hash_table *(*_bfd_link_hash_table_create)  (bfd *)  ;

   /* Add symbols from this object file into the hash table.  */
  boolean (*_bfd_link_add_symbols)  (bfd *, struct bfd_link_info *)  ;

   /* Do a link based on the link_order structures attached to each
     section of the BFD.  */
  boolean (*_bfd_final_link)  (bfd *, struct bfd_link_info *)  ;

   /* Should this section be split up into smaller pieces during linking.  */
  boolean (*_bfd_link_split_section)  (bfd *, struct sec *)  ;

  /* Routines to handle dynamic symbols and relocs.  */
#define BFD_JUMP_TABLE_DYNAMIC(NAME)CAT(NAME,_get_dynamic_symtab_upper_bound),CAT(NAME,_canonicalize_dynamic_symtab),CAT(NAME,_get_dynamic_reloc_upper_bound),CAT(NAME,_canonicalize_dynamic_reloc)
   /* Get the amount of memory required to hold the dynamic symbols. */
  long  (*_bfd_get_dynamic_symtab_upper_bound)  (bfd *)  ;
   /* Read in the dynamic symbols.  */
  long  (*_bfd_canonicalize_dynamic_symtab)
     (bfd *, struct symbol_cache_entry **)  ;
   /* Get the amount of memory required to hold the dynamic relocs.  */
  long  (*_bfd_get_dynamic_reloc_upper_bound)  (bfd *)  ;
   /* Read in the dynamic relocs.  */
  long  (*_bfd_canonicalize_dynamic_reloc)
     (bfd *, arelent **, struct symbol_cache_entry **)  ;

 void *  backend_data;
} bfd_target;
boolean 
bfd_set_default_target   (const char *name)  ;

const bfd_target *
bfd_find_target  (const  char *target_name, bfd *abfd)  ;

const char **
bfd_target_list  (void)  ;

boolean 
bfd_check_format  (bfd *abfd, bfd_format format)  ;

boolean 
bfd_check_format_matches  (bfd *abfd, bfd_format format, char ***matching)  ;

boolean 
bfd_set_format  (bfd *abfd, bfd_format format)  ;

const  char *
bfd_format_string  (bfd_format format)  ;





typedef int (*fprintf_ftype)  (FILE*, const char*, ...)  ;

enum dis_insn_type {
  dis_noninsn,			/* Not a valid instruction */
  dis_nonbranch,		/* Not a branch instruction */
  dis_branch,			/* Unconditional branch */
  dis_condbranch,		/* Conditional branch */
  dis_jsr,			/* Jump to subroutine */
  dis_condjsr,			/* Conditional jump to subroutine */
  dis_dref,			/* Data reference instruction */
  dis_dref2			/* Two data references in instruction */
};

/* This struct is passed into the instruction decoding routine, 
   and is passed back out into each callback.  The various fields are used
   for conveying information from your main routine into your callbacks,
   for passing information into the instruction decoders (such as the
   addresses of the callback functions), or for passing information
   back from the instruction decoders to their callers.

   It must be initialized before it is first passed; this can be done
   by hand, or using one of the initialization macros below.  */

typedef struct disassemble_info {
  fprintf_ftype fprintf_func;
  FILE *stream;
  void *  application_data;

  /* Target description.  We could replace this with a pointer to the bfd,
     but that would require one.  There currently isn't any such requirement
     so to avoid introducing one we record these explicitly.  */
  /* The bfd_flavour.  This can be bfd_target_unknown_flavour.  */
  enum bfd_flavour flavour;
  /* The bfd_arch value.  */
  enum bfd_architecture arch;
  /* The bfd_mach value.  */
  unsigned long mach;
  /* Endianness (for bi-endian cpus).  Mono-endian cpus can ignore this.  */
  enum bfd_endian endian;
  /* The symbol at the start of the function being disassembled.  This
     is not set reliably, but if it is not NULL, it is correct.  */
  asymbol *symbol;

  /* For use by the disassembler.
     The top 16 bits are reserved for public use (and are documented here).
     The bottom 16 bits are for the internal use of the disassembler.  */
  unsigned long flags;
  void *  private_data;

  /* Function used to get bytes to disassemble.  MEMADDR is the
     address of the stuff to be disassembled, MYADDR is the address to
     put the bytes in, and LENGTH is the number of bytes to read.
     INFO is a pointer to this struct.
     Returns an errno value or 0 for success.  */
  int (*read_memory_func)
     (bfd_vma memaddr, bfd_byte *myaddr, int length,
	     struct disassemble_info *info)  ;

  /* Function which should be called if we get an error that we can't
     recover from.  STATUS is the errno value from read_memory_func and
     MEMADDR is the address that we were trying to read.  INFO is a
     pointer to this struct.  */
  void (*memory_error_func)
     (int status, bfd_vma memaddr, struct disassemble_info *info)  ;

  /* Function called to print ADDR.  */
  void (*print_address_func)
     (bfd_vma addr, struct disassemble_info *info)  ;

  /* These are for buffer_read_memory.  */
  bfd_byte *buffer;
  bfd_vma buffer_vma;
  int buffer_length;

  /* This variable may be set by the instruction decoder.  It suggests
      the number of bytes objdump should display on a single line.  If
      the instruction decoder sets this, it should always set it to
      the same value in order to get reasonable looking output.  */
  int bytes_per_line;

  /* the next two variables control the way objdump displays the raw data */
  /* For example, if bytes_per_line is 8 and bytes_per_chunk is 4, the */
  /* output will look like this:
     00:   00000000 00000000
     with the chunks displayed according to "display_endian". */
  int bytes_per_chunk;
  enum bfd_endian display_endian;

  /* Results from instruction decoders.  Not all decoders yet support
     this information.  This info is set each time an instruction is
     decoded, and is only valid for the last such instruction.

     To determine whether this decoder supports this information, set
     insn_info_valid to 0, decode an instruction, then check it.  */

  char insn_info_valid;		/* Branch info has been set. */
  char branch_delay_insns;	/* How many sequential insn's will run before
				   a branch takes effect.  (0 = normal) */
  char data_size;		/* Size of data reference in insn, in bytes */
  enum dis_insn_type insn_type;	/* Type of instruction */
  bfd_vma target;		/* Target address of branch or dref, if known;
				   zero if unknown.  */
  bfd_vma target2;		/* Second target address for dref2 */

} disassemble_info;


/* Standard disassemblers.  Disassemble one instruction at the given
   target address.  Return number of bytes processed.  */
typedef int (*disassembler_ftype)
      (bfd_vma, disassemble_info *)  ;

extern int print_insn_big_mips		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_little_mips	 (bfd_vma, disassemble_info*)  ;
extern int print_insn_i386		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_m68k		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_z8001		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_z8002		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_h8300		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_h8300h		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_h8300s		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_h8500		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_alpha		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_big_arm		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_little_arm	 (bfd_vma, disassemble_info*)  ;
extern int print_insn_sparc		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_big_a29k		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_little_a29k	 (bfd_vma, disassemble_info*)  ;
extern int print_insn_i960		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_sh		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_shl		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_hppa		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_m32r		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_m88k		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_mn10200		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_mn10300		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_ns32k		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_big_powerpc	 (bfd_vma, disassemble_info*)  ;
extern int print_insn_little_powerpc	 (bfd_vma, disassemble_info*)  ;
extern int print_insn_rs6000		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_w65		 (bfd_vma, disassemble_info*)  ;
extern int print_insn_d10v		 (bfd_vma, disassemble_info*)  ;

/* Fetch the disassembler for a given BFD, if that support is available.  */
extern disassembler_ftype disassembler	 (bfd *)  ;


/* This block of definitions is for particular callers who read instructions
   into a buffer before calling the instruction decoder.  */

/* Here is a function which callers may wish to use for read_memory_func.
   It gets bytes from a buffer.  */
extern int buffer_read_memory
   (bfd_vma, bfd_byte *, int, struct disassemble_info *)  ;

/* This function goes with buffer_read_memory.
   It prints a message using info->fprintf_func and info->stream.  */
extern void perror_memory  (int, bfd_vma, struct disassemble_info *)  ;


/* Just print the address in hex.  This is included for completeness even
   though both GDB and objdump provide their own (to print symbolic
   addresses).  */
extern void generic_print_address
   (bfd_vma, struct disassemble_info *)  ;

/* Macro to initialize a disassemble_info struct.  This should be called
   by all applications creating such a struct.  */
#define INIT_DISASSEMBLE_INFO(INFO, STREAM, FPRINTF_FUNC) (INFO).flavour = bfd_target_unknown_flavour, (INFO).arch = bfd_arch_unknown, (INFO).mach = 0, (INFO).endian = BFD_ENDIAN_UNKNOWN, INIT_DISASSEMBLE_INFO_NO_ARCH(INFO, STREAM, FPRINTF_FUNC)

/* Call this macro to initialize only the internal variables for the
   disassembler.  Architecture dependent things such as byte order, or machine
   variant are not touched by this macro.  This makes things much easier for
   GDB which must initialize these things seperatly.  */

#define INIT_DISASSEMBLE_INFO_NO_ARCH(INFO, STREAM, FPRINTF_FUNC) (INFO).fprintf_func = (FPRINTF_FUNC), (INFO).stream = (STREAM), (INFO).symbol = NULL, (INFO).buffer = NULL, (INFO).buffer_vma = 0, (INFO).buffer_length = 0, (INFO).read_memory_func = buffer_read_memory, (INFO).memory_error_func = perror_memory, (INFO).print_address_func = generic_print_address, (INFO).flags = 0, (INFO).bytes_per_line = 0, (INFO).bytes_per_chunk = 0, (INFO).display_endian = BFD_ENDIAN_UNKNOWN, (INFO).insn_info_valid = 0



/* Random host-dependent support code.
   Copyright (C) 1995, 1997 Free Software Foundation, Inc.
   Written by Ken Raeburn.

This file is part of libopcodes, the opcodes library.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

/* Do system-dependent stuff, mainly driven by autoconf-detected info.

   Well, some generic common stuff is done here too, like including
   ansidecl.h.  That's because the .h files in bfd/hosts files I'm
   trying to replace often did that.  If it can be dropped from this
   file (check in a non-ANSI environment!), it should be.  */

/* config.h.  Generated automatically by configure.  */
/* config.in.  Generated automatically from configure.in by autoheader.  */

/* Define if you have the <stdlib.h> header file.  */
#define HAVE_STDLIB_H 1

/* Define if you have the <string.h> header file.  */
#define HAVE_STRING_H 1

/* Define if you have the <strings.h> header file.  */
#define HAVE_STRINGS_H 1





/* Copyright (C) 1991, 92, 93, 94, 95, 96, 97 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/*
 *	ISO S Standard: 4.10 GENERAL UTILITIES	<stdlib.h>
 */



#define	_STDLIB_H	1


/* Get size_t, wchar_t and NULL from <stddef.h>.  */
#define	__need_size_t
#define	__need_wchar_t
#define	__need_NULL





/* Any one of these symbols __need_* means that GNU libc
   wants us just to define one data type.  So don't define
   the symbols that indicate this file's entire job has been done.  */



/* This avoids lossage on SunOS but only if stdtypes.h comes first.
   There's no way to win with the other order!  Sun lossage.  */

/* On 4.3bsd-net2, make sure ansi.h is included, so we have
   one less case to deal with in the following.  */


/* In 4.3bsd-net2, machine/ansi.h defines these symbols, which are
   defined if the corresponding type is *not* defined.
   FreeBSD-2.1 defines _MACHINE_ANSI_H_ instead of _ANSI_H_ */


/* Sequent's header files use _PTRDIFF_T_ in some conflicting way.
   Just ignore it.  */


/* On VxWorks, <type/vxTypesBase.h> may have defined macros like
   _TYPE_size_t which will typedef size_t.  fixincludes patched the
   vxTypesBase.h so that this macro is only defined if _GCC_SIZE_T is
   not defined, and so that defining this macro defines _GCC_SIZE_T.
   If we find that the macros are still defined at this point, we must
   invoke them so that the type is defined as expected.  */




/* In case nobody has defined these types, but we aren't running under
   GCC 2.00, make sure that __PTRDIFF_TYPE__, __SIZE__TYPE__, and
   __WCHAR_TYPE__ have reasonable values.  This can happen if the
   parts of GCC is compiled by an older compiler, that actually
   include gstddef.h, such as collect2.  */

/* Signed type of difference of two pointers.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */


/* Unsigned type of `sizeof' something.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */






/* Wide character type.
   Locale-writers should change this as necessary to
   be big enough to hold unique values not between 0 and 127,
   and not (wchar_t) -1, for each defined multibyte character.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */













#define _WCHAR_T
#define _T_WCHAR_
#define _T_WCHAR
#define __WCHAR_T
#define _WCHAR_T_
#define _BSD_WCHAR_T_
#define _WCHAR_T_DEFINED_
#define _WCHAR_T_DEFINED
#define _WCHAR_T_H
#define ___int_wchar_t_h
#define __INT_WCHAR_T_H
#define _GCC_WCHAR_T

/* On BSD/386 1.1, at least, machine/ansi.h defines _BSD_WCHAR_T_
   instead of _WCHAR_T_, and _BSD_RUNE_T_ (which, unlike the other
   symbols in the _FOO_T_ family, stays defined even after its
   corresponding type is defined).  If we define wchar_t, then we
   must undef _WCHAR_T_; for BSD/386 1.1 (and perhaps others), if
   we undef _WCHAR_T_, then we must also define rune_t, since 
   headers like runetype.h assume that if machine/ansi.h is included,
   and _BSD_WCHAR_T_ is not defined, then rune_t is available.
   machine/ansi.h says, "Note that _WCHAR_T_ and _RUNE_T_ must be of
   the same type." */







typedef unsigned int wchar_t;


















/*  In 4.3bsd-net2, leave these undefined to indicate that size_t, etc.
    are already defined.  */
















 

/* Returned by `div'.  */
typedef struct
  {
    int quot;			/* Quotient.  */
    int rem;			/* Remainder.  */
  } div_t;

/* Returned by `ldiv'.  */
typedef struct
  {
    long int quot;		/* Quotient.  */
    long int rem;		/* Remainder.  */
  } ldiv_t;


/* Returned by `lldiv'.  */
typedef struct
  {
    long long int quot;		/* Quotient.  */
    long long int rem;		/* Remainder.  */
  } lldiv_t;



/* The largest number rand will return (same as INT_MAX).  */
#define	RAND_MAX	2147483647


/* We define these the same for all machines.
   Changes from this to the outside world should be done in `_exit'.  */
#define	EXIT_FAILURE	1	
#define	EXIT_SUCCESS	0	


/* Maximum length of a multibyte character in the current locale.  */
#define	MB_CUR_MAX	(__ctype_get_mb_cur_max ())
extern int __ctype_get_mb_cur_max  (void)  ;


/* Convert a string to a floating-point number.  */
extern double atof  (__const char *__nptr)  ;
/* Convert a string to an integer.  */
extern int atoi  (__const char *__nptr)  ;
/* Convert a string to a long integer.  */
extern long int atol  (__const char *__nptr)  ;


/* These functions will part of the standard C library in ISO C 9X.  */
extern long long int atoll  (__const char *__nptr)  ;


/* Convert a string to a floating-point number.  */
extern double strtod  (__const char *__nptr, char **__endptr)  ;


/* Likewise for `float' and `long double' sizes of floating-point numbers.  */
extern float strtof  (__const char *__nptr, char **__endptr)  ;
extern long double  strtold  (__const char *__nptr, char **__endptr)  ;


/* Convert a string to a long integer.  */
extern long int strtol  (__const char *__nptr, char **__endptr,
			     int __base)  ;
/* Convert a string to an unsigned long integer.  */
extern unsigned long int strtoul  (__const char *__nptr,
				       char **__endptr, int __base)  ;


/* Convert a string to a quadword integer.  */
extern long long int strtoq  (__const char *__nptr, char **__endptr,
				  int __base)  ;
/* Convert a string to an unsigned quadword integer.  */
extern unsigned long long int strtouq  (__const char *__nptr,
					    char **__endptr, int __base)  ;



/* These functions will part of the standard C library in ISO C 9X.  */

/* Convert a string to a quadword integer.  */
extern long long int strtoll  (__const char *__nptr, char **__endptr,
				   int __base)  ;
/* Convert a string to an unsigned quadword integer.  */
extern unsigned long long int strtoull  (__const char *__nptr,
					     char **__endptr, int __base)  ;




/* The internal entry points for `strtoX' take an extra flag argument
   saying whether or not to parse locale-dependent number grouping.  */

extern double __strtod_internal  (__const char *__nptr,
				      char **__endptr, int __group)  ;
extern float __strtof_internal  (__const char *__nptr, char **__endptr,
				     int __group)  ;
extern long double  __strtold_internal  (__const char *__nptr,
						char **__endptr, int __group)  ;
extern long int __strtol_internal  (__const char *__nptr, char **__endptr,
					int __base, int __group)  ;
extern unsigned long int __strtoul_internal  (__const char *__nptr,
						  char **__endptr, int __base,
						  int __group)  ;

extern long long int __strtoq_internal  (__const char *__nptr,
					     char **__endptr, int __base,
					     int __group)  ;
extern unsigned long long int __strtouq_internal  (__const char *__nptr,
						       char **__endptr,
						       int __base,
						       int __group)  ;



/* Define inline functions which call the internal entry points.  */

extern __inline double strtod (__const char *__nptr, char **__endptr)
{ return __strtod_internal (__nptr, __endptr, 0); }
extern __inline long int strtol (__const char *__nptr,
				 char **__endptr, int __base)
{ return __strtol_internal (__nptr, __endptr, __base, 0); }
extern __inline unsigned long int strtoul (__const char *__nptr,
					   char **__endptr, int __base)
{ return __strtoul_internal (__nptr, __endptr, __base, 0); }


extern __inline float strtof (__const char *__nptr, char **__endptr)
{ return __strtof_internal (__nptr, __endptr, 0); }
extern __inline long double  strtold (__const char *__nptr, char **__endptr)
{ return __strtold_internal (__nptr, __endptr, 0); }



extern __inline long long int strtoq (__const char *__nptr, char **__endptr,
				      int __base)
{ return __strtoq_internal (__nptr, __endptr, __base, 0); }
extern __inline unsigned long long int strtouq (__const char *__nptr,
						char **__endptr, int __base)
{ return __strtouq_internal (__nptr, __endptr, __base, 0); }



extern __inline long long int strtoll (__const char *__nptr, char **__endptr,
				       int __base)
{ return __strtoq_internal (__nptr, __endptr, __base, 0); }
extern __inline unsigned long long int strtoull (__const char *__nptr,
						 char **__endptr, int __base)
{ return __strtouq_internal (__nptr, __endptr, __base, 0); }


extern __inline double atof (__const char *__nptr)
{ return strtod (__nptr, (char **) ((void *)0) ); }
extern __inline int atoi (__const char *__nptr)
{ return (int) strtol (__nptr, (char **) ((void *)0) , 10); }
extern __inline long int atol (__const char *__nptr)
{ return strtol (__nptr, (char **) ((void *)0) , 10); }


extern __inline long long int atoll (__const char *__nptr)
{ return strtoll (__nptr, (char **) ((void *)0) , 10); }





/* Convert N to base 64 using the digits "./0-9A-Za-z", least-significant
   digit first.  Returns a pointer to static storage overwritten by the
   next call.  */
extern char *l64a  (long int __n)  ;

/* Read a number from a string S in base 64 as above.  */
extern long int a64l  (__const char *__s)  ;


/* Copyright (C) 1991, 1992, 1994, 1995, 1996 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/*
 *	POSIX Standard: 2.6 Primitive System Data Types	<sys/types.h>
 */



#define	_SYS_TYPES_H	1


 




typedef __u_char u_char;
typedef __u_short u_short;
typedef __u_int u_int;
typedef __u_long u_long;
typedef __quad_t quad_t;
typedef __u_quad_t u_quad_t;
typedef __fsid_t fsid_t;


typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __ino_t ino_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __off_t off_t;
typedef __loff_t loff_t;
typedef __pid_t pid_t;
typedef __uid_t uid_t;


typedef __ssize_t ssize_t;
#define ssize_t ssize_t



typedef __daddr_t daddr_t;
typedef __caddr_t caddr_t;



typedef __key_t key_t;


#define	__need_time_t
/* Copyright (C) 1991, 92, 93, 94, 95, 96, 97 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/*
 *	ISO C Standard: 4.12 DATE and TIME	<time.h>
 */
















#define	__time_t_defined	1



/* Returned by `time'.  */
typedef __time_t time_t;


















#define	__need_size_t





/* Any one of these symbols __need_* means that GNU libc
   wants us just to define one data type.  So don't define
   the symbols that indicate this file's entire job has been done.  */



/* This avoids lossage on SunOS but only if stdtypes.h comes first.
   There's no way to win with the other order!  Sun lossage.  */

/* On 4.3bsd-net2, make sure ansi.h is included, so we have
   one less case to deal with in the following.  */


/* In 4.3bsd-net2, machine/ansi.h defines these symbols, which are
   defined if the corresponding type is *not* defined.
   FreeBSD-2.1 defines _MACHINE_ANSI_H_ instead of _ANSI_H_ */


/* Sequent's header files use _PTRDIFF_T_ in some conflicting way.
   Just ignore it.  */


/* On VxWorks, <type/vxTypesBase.h> may have defined macros like
   _TYPE_size_t which will typedef size_t.  fixincludes patched the
   vxTypesBase.h so that this macro is only defined if _GCC_SIZE_T is
   not defined, and so that defining this macro defines _GCC_SIZE_T.
   If we find that the macros are still defined at this point, we must
   invoke them so that the type is defined as expected.  */




/* In case nobody has defined these types, but we aren't running under
   GCC 2.00, make sure that __PTRDIFF_TYPE__, __SIZE__TYPE__, and
   __WCHAR_TYPE__ have reasonable values.  This can happen if the
   parts of GCC is compiled by an older compiler, that actually
   include gstddef.h, such as collect2.  */

/* Signed type of difference of two pointers.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */


/* Unsigned type of `sizeof' something.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */






/* Wide character type.
   Locale-writers should change this as necessary to
   be big enough to hold unique values not between 0 and 127,
   and not (wchar_t) -1, for each defined multibyte character.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */




/*  In 4.3bsd-net2, leave these undefined to indicate that size_t, etc.
    are already defined.  */




/* A null pointer constant.  */













/* Old compatibility names for C types.  */
typedef unsigned long int ulong;
typedef unsigned short int ushort;
typedef unsigned int uint;


/* These size-specific names are used by some of the inet code.  */



/* For GCC 2.7 and later, we can use specific type-size attributes.  */
#define __intN_t(N, MODE) typedef int int##N##_t __attribute__ ((__mode__ (MODE)))
#define __u_intN_t(N, MODE) typedef unsigned int u_int##N##_t __attribute__ ((__mode__ (MODE)))

typedef int int8_t __attribute__ ((__mode__ (  __QI__ ))) ;
typedef unsigned int u_int8_t __attribute__ ((__mode__ (  __QI__ ))) ;
typedef int int16_t __attribute__ ((__mode__ (  __HI__ ))) ;
typedef unsigned int u_int16_t __attribute__ ((__mode__ (  __HI__ ))) ;
typedef int int32_t __attribute__ ((__mode__ (  __SI__ ))) ;
typedef unsigned int u_int32_t __attribute__ ((__mode__ (  __SI__ ))) ;
typedef int int64_t __attribute__ ((__mode__ (  __DI__ ))) ;
typedef unsigned int u_int64_t __attribute__ ((__mode__ (  __DI__ ))) ;

typedef int register_t __attribute__ ((__mode__ (__word__)));


/* Some code from BIND tests this macro to see if the types above are
   defined.  */
#define __BIT_TYPES_DEFINED__	1




/* In BSD <sys/types.h> is expected to define BYTE_ORDER.  */
/* Copyright (C) 1992, 1996 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */


#define	_ENDIAN_H	1


/* Definitions for byte order, according to significance of bytes, from low
   addresses to high addresses.  The value is what you get by putting '4'
   in the most significant byte, '3' in the second most significant byte,
   '2' in the second least significant byte, and '1' in the least
   significant byte.  */

#define	__LITTLE_ENDIAN	1234
#define	__BIG_ENDIAN	4321
#define	__PDP_ENDIAN	3412

/* This file defines `__BYTE_ORDER' for the particular machine.  */
/* Alpha is little-endian.  */

#define __BYTE_ORDER __LITTLE_ENDIAN



#define	LITTLE_ENDIAN	__LITTLE_ENDIAN
#define	BIG_ENDIAN	__BIG_ENDIAN
#define	PDP_ENDIAN	__PDP_ENDIAN
#define	BYTE_ORDER	__BYTE_ORDER





/* It also defines `fd_set' and the FD_* macros for `select'.  */
/* `fd_set' type and related macros, and `select'/`pselect' declarations.
   Copyright (C) 1996, 1997 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/*	POSIX 1003.1g: 6.2 Select from File Descriptor Sets <sys/select.h>  */



#define _SYS_SELECT_H	1


/* Get definition of needed basic types.  */


/* Get __FD_* definitions.  */
/* Copyright (C) 1997 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */


#define _SELECTBITS_H	1

/* This line MUST be split!  Otherwise m4 will not change it.  */
#define __FD_ZERO(set) ((void) memset ((__ptr_t) (set), 0, sizeof (fd_set)))
#define __FD_SET(d, set)	((set)->fds_bits[__FDELT(d)] |= __FDMASK(d))
#define __FD_CLR(d, set)	((set)->fds_bits[__FDELT(d)] &= ~__FDMASK(d))
#define __FD_ISSET(d, set)	((set)->fds_bits[__FDELT(d)] & __FDMASK(d))




/* Get definition of timer specification structures.  */
#define __need_timespec
/* Copyright (C) 1991, 92, 93, 94, 95, 96, 97 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/*
 *	ISO C Standard: 4.12 DATE and TIME	<time.h>
 */




















#define	__timespec_defined	1

/* POSIX.4 structure for a time value.  This is like a `struct timeval' but
   has nanoseconds instead of microseconds.  */
struct timespec
  {
    long int tv_sec;		/* Seconds.  */
    long int tv_nsec;		/* Nanoseconds.  */
  };














 

/* This declaration puts `struct timeval' in global scope even if
   <sys/time.h> has not been included to define it.  That way the
   `select' prototype below will not conflict with a later definition
   of `struct timeval'.  */
struct timeval;

typedef __fd_mask fd_mask;

/* Representation of a set of file descriptors.  */
typedef __fd_set fd_set;

/* Maximum number of file descriptors in `fd_set'.  */
#define	FD_SETSIZE		__FD_SETSIZE


/* Number of bits per word of `fd_set' (some code assumes this is 32).  */
#define	NFDBITS			__NFDBITS



/* Access macros for `fd_set'.  */
#define	FD_SET(fd, fdsetp)	__FD_SET ((fd), (fdsetp))
#define	FD_CLR(fd, fdsetp)	__FD_CLR ((fd), (fdsetp))
#define	FD_ISSET(fd, fdsetp)	__FD_ISSET ((fd), (fdsetp))
#define	FD_ZERO(fdsetp)		__FD_ZERO (fdsetp)


/* Check the first NFDS descriptors each in READFDS (if not NULL) for read
   readiness, in WRITEFDS (if not NULL) for write readiness, and in EXCEPTFDS
   (if not NULL) for exceptional conditions.  If TIMEOUT is not NULL, time out
   after waiting the interval specified therein.  Returns the number of ready
   descriptors, or -1 for errors.  */
extern int __select  (int __nfds, __fd_set *__readfds,
			  __fd_set *__writefds, __fd_set *__exceptfds,
			  struct timeval *__timeout)  ;
extern int select  (int __nfds, __fd_set *__readfds,
			__fd_set *__writefds, __fd_set *__exceptfds,
			struct timeval *__timeout)  ;

/* Same as above only that the TIMEOUT value is given with higher
   resolution.  This version should be used.  */
extern int __pselect  (int __nfds, __fd_set *__readfds,
			   __fd_set *__writefds, __fd_set *__exceptfds,
			   struct timespec *__timeout)  ;
extern int pselect  (int __nfds, __fd_set *__readfds,
			 __fd_set *__writefds, __fd_set *__exceptfds,
			 struct timespec *__timeout)  ;

 






 




/* These are the functions that actually do things.  The `random', `srandom',
   `initstate' and `setstate' functions are those from BSD Unices.
   The `rand' and `srand' functions are required by the ANSI standard.
   We provide both interfaces to the same random number generator.  */
/* Return a random long integer between 0 and RAND_MAX inclusive.  */
extern int32_t __random  (void)  ;
extern int32_t random  (void)  ;

/* Seed the random number generator with the given number.  */
extern void __srandom  (unsigned int __seed)  ;
extern void srandom  (unsigned int __seed)  ;

/* Initialize the random number generator to use state buffer STATEBUF,
   of length STATELEN, and seed it with SEED.  Optimal lengths are 8, 16,
   32, 64, 128 and 256, the bigger the better; values less than 8 will
   cause an error and values greater than 256 will be rounded down.  */
extern void *  __initstate  (unsigned int __seed, void *  __statebuf,
				 size_t __statelen)  ;
extern void *  initstate  (unsigned int __seed, void *  __statebuf,
			       size_t __statelen)  ;

/* Switch the random number generator to state buffer STATEBUF,
   which should have been previously initialized by `initstate'.  */
extern void *  __setstate  (void *  __statebuf)  ;
extern void *  setstate  (void *  __statebuf)  ;



/* Reentrant versions of the `random' family of functions.
   These functions all use the following data structure to contain
   state, rather than global state variables.  */

struct random_data
  {
    int32_t *fptr;		/* Front pointer.  */
    int32_t *rptr;		/* Rear pointer.  */
    int32_t *state;		/* Array of state values.  */
    int rand_type;		/* Type of random number generator.  */
    int rand_deg;		/* Degree of random number generator.  */
    int rand_sep;		/* Distance between front and rear.  */
    int32_t *end_ptr;		/* Pointer behind state table.  */
  };

extern int __random_r  (struct random_data *__buf, int32_t *__result)  ;
extern int random_r  (struct random_data *__buf, int32_t *__result)  ;

extern int __srandom_r  (unsigned int __seed, struct random_data *__buf)  ;
extern int srandom_r  (unsigned int __seed, struct random_data *__buf)  ;

extern int __initstate_r  (unsigned int __seed, void *  __statebuf,
			       size_t __statelen, struct random_data *__buf)  ;
extern int initstate_r  (unsigned int __seed, void *  __statebuf,
			     size_t __statelen, struct random_data *__buf)  ;

extern int __setstate_r  (void *  __statebuf, struct random_data *__buf)  ;
extern int setstate_r  (void *  __statebuf, struct random_data *__buf)  ;




/* Return a random integer between 0 and RAND_MAX inclusive.  */
extern int rand  (void)  ;
/* Seed the random number generator with the given number.  */
extern void srand  (unsigned int __seed)  ;


/* Reentrant interface according to POSIX.1.  */
extern int __rand_r  (unsigned int *__seed)  ;
extern int rand_r  (unsigned int *__seed)  ;




/* System V style 48-bit random number generator functions.  */

/* Return non-negative, double-precision floating-point value in [0.0,1.0).  */
extern double drand48  (void)  ;
extern double erand48  (unsigned short int __xsubi[3])  ;

/* Return non-negative, long integer in [0,2^31).  */
extern long lrand48  (void)  ;
extern long nrand48  (unsigned short int __xsubi[3])  ;

/* Return signed, long integers in [-2^31,2^31).  */
extern long mrand48  (void)  ;
extern long jrand48  (unsigned short int __xsubi[3])  ;

/* Seed random number generator.  */
extern void srand48  (long __seedval)  ;
extern unsigned short int *seed48  (unsigned short int __seed16v[3])  ;
extern void lcong48  (unsigned short int __param[7])  ;

/* Data structure for communication with thread safe versions.  */
struct drand48_data
  {
    unsigned short int X[3];	/* Current state.  */
    unsigned short int a[3];	/* Factor in congruential formula.  */
    unsigned short int c;	/* Additive const. in congruential formula.  */
    unsigned short int old_X[3]; /* Old state.  */
    int init;			/* Flag for initializing.  */
  };


/* Return non-negative, double-precision floating-point value in [0.0,1.0).  */
extern int drand48_r  (struct drand48_data *__buffer, double *__result)  ;
extern int erand48_r  (unsigned short int __xsubi[3],
			   struct drand48_data *__buffer, double *__result)  ;

/* Return non-negative, long integer in [0,2^31).  */
extern int lrand48_r  (struct drand48_data *__buffer, long *__result)  ;
extern int nrand48_r  (unsigned short int __xsubi[3],
			   struct drand48_data *__buffer, long *__result)  ;

/* Return signed, long integers in [-2^31,2^31).  */
extern int mrand48_r  (struct drand48_data *__buffer, long *__result)  ;
extern int jrand48_r  (unsigned short int __xsubi[3],
			   struct drand48_data *__buffer, long *__result)  ;

/* Seed random number generator.  */
extern int srand48_r  (long __seedval, struct drand48_data *__buffer)  ;
extern int seed48_r  (unsigned short int __seed16v[3],
			  struct drand48_data *__buffer)  ;
extern int lcong48_r  (unsigned short int __param[7],
			   struct drand48_data *__buffer)  ;


/* Internal function to compute next state of the generator.  */
extern int __drand48_iterate  (unsigned short int __xsubi[3],
				   struct drand48_data *__buffer)  ;



/* Allocate SIZE bytes of memory.  */
extern void *  malloc  (size_t __size)  ;
/* Re-allocate the previously allocated block
   in __ptr_t, making the new block SIZE bytes long.  */
extern void *  realloc  (void *  __ptr, size_t __size)  ;
/* Allocate NMEMB elements of SIZE bytes each, all initialized to 0.  */
extern void *  calloc  (size_t __nmemb, size_t __size)  ;
/* Free a block allocated by `malloc', `realloc' or `calloc'.  */
extern void free  (void *  __ptr)  ;


/* Free a block.  An alias for `free'.	(Sun Unices).  */
extern void cfree  (void *  __ptr)  ;



/* Copyright (C) 1992, 1996, 1997 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */


#define	_ALLOCA_H	1



#define	__need_size_t





/* Any one of these symbols __need_* means that GNU libc
   wants us just to define one data type.  So don't define
   the symbols that indicate this file's entire job has been done.  */



/* This avoids lossage on SunOS but only if stdtypes.h comes first.
   There's no way to win with the other order!  Sun lossage.  */

/* On 4.3bsd-net2, make sure ansi.h is included, so we have
   one less case to deal with in the following.  */


/* In 4.3bsd-net2, machine/ansi.h defines these symbols, which are
   defined if the corresponding type is *not* defined.
   FreeBSD-2.1 defines _MACHINE_ANSI_H_ instead of _ANSI_H_ */


/* Sequent's header files use _PTRDIFF_T_ in some conflicting way.
   Just ignore it.  */


/* On VxWorks, <type/vxTypesBase.h> may have defined macros like
   _TYPE_size_t which will typedef size_t.  fixincludes patched the
   vxTypesBase.h so that this macro is only defined if _GCC_SIZE_T is
   not defined, and so that defining this macro defines _GCC_SIZE_T.
   If we find that the macros are still defined at this point, we must
   invoke them so that the type is defined as expected.  */




/* In case nobody has defined these types, but we aren't running under
   GCC 2.00, make sure that __PTRDIFF_TYPE__, __SIZE__TYPE__, and
   __WCHAR_TYPE__ have reasonable values.  This can happen if the
   parts of GCC is compiled by an older compiler, that actually
   include gstddef.h, such as collect2.  */

/* Signed type of difference of two pointers.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */


/* Unsigned type of `sizeof' something.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */






/* Wide character type.
   Locale-writers should change this as necessary to
   be big enough to hold unique values not between 0 and 127,
   and not (wchar_t) -1, for each defined multibyte character.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */




/*  In 4.3bsd-net2, leave these undefined to indicate that size_t, etc.
    are already defined.  */




/* A null pointer constant.  */












 

/* Remove any previous definitions.  */



/* Allocate a block that will be freed when the calling function exits.  */
extern void *  __alloca  (size_t __size)  ;
extern void *  alloca  (size_t __size)  ;


#define __alloca(size)	__builtin_alloca (size)
#define alloca(size)	__alloca (size)


 






/* Allocate SIZE bytes on a page boundary.  The storage cannot be freed.  */
extern void *  valloc  (size_t __size)  ;



/* Abort execution and generate a core-dump.  */
extern void abort  (void)   __attribute__ ((__noreturn__));


/* Register a function to be called when `exit' is called.  */
extern int atexit  (void (*__func) (void))  ;


/* Register a function to be called with the status
   given to `exit' and the given argument.  */
extern int __on_exit  (void (*__func) (int __status, void *  __arg),
			   void *  __arg)  ;
extern int on_exit  (void (*__func) (int __status, void *  __arg),
			 void *  __arg)  ;


/* Call all functions registered with `atexit' and `on_exit',
   in the reverse of the order in which they were registered
   perform stdio cleanup, and terminate program execution with STATUS.  */
extern void exit  (int __status)   __attribute__ ((__noreturn__));


/* Return the value of envariable NAME, or NULL if it doesn't exist.  */
extern char *getenv  (__const char *__name)  ;

/* This function is similar to the above but returns NULL if the
   programs is running with SUID or SGID enabled.  */
extern char *__secure_getenv  (__const char *__name)  ;


/* The SVID says this is in <stdio.h>, but this seems a better place.	*/
/* Put STRING, which is of the form "NAME=VALUE", in the environment.
   If there is no `=', remove NAME from the environment.  */
extern int putenv  (__const char *__string)  ;



/* Set NAME to VALUE in the environment.
   If REPLACE is nonzero, overwrite an existing value.  */
extern int setenv  (__const char *__name, __const char *__value,
			int __replace)  ;

/* Remove the variable NAME from the environment.  */
extern void unsetenv  (__const char *__name)  ;



/* The `clearenv' was planned to be added to POSIX.1 but probably
   never made it.  Nevertheless the POSIX.9 standard (POSIX bindings
   for Fortran 77) requires this function.  */
extern int __clearenv  (void)  ;
extern int clearenv  (void)  ;




/* Generate a unique temporary file name from TEMPLATE.
   The last six characters of TEMPLATE must be "XXXXXX";
   they are replaced with a string that makes the file name unique.
   Returns TEMPLATE, or a null pointer if it cannot get a unique file name.  */
extern char *mktemp  (char *__template)  ;

/* Generate a unique temporary file name from TEMPLATE.
   The last six characters of TEMPLATE must be "XXXXXX";
   they are replaced with a string that makes the filename unique.
   Returns a file descriptor open on the file for reading and writing,
   or -1 if it cannot create a uniquely-named file.  */
extern int mkstemp  (char *__template)  ;



/* Execute the given line as a shell command.  */
extern int system  (__const char *__command)  ;



/* Return a malloc'd string containing the canonical absolute name of the
   named file.  The last file name component need not exist, and may be a
   symlink to a nonexistent file.  */
extern char *canonicalize_file_name  (__const char *__name)  ;



/* Return the canonical absolute name of file NAME.  The last file name
   component need not exist, and may be a symlink to a nonexistent file.
   If RESOLVED is null, the result is malloc'd; otherwise, if the canonical
   name is PATH_MAX chars or more, returns null with `errno' set to
   ENAMETOOLONG; if the name fits in fewer than PATH_MAX chars, returns the
   name in RESOLVED.  */
extern char *realpath  (__const char *__name, char *__resolved)  ;



/* Shorthand for type of comparison functions.  */

#define __COMPAR_FN_T
typedef int (*__compar_fn_t)  (__const void * , __const void * )  ;



typedef __compar_fn_t comparison_fn_t;


/* Do a binary search for KEY in BASE, which consists of NMEMB elements
   of SIZE bytes each, using COMPAR to perform the comparisons.  */
extern void *  bsearch  (__const void *  __key, __const void *  __base,
			     size_t __nmemb, size_t __size,
			     __compar_fn_t __compar)  ;

/* Sort NMEMB elements of BASE, of SIZE bytes each,
   using COMPAR to perform the comparisons.  */
extern void qsort  (void *  __base, size_t __nmemb, size_t __size,
			__compar_fn_t __compar)  ;


/* Return the absolute value of X.  */
extern int abs  (int __x)   __attribute__ ((__const__));
extern long int labs  (long int __x)   __attribute__ ((__const__));

extern long long int llabs  (long long int __x)   __attribute__ ((__const__));



/* Return the `div_t', `ldiv_t' or `lldiv_t' representation
   of the value of NUMER over DENOM. */
/* GCC may have built-ins for these someday.  */
extern div_t div  (int __numer, int __denom)   __attribute__ ((__const__));
extern ldiv_t ldiv  (long int __numer, long int __denom)   __attribute__ ((__const__));

extern lldiv_t lldiv  (long long int __numer, long long int __denom)   __attribute__ ((__const__));




/* Convert floating point numbers to strings.  The returned values are
   valid only until another call to the same function.  */

/* Convert VALUE to a string with NDIGIT digits and return a pointer to
   this.  Set *DECPT with the position of the decimal character and *SIGN
   with the sign of the number.  */
extern char *ecvt  (double __value, int __ndigit, int *__decpt,
			int *__sign)  ;

/* Convert VALUE to a string rounded to NDIGIT decimal digits.  Set *DECPT
   with the position of the decimal character and *SIGN with the sign of
   the number.  */
extern char *fcvt  (double __value, int __ndigit, int *__decpt,
			int *__sign)  ;

/* If possible convert VALUE to a string with NDIGIT significant digits.
   Otherwise use exponential representation.  The resulting string will
   be written to BUF.  */
extern char *gcvt  (double __value, int __ndigit, char *__buf)  ;

/* Long double versions of above functions.  */
extern char *qecvt  (long double  __value, int __ndigit, int *__decpt,
			 int *__sign)  ;
extern char *qfcvt  (long double  __value, int __ndigit, int *__decpt,
			 int *__sign)  ;
extern char *qgcvt  (long double  __value, int __ndigit, char *__buf)  ;



/* Reentrant version of the functions above which provide their own
   buffers.  */
extern int ecvt_r  (double __value, int __ndigit, int *__decpt,
			int *__sign, char *__buf, size_t __len)  ;
extern int fcvt_r  (double __value, int __ndigit, int *__decpt,
			int *__sign, char *__buf, size_t __len)  ;

extern int qecvt_r  (long double  __value, int __ndigit, int *__decpt,
			 int *__sign, char *__buf, size_t __len)  ;
extern int qfcvt_r  (long double  __value, int __ndigit, int *__decpt,
			 int *__sign, char *__buf, size_t __len)  ;




/* Return the length of the multibyte character
   in S, which is no longer than N.  */
extern int mblen  (__const char *__s, size_t __n)  ;
/* Return the length of the given multibyte character,
   putting its `wchar_t' representation in *PWC.  */
extern int mbtowc  (wchar_t *__pwc, __const char *__s, size_t __n)  ;
/* Put the multibyte character represented
   by WCHAR in S, returning its length.  */
extern int wctomb  (char *__s, wchar_t __wchar)  ;


extern __inline int mblen (__const char *__s, size_t __n)
{ return mbtowc ((wchar_t *) ((void *)0) , __s, __n); }



/* Convert a multibyte string to a wide char string.  */
extern size_t mbstowcs  (wchar_t *__pwcs, __const char *__s, size_t __n)  ;
/* Convert a wide char string to multibyte string.  */
extern size_t wcstombs  (char *__s, __const wchar_t *__pwcs, size_t __n)  ;



/* Determine whether the string value of RESPONSE matches the affirmation
   or negative response expression as specified by the LC_MESSAGES category
   in the program's current locale.  Returns 1 if affirmative, 0 if
   negative, and -1 if not matching.  */
extern int rpmatch  (__const char *__response)  ;




/* Parse comma separated suboption from *OPTIONP and match against
   strings in TOKENS.  If found return index and set *VALUEP to
   optional value introduced by an equal sign.  If the suboption is
   not part of TOKENS return in *VALUEP beginning of unknown
   suboption.  On exit *OPTIONP is set to the beginning of the next
   otken or at the terminating NUL character.  */
extern int getsubopt  (char **__optionp, __const char *__const *__tokens,
			   char **__valuep)  ;





/* Setup DES tables according KEY.  */
extern void setkey  (__const char *__key)  ;



 






/* Copyright (C) 1991, 92, 93, 95, 96, 97 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/*
 *	ISO C Standard: 4.11 STRING HANDLING	<string.h>
 */



#define	_STRING_H	1


 

/* Get size_t and NULL from <stddef.h>.  */
#define	__need_size_t
#define	__need_NULL





/* Any one of these symbols __need_* means that GNU libc
   wants us just to define one data type.  So don't define
   the symbols that indicate this file's entire job has been done.  */



/* This avoids lossage on SunOS but only if stdtypes.h comes first.
   There's no way to win with the other order!  Sun lossage.  */

/* On 4.3bsd-net2, make sure ansi.h is included, so we have
   one less case to deal with in the following.  */


/* In 4.3bsd-net2, machine/ansi.h defines these symbols, which are
   defined if the corresponding type is *not* defined.
   FreeBSD-2.1 defines _MACHINE_ANSI_H_ instead of _ANSI_H_ */


/* Sequent's header files use _PTRDIFF_T_ in some conflicting way.
   Just ignore it.  */


/* On VxWorks, <type/vxTypesBase.h> may have defined macros like
   _TYPE_size_t which will typedef size_t.  fixincludes patched the
   vxTypesBase.h so that this macro is only defined if _GCC_SIZE_T is
   not defined, and so that defining this macro defines _GCC_SIZE_T.
   If we find that the macros are still defined at this point, we must
   invoke them so that the type is defined as expected.  */




/* In case nobody has defined these types, but we aren't running under
   GCC 2.00, make sure that __PTRDIFF_TYPE__, __SIZE__TYPE__, and
   __WCHAR_TYPE__ have reasonable values.  This can happen if the
   parts of GCC is compiled by an older compiler, that actually
   include gstddef.h, such as collect2.  */

/* Signed type of difference of two pointers.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */


/* Unsigned type of `sizeof' something.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */






/* Wide character type.
   Locale-writers should change this as necessary to
   be big enough to hold unique values not between 0 and 127,
   and not (wchar_t) -1, for each defined multibyte character.  */

/* Define this type if we are doing the whole job,
   or if we want this type in particular.  */




/*  In 4.3bsd-net2, leave these undefined to indicate that size_t, etc.
    are already defined.  */















/* Copy N bytes of SRC to DEST.  */
extern void *  memcpy  (void *  __dest, __const void *  __src,
			    size_t __n)  ;
/* Copy N bytes of SRC to DEST, guaranteeing
   correct behavior for overlapping strings.  */
extern void *  memmove  (void *  __dest, __const void *  __src,
			     size_t __n)  ;

/* Copy no more than N bytes of SRC to DEST, stopping when C is found.
   Return the position in DEST one byte past where C was copied,
   or NULL if C was not found in the first N bytes of SRC.  */
extern void *  __memccpy  (void *  __dest, __const void *  __src,
			       int __c, size_t __n)  ;

extern void *  memccpy  (void *  __dest, __const void *  __src,
			     int __c, size_t __n)  ;



/* Set N bytes of S to C.  */
extern void *  memset  (void *  __s, int __c, size_t __n)  ;

/* Compare N bytes of S1 and S2.  */
extern int memcmp  (__const void *  __s1, __const void *  __s2,
			size_t __n)  ;

/* Search N bytes of S for C.  */
extern void *  memchr  (__const void *  __s, int __c, size_t __n)  ;


/* Copy SRC to DEST.  */
extern char *strcpy  (char *__dest, __const char *__src)  ;
/* Copy no more than N characters of SRC to DEST.  */
extern char *strncpy  (char *__dest, __const char *__src, size_t __n)  ;

/* Append SRC onto DEST.  */
extern char *strcat  (char *__dest, __const char *__src)  ;
/* Append no more than N characters from SRC onto DEST.  */
extern char *strncat  (char *__dest, __const char *__src, size_t __n)  ;

/* Compare S1 and S2.  */
extern int strcmp  (__const char *__s1, __const char *__s2)  ;
/* Compare N characters of S1 and S2.  */
extern int strncmp  (__const char *__s1, __const char *__s2, size_t __n)  ;

/* Compare the collated forms of S1 and S2.  */
extern int strcoll  (__const char *__s1, __const char *__s2)  ;
/* Put a transformation of SRC into no more than N bytes of DEST.  */
extern size_t strxfrm  (char *__dest, __const char *__src, size_t __n)  ;


/* Duplicate S, returning an identical malloc'd string.  */
extern char *__strdup  (__const char *__s)  ;
extern char *strdup  (__const char *__s)  ;


/* Return a malloc'd copy of at most N bytes of STRING.  The
   resultant string is terminated even if no null terminator
   appears before STRING[N].  */
extern char *__strndup  (__const char *__string, size_t __n)  ;

extern char *strndup  (__const char *__string, size_t __n)  ;



/* Duplicate S, returning an identical alloca'd string.  */
#define strdupa(s)	(__extension__	({	__const char *__old = (s);	size_t __len = strlen (__old) + 1;	char *__new = __builtin_alloca (__len);	memcpy (__new, __old, __len);	}))

/* Return an alloca'd copy of at most N bytes of string.  */
#define strndupa(s, n)	(__extension__	({	__const char *__old = (s);	size_t __len = strnlen (__old, (n));	char *__new = __builtin_alloca (__len + 1);	__new[__len] = '\0';	memcpy (__new, __old, __len);	}))


/* Find the first occurrence of C in S.  */
extern char *strchr  (__const char *__s, int __c)  ;
/* Find the last occurrence of C in S.  */
extern char *strrchr  (__const char *__s, int __c)  ;

/* Return the length of the initial segment of S which
   consists entirely of characters not in REJECT.  */
extern size_t strcspn  (__const char *__s, __const char *__reject)  ;
/* Return the length of the initial segment of S which
   consists entirely of characters in ACCEPT.  */
extern size_t strspn  (__const char *__s, __const char *__accept)  ;
/* Find the first occurrence in S of any character in ACCEPT.  */
extern char *strpbrk  (__const char *__s, __const char *__accept)  ;
/* Find the first occurrence of NEEDLE in HAYSTACK.  */
extern char *strstr  (__const char *__haystack, __const char *__needle)  ;
/* Divide S into tokens separated by characters in DELIM.  */
extern char *strtok  (char *__s, __const char *__delim)  ;


/* Divide S into tokens separated by characters in DELIM.  Information
   passed between calls are stored in SAVE_PTR.  */
extern char *strtok_r  (char *__s, __const char *__delim,
			    char **__save_ptr)  ;



/* Find the first occurrence of NEEDLE in HAYSTACK.
   NEEDLE is NEEDLELEN bytes long;
   HAYSTACK is HAYSTACKLEN bytes long.  */
extern void *  memmem  (__const void *  __haystack, size_t __haystacklen,
			    __const void *  __needle, size_t __needlelen)  ;



/* Return the length of S.  */
extern size_t strlen  (__const char *__s)  ;


/* Find the length of STRING, but scan at most MAXLEN characters.
   If no '\0' terminator is found in that many characters, return MAXLEN.  */
extern size_t strnlen  (__const char *__string, size_t __maxlen)  ;


extern __inline size_t
strnlen (__const char *__string, size_t __maxlen)
{
  __const char *__end = (__const char *) memchr (__string, '\0', __maxlen);
  return __end ? __end - __string : __maxlen;
}




/* Return a string describing the meaning of the `errno' code in ERRNUM.  */
extern char *strerror  (int __errnum)  ;

/* Reentrant version of `strerror'.  If a temporary buffer is required, at
   most BUFLEN bytes of BUF will be used.  */
extern char *__strerror_r  (int __errnum, char *__buf, size_t __buflen)  ;
extern char *strerror_r  (int __errnum, char *__buf, size_t __buflen)  ;



/* Copy N bytes of SRC to DEST (like memmove, but args reversed).  */
extern void bcopy  (__const void *  __src, void *  __dest, size_t __n)  ;

/* Set N bytes of S to 0.  */
extern void bzero  (void *  __s, size_t __n)  ;

/* Compare N bytes of S1 and S2 (same as memcmp).  */
extern int bcmp  (__const void *  __s1, __const void *  __s2, size_t __n)  ;

/* Find the first occurrence of C in S (same as strchr).  */
extern char *index  (__const char *__s, int __c)  ;

/* Find the last occurrence of C in S (same as strrchr).  */
extern char *rindex  (__const char *__s, int __c)  ;

/* Return the position of the first bit set in I, or 0 if none are set.
   The least-significant bit is position 1, the most-significant 32.  */
extern int ffs  (int __i)  ;

/* Compare S1 and S2, ignoring case.  */
extern int __strcasecmp  (__const char *__s1, __const char *__s2)  ;
extern int strcasecmp  (__const char *__s1, __const char *__s2)  ;

/* Compare no more than N chars of S1 and S2, ignoring case.  */
extern int __strncasecmp  (__const char *__s1, __const char *__s2,
			       size_t __n)  ;
extern int strncasecmp  (__const char *__s1, __const char *__s2,
			     size_t __n)  ;



/* Return the next DELIM-delimited token from *STRINGP,
   terminating it with a '\0', and update *STRINGP to point past it.  */
extern char *__strsep  (char **__stringp, __const char *__delim)  ;
extern char *strsep  (char **__stringp, __const char *__delim)  ;



/* Return a string describing the meaning of the signal number in SIG.  */
extern char *strsignal  (int __sig)  ;

/* Copy SRC to DEST, returning the address of the terminating '\0' in DEST.  */
extern char *__stpcpy  (char *__dest, __const char *__src)  ;
extern char *stpcpy  (char *__dest, __const char *__src)  ;

/* Copy no more than N characters of SRC to DEST, returning the address of
   the last character written into DEST.  */
extern char *__stpncpy  (char *__dest, __const char *__src, size_t __n)  ;
extern char *stpncpy  (char *__dest, __const char *__src, size_t __n)  ;

/* Sautee STRING briskly.  */
extern char *strfry  (char *__string)  ;

/* Frobnicate N bytes of S.  */
extern void *  memfrob  (void *  __s, size_t __n)  ;



/* Return the file name within directory of FILENAME.  */
extern char *basename  (__const char *__filename)  ;


 






#define MAXLEN 20

/* Copyright (C) 1991, 92, 93, 94, 95, 96, 97 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/*
 *	ISO C Standard: 4.6 NON-LOCAL JUMPS	<setjmp.h>
 */



#define	_SETJMP_H	1


 

/* Get the machine-dependent definition of `__jmp_buf'.  */
/* Define the machine-dependent type `jmp_buf'.  Alpha version.
Copyright (C) 1992 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

typedef struct
  {
    /* Integer registers:
           $0 is the return value;
	   $1-$8, $22-$25, $28 are call-used;
	   $9-$14 we save here;
	   $15 is the FP and we save it here;
	   $16-$21 are input arguments (call-used);
	   $26 is the return PC and we save it here;
	   $27 is the procedure value (i.e., the address of __setjmp);
	   $29 is the global pointer, which the caller will reconstruct
	   from the return address restored in $26;
	   $30 is the stack pointer and we save it here;
	   $31 is always zero.  */
    long int __9, __10, __11, __12, __13, __14;
    long int *__pc, *__fp, *__sp;


    /* Floating-point registers:
           $f0 is the floating return value;
	   $f1, $f10-$f15, $f22-$f30 are call-used;
	   $f2-$f9 we save here;
	   $f16-$21 are input args (call-used);
	   $f31 is always zero.  */
    double __f2, __f3, __f4, __f5, __f6, __f7, __f8, __f9;

  } __jmp_buf[1];

/* __sig_atomic_t, __sigset_t, and related definitions.  Linux version.
   Copyright (C) 1991, 1992, 1994, 1996, 1997 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */


#define	_SIGSET_H_types	1

typedef int __sig_atomic_t;

/* A `sigset_t' has a bit for each signal.  */

#define _SIGSET_NWORDS	(1024 / (8 * sizeof (unsigned long int)))
typedef struct
  {
    unsigned long int __val[(1024 / (8 * sizeof (unsigned long int))) ];
  } __sigset_t;




/* We only want to define these functions if <signal.h> was actually
   included; otherwise we were included just to define the types.  Since we
   are namespace-clean, it wouldn't hurt to define extra macros.  But
   trouble can be caused by functions being defined (e.g., any global
   register vars declared later will cause compilation errors).  */




/* Calling environment, plus possibly a saved signal mask.  */
typedef struct __jmp_buf_tag	/* C++ doesn't like tagless structs.  */
  {
    /* NOTE: The machine-dependent definitions of `__sigsetjmp'
       assume that a `jmp_buf' begins with a `__jmp_buf'.
       Do not move this member or add others before it.  */
    __jmp_buf __jmpbuf;		/* Calling environment.  */
    int __mask_was_saved;	/* Saved the signal mask?  */
    __sigset_t __saved_mask;	/* Saved signal mask.  */
  } jmp_buf[1];


/* Store the calling environment in ENV, also saving the
   signal mask if SAVEMASK is nonzero.  Return 0.
   This is the internal name for `sigsetjmp'.  */
extern int __sigsetjmp  (jmp_buf __env, int __savemask)  ;


/* Set ENV to the current position and return 0, not saving the signal mask.
   This is just like `sigsetjmp (ENV, 0)'.
   The ISO C standard says `setjmp' is a macro.  */
#define	setjmp(env)	__sigsetjmp ((env), 0)



/* Set ENV to the current position and return 0, not saving the signal mask.
   This is the 4.3 BSD name for ISO `setjmp'.  */
#define _setjmp(env)	__sigsetjmp ((env), 0)



/* Jump to the environment saved in ENV, making the
   `setjmp' call there return VAL, or 1 if VAL is 0.  */
extern void longjmp  (jmp_buf __env, int __val)  
     __attribute__ ((__noreturn__));

/* Same.  Usually `_longjmp' is used with `_setjmp', which does not save
   the signal mask.  But it is how ENV was saved that determines whether
   `longjmp' restores the mask; `_longjmp' is just an alias.  */
extern void _longjmp  (jmp_buf __env, int __val)  
     __attribute__ ((__noreturn__));


/* Internal machine-dependent function to restore context sans signal mask.  */
extern void __longjmp  (__jmp_buf __env, int __val)  
     __attribute__ ((__noreturn__));

/* Internal function to possibly save the current mask of blocked signals
   in ENV, and always set the flag saying whether or not it was saved.
   This is used by the machine-dependent definition of `__sigsetjmp'.
   Always returns zero, for convenience.  */
extern int __sigjmp_save  (jmp_buf __env, int __savemask)  ;



/* Use the same type for `jmp_buf' and `sigjmp_buf'.
   The `__mask_was_saved' flag determines whether
   or not `longjmp' will restore the signal mask.  */
typedef jmp_buf sigjmp_buf;

/* Store the calling environment in ENV, also saving the
   signal mask if SAVEMASK is nonzero.  Return 0.  */
#define	sigsetjmp(env, savemask)	__sigsetjmp ((env), (savemask))

/* Jump to the environment saved in ENV, making the
   sigsetjmp call there return VAL, or 1 if VAL is 0.
   Restore the signal mask if that sigsetjmp call saved it.
   This is just an alias `longjmp'.  */
extern void siglongjmp  (sigjmp_buf __env, int __val)  
     __attribute__ ((__noreturn__));


 




static int fetch_data  (struct disassemble_info *, bfd_byte *)  ;

struct dis_private
{
  /* Points to first byte not fetched.  */
  bfd_byte *max_fetched;
  bfd_byte the_buffer[20 ];
  bfd_vma insn_start;
  jmp_buf bailout;
};

/* Make sure that bytes from INFO->PRIVATE_DATA->BUFFER (inclusive)
   to ADDR (exclusive) are valid.  Returns 1 for success, longjmps
   on error.  */
#define FETCH_DATA(info, addr) ((addr) <= ((struct dis_private *)(info->private_data))->max_fetched ? 1 : fetch_data ((info), (addr)))

static int
fetch_data (info, addr)
     struct disassemble_info *info;
     bfd_byte *addr;
{
  int status;
  struct dis_private *priv = (struct dis_private *)info->private_data;
  bfd_vma start = priv->insn_start + (priv->max_fetched - priv->the_buffer);

  status = (*info->read_memory_func) (start,
				      priv->max_fetched,
				      addr - priv->max_fetched,
				      info);
  if (status != 0)
    {
      (*info->memory_error_func) (status, start, info);
      longjmp (priv->bailout, 1);
    }
  else
    priv->max_fetched = addr;
  return 1;
}

#define Eb OP_E, b_mode
#define indirEb OP_indirE, b_mode
#define Gb OP_G, b_mode
#define Ev OP_E, v_mode
#define indirEv OP_indirE, v_mode
#define Ew OP_E, w_mode
#define Ma OP_E, v_mode
#define M OP_E, 0
#define Mp OP_E, 0		
#define Gv OP_G, v_mode
#define Gw OP_G, w_mode
#define Rw OP_rm, w_mode
#define Rd OP_rm, d_mode
#define Ib OP_I, b_mode
#define sIb OP_sI, b_mode	
#define Iv OP_I, v_mode
#define Iw OP_I, w_mode
#define Jb OP_J, b_mode
#define Jv OP_J, v_mode

#define Cd OP_C, d_mode
#define Dd OP_D, d_mode
#define Td OP_T, d_mode

#define eAX OP_REG, eAX_reg
#define eBX OP_REG, eBX_reg
#define eCX OP_REG, eCX_reg
#define eDX OP_REG, eDX_reg
#define eSP OP_REG, eSP_reg
#define eBP OP_REG, eBP_reg
#define eSI OP_REG, eSI_reg
#define eDI OP_REG, eDI_reg
#define AL OP_REG, al_reg
#define CL OP_REG, cl_reg
#define DL OP_REG, dl_reg
#define BL OP_REG, bl_reg
#define AH OP_REG, ah_reg
#define CH OP_REG, ch_reg
#define DH OP_REG, dh_reg
#define BH OP_REG, bh_reg
#define AX OP_REG, ax_reg
#define DX OP_REG, dx_reg
#define indirDX OP_REG, indir_dx_reg

#define Sw OP_SEG, w_mode
#define Ap OP_DIR, lptr
#define Av OP_DIR, v_mode
#define Ob OP_OFF, b_mode
#define Ov OP_OFF, v_mode
#define Xb OP_DSSI, b_mode
#define Xv OP_DSSI, v_mode
#define Yb OP_ESDI, b_mode
#define Yv OP_ESDI, v_mode

#define es OP_REG, es_reg
#define ss OP_REG, ss_reg
#define cs OP_REG, cs_reg
#define ds OP_REG, ds_reg
#define fs OP_REG, fs_reg
#define gs OP_REG, gs_reg

#define MX OP_MMX, 0
#define EM OP_EM, v_mode
#define MS OP_MS, b_mode

typedef int (*op_rtn)  (int bytemode, int aflag, int dflag)  ;

static int OP_E  (int, int, int)  ;
static int OP_G  (int, int, int)  ;
static int OP_I  (int, int, int)  ;
static int OP_indirE  (int, int, int)  ;
static int OP_sI  (int, int, int)  ;
static int OP_REG  (int, int, int)  ;
static int OP_J  (int, int, int)  ;
static int OP_DIR  (int, int, int)  ;
static int OP_OFF  (int, int, int)  ;
static int OP_ESDI  (int, int, int)  ;
static int OP_DSSI  (int, int, int)  ;
static int OP_SEG  (int, int, int)  ;
static int OP_C  (int, int, int)  ;
static int OP_D  (int, int, int)  ;
static int OP_T  (int, int, int)  ;
static int OP_rm  (int, int, int)  ;
static int OP_ST  (int, int, int)  ;
static int OP_STi   (int, int, int)  ;

static int OP_MMX  (int, int, int)  ;
static int OP_EM  (int, int, int)  ;
static int OP_MS  (int, int, int)  ;

static void append_prefix  (void)  ;
static void set_op  (int op)  ;
static void putop  (char *template, int aflag, int dflag)  ;
static void dofloat  (int aflag, int dflag)  ;
static int get16  (void)  ;
static int get32  (void)  ;
static void ckprefix  (void)  ;

#define b_mode 1
#define v_mode 2
#define w_mode 3
#define d_mode 4

#define es_reg 100
#define cs_reg 101
#define ss_reg 102
#define ds_reg 103
#define fs_reg 104
#define gs_reg 105
#define eAX_reg 107
#define eCX_reg 108
#define eDX_reg 109
#define eBX_reg 110
#define eSP_reg 111
#define eBP_reg 112
#define eSI_reg 113
#define eDI_reg 114

#define lptr 115

#define al_reg 116
#define cl_reg 117
#define dl_reg 118
#define bl_reg 119
#define ah_reg 120
#define ch_reg 121
#define dh_reg 122
#define bh_reg 123

#define ax_reg 124
#define cx_reg 125
#define dx_reg 126
#define bx_reg 127
#define sp_reg 128
#define bp_reg 129
#define si_reg 130
#define di_reg 131

#define indir_dx_reg 150

#define GRP1b NULL, NULL, 0
#define GRP1S NULL, NULL, 1
#define GRP1Ss NULL, NULL, 2
#define GRP2b NULL, NULL, 3
#define GRP2S NULL, NULL, 4
#define GRP2b_one NULL, NULL, 5
#define GRP2S_one NULL, NULL, 6
#define GRP2b_cl NULL, NULL, 7
#define GRP2S_cl NULL, NULL, 8
#define GRP3b NULL, NULL, 9
#define GRP3S NULL, NULL, 10
#define GRP4  NULL, NULL, 11
#define GRP5  NULL, NULL, 12
#define GRP6  NULL, NULL, 13
#define GRP7 NULL, NULL, 14
#define GRP8 NULL, NULL, 15
#define GRP9 NULL, NULL, 16
#define GRP10 NULL, NULL, 17
#define GRP11 NULL, NULL, 18
#define GRP12 NULL, NULL, 19

#define FLOATCODE 50
#define FLOAT NULL, NULL, FLOATCODE

struct dis386 {
  char *name;
  op_rtn op1;
  int bytemode1;
  op_rtn op2;
  int bytemode2;
  op_rtn op3;
  int bytemode3;
};

static struct dis386 dis386[] = {
  /* 00 */
  { "addb",	OP_E, 1  , OP_G, 1   },
  { "addS",	OP_E, 2  , OP_G, 2   },
  { "addb",	OP_G, 1  , OP_E, 1   },
  { "addS",	OP_G, 2  , OP_E, 2   },
  { "addb",	OP_REG, 116  , OP_I, 1   },
  { "addS",	OP_REG, 107  , OP_I, 2   },
  { "pushl",	OP_REG, 100   },
  { "popl",	OP_REG, 100   },
  /* 08 */
  { "orb",	OP_E, 1  , OP_G, 1   },
  { "orS",	OP_E, 2  , OP_G, 2   },
  { "orb",	OP_G, 1  , OP_E, 1   },
  { "orS",	OP_G, 2  , OP_E, 2   },
  { "orb",	OP_REG, 116  , OP_I, 1   },
  { "orS",	OP_REG, 107  , OP_I, 2   },
  { "pushl",	OP_REG, 101   },
  { "(bad)" },	/* 0x0f extended opcode escape */
  /* 10 */
  { "adcb",	OP_E, 1  , OP_G, 1   },
  { "adcS",	OP_E, 2  , OP_G, 2   },
  { "adcb",	OP_G, 1  , OP_E, 1   },
  { "adcS",	OP_G, 2  , OP_E, 2   },
  { "adcb",	OP_REG, 116  , OP_I, 1   },
  { "adcS",	OP_REG, 107  , OP_I, 2   },
  { "pushl",	OP_REG, 102   },
  { "popl",	OP_REG, 102   },
  /* 18 */
  { "sbbb",	OP_E, 1  , OP_G, 1   },
  { "sbbS",	OP_E, 2  , OP_G, 2   },
  { "sbbb",	OP_G, 1  , OP_E, 1   },
  { "sbbS",	OP_G, 2  , OP_E, 2   },
  { "sbbb",	OP_REG, 116  , OP_I, 1   },
  { "sbbS",	OP_REG, 107  , OP_I, 2   },
  { "pushl",	OP_REG, 103   },
  { "popl",	OP_REG, 103   },
  /* 20 */
  { "andb",	OP_E, 1  , OP_G, 1   },
  { "andS",	OP_E, 2  , OP_G, 2   },
  { "andb",	OP_G, 1  , OP_E, 1   },
  { "andS",	OP_G, 2  , OP_E, 2   },
  { "andb",	OP_REG, 116  , OP_I, 1   },
  { "andS",	OP_REG, 107  , OP_I, 2   },
  { "(bad)" },			/* SEG ES prefix */
  { "daa" },
  /* 28 */
  { "subb",	OP_E, 1  , OP_G, 1   },
  { "subS",	OP_E, 2  , OP_G, 2   },
  { "subb",	OP_G, 1  , OP_E, 1   },
  { "subS",	OP_G, 2  , OP_E, 2   },
  { "subb",	OP_REG, 116  , OP_I, 1   },
  { "subS",	OP_REG, 107  , OP_I, 2   },
  { "(bad)" },			/* SEG CS prefix */
  { "das" },
  /* 30 */
  { "xorb",	OP_E, 1  , OP_G, 1   },
  { "xorS",	OP_E, 2  , OP_G, 2   },
  { "xorb",	OP_G, 1  , OP_E, 1   },
  { "xorS",	OP_G, 2  , OP_E, 2   },
  { "xorb",	OP_REG, 116  , OP_I, 1   },
  { "xorS",	OP_REG, 107  , OP_I, 2   },
  { "(bad)" },			/* SEG SS prefix */
  { "aaa" },
  /* 38 */
  { "cmpb",	OP_E, 1  , OP_G, 1   },
  { "cmpS",	OP_E, 2  , OP_G, 2   },
  { "cmpb",	OP_G, 1  , OP_E, 1   },
  { "cmpS",	OP_G, 2  , OP_E, 2   },
  { "cmpb",	OP_REG, 116  , OP_I, 1   },
  { "cmpS",	OP_REG, 107  , OP_I, 2   },
  { "(bad)" },			/* SEG DS prefix */
  { "aas" },
  /* 40 */
  { "incS",	OP_REG, 107   },
  { "incS",	OP_REG, 108   },
  { "incS",	OP_REG, 109   },
  { "incS",	OP_REG, 110   },
  { "incS",	OP_REG, 111   },
  { "incS",	OP_REG, 112   },
  { "incS",	OP_REG, 113   },
  { "incS",	OP_REG, 114   },
  /* 48 */
  { "decS",	OP_REG, 107   },
  { "decS",	OP_REG, 108   },
  { "decS",	OP_REG, 109   },
  { "decS",	OP_REG, 110   },
  { "decS",	OP_REG, 111   },
  { "decS",	OP_REG, 112   },
  { "decS",	OP_REG, 113   },
  { "decS",	OP_REG, 114   },
  /* 50 */
  { "pushS",	OP_REG, 107   },
  { "pushS",	OP_REG, 108   },
  { "pushS",	OP_REG, 109   },
  { "pushS",	OP_REG, 110   },
  { "pushS",	OP_REG, 111   },
  { "pushS",	OP_REG, 112   },
  { "pushS",	OP_REG, 113   },
  { "pushS",	OP_REG, 114   },
  /* 58 */
  { "popS",	OP_REG, 107   },
  { "popS",	OP_REG, 108   },
  { "popS",	OP_REG, 109   },
  { "popS",	OP_REG, 110   },
  { "popS",	OP_REG, 111   },
  { "popS",	OP_REG, 112   },
  { "popS",	OP_REG, 113   },
  { "popS",	OP_REG, 114   },
  /* 60 */
  { "pusha" },
  { "popa" },
  { "boundS",	OP_G, 2  , OP_E, 2   },
  { "arpl",	OP_E, 3  , OP_G, 3   },
  { "(bad)" },			/* seg fs */
  { "(bad)" },			/* seg gs */
  { "(bad)" },			/* op size prefix */
  { "(bad)" },			/* adr size prefix */
  /* 68 */
  { "pushS",	OP_I, 2   },		/* 386 book wrong */
  { "imulS",	OP_G, 2  , OP_E, 2  , OP_I, 2   },
  { "pushl",	OP_sI, 1   },		/* push of byte really pushes 4 bytes */
  { "imulS",	OP_G, 2  , OP_E, 2  , OP_I, 1   },
  { "insb",	OP_ESDI, 1  , OP_REG, 150   },
  { "insS",	OP_ESDI, 2  , OP_REG, 150   },
  { "outsb",	OP_REG, 150  , OP_DSSI, 1   },
  { "outsS",	OP_REG, 150  , OP_DSSI, 2   },
  /* 70 */
  { "jo",	OP_J, 1   },
  { "jno",	OP_J, 1   },
  { "jb",	OP_J, 1   },
  { "jae",	OP_J, 1   },
  { "je",	OP_J, 1   },
  { "jne",	OP_J, 1   },
  { "jbe",	OP_J, 1   },
  { "ja",	OP_J, 1   },
  /* 78 */
  { "js",	OP_J, 1   },
  { "jns",	OP_J, 1   },
  { "jp",	OP_J, 1   },
  { "jnp",	OP_J, 1   },
  { "jl",	OP_J, 1   },
  { "jnl",	OP_J, 1   },
  { "jle",	OP_J, 1   },
  { "jg",	OP_J, 1   },
  /* 80 */
  { ((void *)0) , ((void *)0) , 0  },
  { ((void *)0) , ((void *)0) , 1  },
  { "(bad)" },
  { ((void *)0) , ((void *)0) , 2  },
  { "testb",	OP_E, 1  , OP_G, 1   },
  { "testS",	OP_E, 2  , OP_G, 2   },
  { "xchgb",	OP_E, 1  , OP_G, 1   },
  { "xchgS",	OP_E, 2  , OP_G, 2   },
  /* 88 */
  { "movb",	OP_E, 1  , OP_G, 1   },
  { "movS",	OP_E, 2  , OP_G, 2   },
  { "movb",	OP_G, 1  , OP_E, 1   },
  { "movS",	OP_G, 2  , OP_E, 2   },
  { "movw",	OP_E, 3  , OP_SEG, 3   },
  { "leaS",	OP_G, 2  , OP_E, 0  },
  { "movw",	OP_SEG, 3  , OP_E, 3   },
  { "popS",	OP_E, 2   },
  /* 90 */
  { "nop" },
  { "xchgS",	OP_REG, 108  , OP_REG, 107   },
  { "xchgS",	OP_REG, 109  , OP_REG, 107   },
  { "xchgS",	OP_REG, 110  , OP_REG, 107   },
  { "xchgS",	OP_REG, 111  , OP_REG, 107   },
  { "xchgS",	OP_REG, 112  , OP_REG, 107   },
  { "xchgS",	OP_REG, 113  , OP_REG, 107   },
  { "xchgS",	OP_REG, 114  , OP_REG, 107   },
  /* 98 */
  { "cwtl" },
  { "cltd" },
  { "lcall",	OP_DIR, 115   },
  { "(bad)" },		/* fwait */
  { "pushf" },
  { "popf" },
  { "sahf" },
  { "lahf" },
  /* a0 */
  { "movb",	OP_REG, 116  , OP_OFF, 1   },
  { "movS",	OP_REG, 107  , OP_OFF, 2   },
  { "movb",	OP_OFF, 1  , OP_REG, 116   },
  { "movS",	OP_OFF, 2  , OP_REG, 107   },
  { "movsb",	OP_ESDI, 1  , OP_DSSI, 1   },
  { "movsS",	OP_ESDI, 2  , OP_DSSI, 2   },
  { "cmpsb",	OP_ESDI, 1  , OP_DSSI, 1   },
  { "cmpsS",	OP_ESDI, 2  , OP_DSSI, 2   },
  /* a8 */
  { "testb",	OP_REG, 116  , OP_I, 1   },
  { "testS",	OP_REG, 107  , OP_I, 2   },
  { "stosb",	OP_ESDI, 1  , OP_REG, 116   },
  { "stosS",	OP_ESDI, 2  , OP_REG, 107   },
  { "lodsb",	OP_REG, 116  , OP_DSSI, 1   },
  { "lodsS",	OP_REG, 107  , OP_DSSI, 2   },
  { "scasb",	OP_REG, 116  , OP_ESDI, 1   },
  { "scasS",	OP_REG, 107  , OP_ESDI, 2   },
  /* b0 */
  { "movb",	OP_REG, 116  , OP_I, 1   },
  { "movb",	OP_REG, 117  , OP_I, 1   },
  { "movb",	OP_REG, 118  , OP_I, 1   },
  { "movb",	OP_REG, 119  , OP_I, 1   },
  { "movb",	OP_REG, 120  , OP_I, 1   },
  { "movb",	OP_REG, 121  , OP_I, 1   },
  { "movb",	OP_REG, 122  , OP_I, 1   },
  { "movb",	OP_REG, 123  , OP_I, 1   },
  /* b8 */
  { "movS",	OP_REG, 107  , OP_I, 2   },
  { "movS",	OP_REG, 108  , OP_I, 2   },
  { "movS",	OP_REG, 109  , OP_I, 2   },
  { "movS",	OP_REG, 110  , OP_I, 2   },
  { "movS",	OP_REG, 111  , OP_I, 2   },
  { "movS",	OP_REG, 112  , OP_I, 2   },
  { "movS",	OP_REG, 113  , OP_I, 2   },
  { "movS",	OP_REG, 114  , OP_I, 2   },
  /* c0 */
  { ((void *)0) , ((void *)0) , 3  },
  { ((void *)0) , ((void *)0) , 4  },
  { "ret",	OP_I, 3   },
  { "ret" },
  { "lesS",	OP_G, 2  , OP_E, 0  },
  { "ldsS",	OP_G, 2  , OP_E, 0  },
  { "movb",	OP_E, 1  , OP_I, 1   },
  { "movS",	OP_E, 2  , OP_I, 2   },
  /* c8 */
  { "enter",	OP_I, 3  , OP_I, 1   },
  { "leave" },
  { "lret",	OP_I, 3   },
  { "lret" },
  { "int3" },
  { "int",	OP_I, 1   },
  { "into" },
  { "iret" },
  /* d0 */
  { ((void *)0) , ((void *)0) , 5  },
  { ((void *)0) , ((void *)0) , 6  },
  { ((void *)0) , ((void *)0) , 7  },
  { ((void *)0) , ((void *)0) , 8  },
  { "aam",	OP_I, 1   },
  { "aad",	OP_I, 1   },
  { "(bad)" },
  { "xlat" },
  /* d8 */
  { ((void *)0) , ((void *)0) , 50   },
  { ((void *)0) , ((void *)0) , 50   },
  { ((void *)0) , ((void *)0) , 50   },
  { ((void *)0) , ((void *)0) , 50   },
  { ((void *)0) , ((void *)0) , 50   },
  { ((void *)0) , ((void *)0) , 50   },
  { ((void *)0) , ((void *)0) , 50   },
  { ((void *)0) , ((void *)0) , 50   },
  /* e0 */
  { "loopne",	OP_J, 1   },
  { "loope",	OP_J, 1   },
  { "loop",	OP_J, 1   },
  { "jCcxz",	OP_J, 1   },
  { "inb",	OP_REG, 116  , OP_I, 1   },
  { "inS",	OP_REG, 107  , OP_I, 1   },
  { "outb",	OP_I, 1  , OP_REG, 116   },
  { "outS",	OP_I, 1  , OP_REG, 107   },
  /* e8 */
  { "call",	OP_DIR, 2   },
  { "jmp",	OP_J, 2   },
  { "ljmp",	OP_DIR, 115   },
  { "jmp",	OP_J, 1   },
  { "inb",	OP_REG, 116  , OP_REG, 150   },
  { "inS",	OP_REG, 107  , OP_REG, 150   },
  { "outb",	OP_REG, 150  , OP_REG, 116   },
  { "outS",	OP_REG, 150  , OP_REG, 107   },
  /* f0 */
  { "(bad)" },			/* lock prefix */
  { "(bad)" },
  { "(bad)" },			/* repne */
  { "(bad)" },			/* repz */
  { "hlt" },
  { "cmc" },
  { ((void *)0) , ((void *)0) , 9  },
  { ((void *)0) , ((void *)0) , 10  },
  /* f8 */
  { "clc" },
  { "stc" },
  { "cli" },
  { "sti" },
  { "cld" },
  { "std" },
  { ((void *)0) , ((void *)0) , 11  },
  { ((void *)0) , ((void *)0) , 12  },
};

static struct dis386 dis386_twobyte[] = {
  /* 00 */
  { ((void *)0) , ((void *)0) , 13  },
  { ((void *)0) , ((void *)0) , 14  },
  { "larS", OP_G, 2  , OP_E, 3   },
  { "lslS", OP_G, 2  , OP_E, 3   },  
  { "(bad)" },
  { "(bad)" },
  { "clts" },
  { "(bad)" },  
  /* 08 */
  { "invd" },
  { "wbinvd" },
  { "(bad)" },  { "ud2a" },  
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  /* 10 */
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  /* 18 */
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  /* 20 */
  /* these are all backward in appendix A of the intel book */
  { "movl", OP_rm, 4  , OP_C, 4   },
  { "movl", OP_rm, 4  , OP_D, 4   },
  { "movl", OP_C, 4  , OP_rm, 4   },
  { "movl", OP_D, 4  , OP_rm, 4   },  
  { "movl", OP_rm, 4  , OP_T, 4   },
  { "(bad)" },
  { "movl", OP_T, 4  , OP_rm, 4   },
  { "(bad)" },  
  /* 28 */
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  /* 30 */
  { "wrmsr" },  { "rdtsc" },  { "rdmsr" },  { "rdpmc" },  
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  /* 38 */
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  /* 40 */
  { "cmovo", OP_G, 2  ,OP_E, 2   }, { "cmovno", OP_G, 2  ,OP_E, 2   }, { "cmovb", OP_G, 2  ,OP_E, 2   }, { "cmovae", OP_G, 2  ,OP_E, 2   },
  { "cmove", OP_G, 2  ,OP_E, 2   }, { "cmovne", OP_G, 2  ,OP_E, 2   }, { "cmovbe", OP_G, 2  ,OP_E, 2   }, { "cmova", OP_G, 2  ,OP_E, 2   },
  /* 48 */
  { "cmovs", OP_G, 2  ,OP_E, 2   }, { "cmovns", OP_G, 2  ,OP_E, 2   }, { "cmovp", OP_G, 2  ,OP_E, 2   }, { "cmovnp", OP_G, 2  ,OP_E, 2   },
  { "cmovl", OP_G, 2  ,OP_E, 2   }, { "cmovge", OP_G, 2  ,OP_E, 2   }, { "cmovle", OP_G, 2  ,OP_E, 2   }, { "cmovg", OP_G, 2  ,OP_E, 2   },  
  /* 50 */
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  /* 58 */
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  /* 60 */
  { "punpcklbw", OP_MMX, 0 , OP_EM, 2   },
  { "punpcklwd", OP_MMX, 0 , OP_EM, 2   },
  { "punpckldq", OP_MMX, 0 , OP_EM, 2   },
  { "packsswb", OP_MMX, 0 , OP_EM, 2   },
  { "pcmpgtb", OP_MMX, 0 , OP_EM, 2   },
  { "pcmpgtw", OP_MMX, 0 , OP_EM, 2   },
  { "pcmpgtd", OP_MMX, 0 , OP_EM, 2   },
  { "packuswb", OP_MMX, 0 , OP_EM, 2   },
  /* 68 */
  { "punpckhbw", OP_MMX, 0 , OP_EM, 2   },
  { "punpckhwd", OP_MMX, 0 , OP_EM, 2   },
  { "punpckhdq", OP_MMX, 0 , OP_EM, 2   },
  { "packssdw", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },  { "(bad)" },
  { "movd", OP_MMX, 0 , OP_E, 2   },
  { "movq", OP_MMX, 0 , OP_EM, 2   },
  /* 70 */
  { "(bad)" },
  { ((void *)0) , ((void *)0) , 17  },
  { ((void *)0) , ((void *)0) , 18  },
  { ((void *)0) , ((void *)0) , 19  },
  { "pcmpeqb", OP_MMX, 0 , OP_EM, 2   },
  { "pcmpeqw", OP_MMX, 0 , OP_EM, 2   },
  { "pcmpeqd", OP_MMX, 0 , OP_EM, 2   },
  { "emms" },
  /* 78 */
  { "(bad)" },  { "(bad)" },  { "(bad)" },  { "(bad)" },  
  { "(bad)" },  { "(bad)" },
  { "movd", OP_E, 2  , OP_MMX, 0  },
  { "movq", OP_EM, 2  , OP_MMX, 0  },
  /* 80 */
  { "jo", OP_J, 2   },
  { "jno", OP_J, 2   },
  { "jb", OP_J, 2   },
  { "jae", OP_J, 2   },  
  { "je", OP_J, 2   },
  { "jne", OP_J, 2   },
  { "jbe", OP_J, 2   },
  { "ja", OP_J, 2   },  
  /* 88 */
  { "js", OP_J, 2   },
  { "jns", OP_J, 2   },
  { "jp", OP_J, 2   },
  { "jnp", OP_J, 2   },  
  { "jl", OP_J, 2   },
  { "jge", OP_J, 2   },
  { "jle", OP_J, 2   },
  { "jg", OP_J, 2   },  
  /* 90 */
  { "seto", OP_E, 1   },
  { "setno", OP_E, 1   },
  { "setb", OP_E, 1   },
  { "setae", OP_E, 1   },
  { "sete", OP_E, 1   },
  { "setne", OP_E, 1   },
  { "setbe", OP_E, 1   },
  { "seta", OP_E, 1   },
  /* 98 */
  { "sets", OP_E, 1   },
  { "setns", OP_E, 1   },
  { "setp", OP_E, 1   },
  { "setnp", OP_E, 1   },
  { "setl", OP_E, 1   },
  { "setge", OP_E, 1   },
  { "setle", OP_E, 1   },
  { "setg", OP_E, 1   },  
  /* a0 */
  { "pushl", OP_REG, 104   },
  { "popl", OP_REG, 104   },
  { "cpuid" },
  { "btS", OP_E, 2  , OP_G, 2   },  
  { "shldS", OP_E, 2  , OP_G, 2  , OP_I, 1   },
  { "shldS", OP_E, 2  , OP_G, 2  , OP_REG, 117   },
  { "(bad)" },
  { "(bad)" },  
  /* a8 */
  { "pushl", OP_REG, 105   },
  { "popl", OP_REG, 105   },
  { "rsm" },
  { "btsS", OP_E, 2  , OP_G, 2   },  
  { "shrdS", OP_E, 2  , OP_G, 2  , OP_I, 1   },
  { "shrdS", OP_E, 2  , OP_G, 2  , OP_REG, 117   },
  { "(bad)" },
  { "imulS", OP_G, 2  , OP_E, 2   },  
  /* b0 */
  { "cmpxchgb", OP_E, 1  , OP_G, 1   },
  { "cmpxchgS", OP_E, 2  , OP_G, 2   },
  { "lssS", OP_G, 2  , OP_E, 0  },	/* 386 lists only Mp */
  { "btrS", OP_E, 2  , OP_G, 2   },  
  { "lfsS", OP_G, 2  , OP_E, 0  },	/* 386 lists only Mp */
  { "lgsS", OP_G, 2  , OP_E, 0  },	/* 386 lists only Mp */
  { "movzbS", OP_G, 2  , OP_E, 1   },
  { "movzwS", OP_G, 2  , OP_E, 3   },  
  /* b8 */
  { "ud2b" },
  { "(bad)" },
  { ((void *)0) , ((void *)0) , 15  },
  { "btcS", OP_E, 2  , OP_G, 2   },  
  { "bsfS", OP_G, 2  , OP_E, 2   },
  { "bsrS", OP_G, 2  , OP_E, 2   },
  { "movsbS", OP_G, 2  , OP_E, 1   },
  { "movswS", OP_G, 2  , OP_E, 3   },  
  /* c0 */
  { "xaddb", OP_E, 1  , OP_G, 1   },
  { "xaddS", OP_E, 2  , OP_G, 2   },
  { "(bad)" },
  { "(bad)" },  
  { "(bad)" },
  { "(bad)" },
  { "(bad)" },
  { ((void *)0) , ((void *)0) , 16  },  
  /* c8 */
  { "bswap", OP_REG, 107   },
  { "bswap", OP_REG, 108   },
  { "bswap", OP_REG, 109   },
  { "bswap", OP_REG, 110   },
  { "bswap", OP_REG, 111   },
  { "bswap", OP_REG, 112   },
  { "bswap", OP_REG, 113   },
  { "bswap", OP_REG, 114   },
  /* d0 */
  { "(bad)" },
  { "psrlw", OP_MMX, 0 , OP_EM, 2   },
  { "psrld", OP_MMX, 0 , OP_EM, 2   },
  { "psrlq", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },
  { "pmullw", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },  { "(bad)" },  
  /* d8 */
  { "psubusb", OP_MMX, 0 , OP_EM, 2   },
  { "psubusw", OP_MMX, 0 , OP_EM, 2   },
  { "pand", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },
  { "paddusb", OP_MMX, 0 , OP_EM, 2   },
  { "paddusw", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },
  { "pand", OP_MMX, 0 , OP_EM, 2   },
  /* e0 */
  { "(bad)" },
  { "psraw", OP_MMX, 0 , OP_EM, 2   },
  { "psrad", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },
  { "(bad)" },
  { "pmulhw", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },  { "(bad)" },  
  /* e8 */
  { "psubsb", OP_MMX, 0 , OP_EM, 2   },
  { "psubsw", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },
  { "por", OP_MMX, 0 , OP_EM, 2   },
  { "paddsb", OP_MMX, 0 , OP_EM, 2   },
  { "paddsw", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },
  { "pxor", OP_MMX, 0 , OP_EM, 2   },
  /* f0 */
  { "(bad)" },
  { "psllw", OP_MMX, 0 , OP_EM, 2   },
  { "pslld", OP_MMX, 0 , OP_EM, 2   },
  { "psllq", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },
  { "pmaddwd", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },  { "(bad)" },  
  /* f8 */
  { "psubb", OP_MMX, 0 , OP_EM, 2   },
  { "psubw", OP_MMX, 0 , OP_EM, 2   },
  { "psubd", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" },  
  { "paddb", OP_MMX, 0 , OP_EM, 2   },
  { "paddw", OP_MMX, 0 , OP_EM, 2   },
  { "paddd", OP_MMX, 0 , OP_EM, 2   },
  { "(bad)" }
};

static const unsigned char onebyte_has_modrm[256] = {
  1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,
  1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,
  1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,
  1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,1,1,0,0,0,0,0,1,0,1,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,
  1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1
};

static const unsigned char twobyte_has_modrm[256] = {
  /* 00 */ 1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0, /* 0f */
  /* 10 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 1f */
  /* 20 */ 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0, /* 2f */
  /* 30 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 3f */
  /* 40 */ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /* 4f */
  /* 50 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 5f */
  /* 60 */ 1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1, /* 6f */
  /* 70 */ 0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1, /* 7f */
  /* 80 */ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, /* 8f */
  /* 90 */ 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1, /* 9f */
  /* a0 */ 0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1, /* af */
  /* b0 */ 1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1, /* bf */
  /* c0 */ 1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0, /* cf */
  /* d0 */ 0,1,1,1,0,1,0,0,1,1,1,0,1,1,0,1, /* df */
  /* e0 */ 0,1,1,0,0,1,0,0,1,1,0,1,1,1,0,1, /* ef */
  /* f0 */ 0,1,1,1,0,1,0,0,1,1,1,0,1,1,1,0  /* ff */
};

static char obuf[100];
static char *obufp;
static char scratchbuf[100];
static unsigned char *start_codep;
static unsigned char *codep;
static disassemble_info *the_info;
static int mod;
static int rm;
static int reg;
static void oappend  (char *s)  ;

static char *names32[]={
  "%eax","%ecx","%edx","%ebx", "%esp","%ebp","%esi","%edi",
};
static char *names16[] = {
  "%ax","%cx","%dx","%bx","%sp","%bp","%si","%di",
};
static char *names8[] = {
  "%al","%cl","%dl","%bl","%ah","%ch","%dh","%bh",
};
static char *names_seg[] = {
  "%es","%cs","%ss","%ds","%fs","%gs","%?","%?",
};
static char *index16[] = {
  "bx+si","bx+di","bp+si","bp+di","si","di","bp","bx"
};

static struct dis386 grps[][8] = {
  /* GRP1b */
  {
    { "addb",	OP_E, 1  , OP_I, 1   },
    { "orb",	OP_E, 1  , OP_I, 1   },
    { "adcb",	OP_E, 1  , OP_I, 1   },
    { "sbbb",	OP_E, 1  , OP_I, 1   },
    { "andb",	OP_E, 1  , OP_I, 1   },
    { "subb",	OP_E, 1  , OP_I, 1   },
    { "xorb",	OP_E, 1  , OP_I, 1   },
    { "cmpb",	OP_E, 1  , OP_I, 1   }
  },
  /* GRP1S */
  {
    { "addS",	OP_E, 2  , OP_I, 2   },
    { "orS",	OP_E, 2  , OP_I, 2   },
    { "adcS",	OP_E, 2  , OP_I, 2   },
    { "sbbS",	OP_E, 2  , OP_I, 2   },
    { "andS",	OP_E, 2  , OP_I, 2   },
    { "subS",	OP_E, 2  , OP_I, 2   },
    { "xorS",	OP_E, 2  , OP_I, 2   },
    { "cmpS",	OP_E, 2  , OP_I, 2   }
  },
  /* GRP1Ss */
  {
    { "addS",	OP_E, 2  , OP_sI, 1   },
    { "orS",	OP_E, 2  , OP_sI, 1   },
    { "adcS",	OP_E, 2  , OP_sI, 1   },
    { "sbbS",	OP_E, 2  , OP_sI, 1   },
    { "andS",	OP_E, 2  , OP_sI, 1   },
    { "subS",	OP_E, 2  , OP_sI, 1   },
    { "xorS",	OP_E, 2  , OP_sI, 1   },
    { "cmpS",	OP_E, 2  , OP_sI, 1   }
  },
  /* GRP2b */
  {
    { "rolb",	OP_E, 1  , OP_I, 1   },
    { "rorb",	OP_E, 1  , OP_I, 1   },
    { "rclb",	OP_E, 1  , OP_I, 1   },
    { "rcrb",	OP_E, 1  , OP_I, 1   },
    { "shlb",	OP_E, 1  , OP_I, 1   },
    { "shrb",	OP_E, 1  , OP_I, 1   },
    { "(bad)" },
    { "sarb",	OP_E, 1  , OP_I, 1   },
  },
  /* GRP2S */
  {
    { "rolS",	OP_E, 2  , OP_I, 1   },
    { "rorS",	OP_E, 2  , OP_I, 1   },
    { "rclS",	OP_E, 2  , OP_I, 1   },
    { "rcrS",	OP_E, 2  , OP_I, 1   },
    { "shlS",	OP_E, 2  , OP_I, 1   },
    { "shrS",	OP_E, 2  , OP_I, 1   },
    { "(bad)" },
    { "sarS",	OP_E, 2  , OP_I, 1   },
  },
  /* GRP2b_one */
  {
    { "rolb",	OP_E, 1   },
    { "rorb",	OP_E, 1   },
    { "rclb",	OP_E, 1   },
    { "rcrb",	OP_E, 1   },
    { "shlb",	OP_E, 1   },
    { "shrb",	OP_E, 1   },
    { "(bad)" },
    { "sarb",	OP_E, 1   },
  },
  /* GRP2S_one */
  {
    { "rolS",	OP_E, 2   },
    { "rorS",	OP_E, 2   },
    { "rclS",	OP_E, 2   },
    { "rcrS",	OP_E, 2   },
    { "shlS",	OP_E, 2   },
    { "shrS",	OP_E, 2   },
    { "(bad)" },
    { "sarS",	OP_E, 2   },
  },
  /* GRP2b_cl */
  {
    { "rolb",	OP_E, 1  , OP_REG, 117   },
    { "rorb",	OP_E, 1  , OP_REG, 117   },
    { "rclb",	OP_E, 1  , OP_REG, 117   },
    { "rcrb",	OP_E, 1  , OP_REG, 117   },
    { "shlb",	OP_E, 1  , OP_REG, 117   },
    { "shrb",	OP_E, 1  , OP_REG, 117   },
    { "(bad)" },
    { "sarb",	OP_E, 1  , OP_REG, 117   },
  },
  /* GRP2S_cl */
  {
    { "rolS",	OP_E, 2  , OP_REG, 117   },
    { "rorS",	OP_E, 2  , OP_REG, 117   },
    { "rclS",	OP_E, 2  , OP_REG, 117   },
    { "rcrS",	OP_E, 2  , OP_REG, 117   },
    { "shlS",	OP_E, 2  , OP_REG, 117   },
    { "shrS",	OP_E, 2  , OP_REG, 117   },
    { "(bad)" },
    { "sarS",	OP_E, 2  , OP_REG, 117   }
  },
  /* GRP3b */
  {
    { "testb",	OP_E, 1  , OP_I, 1   },
    { "(bad)",	OP_E, 1   },
    { "notb",	OP_E, 1   },
    { "negb",	OP_E, 1   },
    { "mulb",	OP_REG, 116  , OP_E, 1   },
    { "imulb",	OP_REG, 116  , OP_E, 1   },
    { "divb",	OP_REG, 116  , OP_E, 1   },
    { "idivb",	OP_REG, 116  , OP_E, 1   }
  },
  /* GRP3S */
  {
    { "testS",	OP_E, 2  , OP_I, 2   },
    { "(bad)" },
    { "notS",	OP_E, 2   },
    { "negS",	OP_E, 2   },
    { "mulS",	OP_REG, 107  , OP_E, 2   },
    { "imulS",	OP_REG, 107  , OP_E, 2   },
    { "divS",	OP_REG, 107  , OP_E, 2   },
    { "idivS",	OP_REG, 107  , OP_E, 2   },
  },
  /* GRP4 */
  {
    { "incb", OP_E, 1   },
    { "decb", OP_E, 1   },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
  },
  /* GRP5 */
  {
    { "incS",	OP_E, 2   },
    { "decS",	OP_E, 2   },
    { "call",	OP_indirE, 2   },
    { "lcall",	OP_indirE, 2   },
    { "jmp",	OP_indirE, 2   },
    { "ljmp",	OP_indirE, 2   },
    { "pushS",	OP_E, 2   },
    { "(bad)" },
  },
  /* GRP6 */
  {
    { "sldt",	OP_E, 3   },
    { "str",	OP_E, 3   },
    { "lldt",	OP_E, 3   },
    { "ltr",	OP_E, 3   },
    { "verr",	OP_E, 3   },
    { "verw",	OP_E, 3   },
    { "(bad)" },
    { "(bad)" }
  },
  /* GRP7 */
  {
    { "sgdt", OP_E, 3   },
    { "sidt", OP_E, 3   },
    { "lgdt", OP_E, 3   },
    { "lidt", OP_E, 3   },
    { "smsw", OP_E, 3   },
    { "(bad)" },
    { "lmsw", OP_E, 3   },
    { "invlpg", OP_E, 3   },
  },
  /* GRP8 */
  {
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { "btS",	OP_E, 2  , OP_I, 1   },
    { "btsS",	OP_E, 2  , OP_I, 1   },
    { "btrS",	OP_E, 2  , OP_I, 1   },
    { "btcS",	OP_E, 2  , OP_I, 1   },
  },
  /* GRP9 */
  {
    { "(bad)" },
    { "cmpxchg8b", OP_E, 2   },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
  },
  /* GRP10 */
  {
    { "(bad)" },
    { "(bad)" },
    { "psrlw", OP_MS, 1  , OP_I, 1   },
    { "(bad)" },
    { "psraw", OP_MS, 1  , OP_I, 1   },
    { "(bad)" },
    { "psllw", OP_MS, 1  , OP_I, 1   },
    { "(bad)" },
  },
  /* GRP11 */
  {
    { "(bad)" },
    { "(bad)" },
    { "psrld", OP_MS, 1  , OP_I, 1   },
    { "(bad)" },
    { "psrad", OP_MS, 1  , OP_I, 1   },
    { "(bad)" },
    { "pslld", OP_MS, 1  , OP_I, 1   },
    { "(bad)" },
  },
  /* GRP12 */
  {
    { "(bad)" },
    { "(bad)" },
    { "psrlq", OP_MS, 1  , OP_I, 1   },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { "psllq", OP_MS, 1  , OP_I, 1   },
    { "(bad)" },
  }
};

#define PREFIX_REPZ 1
#define PREFIX_REPNZ 2
#define PREFIX_LOCK 4
#define PREFIX_CS 8
#define PREFIX_SS 0x10
#define PREFIX_DS 0x20
#define PREFIX_ES 0x40
#define PREFIX_FS 0x80
#define PREFIX_GS 0x100
#define PREFIX_DATA 0x200
#define PREFIX_ADR 0x400
#define PREFIX_FWAIT 0x800

static int prefixes;

static void
ckprefix ()
{
  prefixes = 0;
  while (1)
    {
      ((  codep + 1 ) <= ((struct dis_private *)( the_info ->private_data))->max_fetched ? 1 : fetch_data (( the_info ), (  codep + 1 ))) ;
      switch (*codep)
	{
	case 0xf3:
	  prefixes |= 1 ;
	  break;
	case 0xf2:
	  prefixes |= 2 ;
	  break;
	case 0xf0:
	  prefixes |= 4 ;
	  break;
	case 0x2e:
	  prefixes |= 8 ;
	  break;
	case 0x36:
	  prefixes |= 0x10 ;
	  break;
	case 0x3e:
	  prefixes |= 0x20 ;
	  break;
	case 0x26:
	  prefixes |= 0x40 ;
	  break;
	case 0x64:
	  prefixes |= 0x80 ;
	  break;
	case 0x65:
	  prefixes |= 0x100 ;
	  break;
	case 0x66:
	  prefixes |= 0x200 ;
	  break;
	case 0x67:
	  prefixes |= 0x400 ;
	  break;
	case 0x9b:
	  prefixes |= 0x800 ;
	  break;
	default:
	  return;
	}
      codep++;
    }
}

static char op1out[100], op2out[100], op3out[100];
static int op_address[3], op_ad, op_index[3];
static int start_pc;


/*
 *   On the 386's of 1988, the maximum length of an instruction is 15 bytes.
 *   (see topic "Redundant prefixes" in the "Differences from 8086"
 *   section of the "Virtual 8086 Mode" chapter.)
 * 'pc' should be the address of this instruction, it will
 *   be used to print the target address if this is a relative jump or call
 * The function returns the length of this instruction in bytes.
 */
static unsigned int	char_count;

int print_insn_x86  (bfd_vma pc, disassemble_info *info, int aflag,
			    int dflag)  ;
int
print_insn_i386 (pc, info)
     bfd_vma pc;
     disassemble_info *info;
{
  if (info->mach == 0 )
    return print_insn_x86 (pc, info, 1, 1);
  else if (info->mach == 1 )
    return print_insn_x86 (pc, info, 0, 0);
  else
    abort ();
}

int
print_insn_x86 (pc, info, aflag, dflag)
     bfd_vma pc;
     disassemble_info *info;
{
  struct dis386 *dp;
  int i;
  int enter_instruction;
  char *first, *second, *third;
  int needcomma;
  unsigned char need_modrm;

  struct dis_private priv;
  bfd_byte *inbuf = priv.the_buffer;

  /* The output looks better if we put 5 bytes on a line, since that
     puts long word instructions on a single line.  */
  info->bytes_per_line = 5;

  info->private_data = (void * ) &priv;
  priv.max_fetched = priv.the_buffer;
  priv.insn_start = pc;
  if (__sigsetjmp (( priv.bailout ), 0)  != 0)
    /* Error return.  */
    return -1;

  obuf[0] = 0;
  op1out[0] = 0;
  op2out[0] = 0;
  op3out[0] = 0;

  op_index[0] = op_index[1] = op_index[2] = -1;

  the_info = info;
  start_pc = pc;
  start_codep = inbuf;
  codep = inbuf;
  
  ckprefix ();

  ((  codep + 1 ) <= ((struct dis_private *)( info ->private_data))->max_fetched ? 1 : fetch_data (( info ), (  codep + 1 ))) ;
  if (*codep == 0xc8)
    enter_instruction = 1;
  else
    enter_instruction = 0;
  
  obufp = obuf;
  
  if (prefixes & 1 )
    oappend ("repz ");
  if (prefixes & 2 )
    oappend ("repnz ");
  if (prefixes & 4 )
    oappend ("lock ");
  
  if ((prefixes & 0x800 )
      && ((*codep < 0xd8) || (*codep > 0xdf)))
    {
      /* fwait not followed by floating point instruction */
      char_count += (*info->fprintf_func) (info->stream, "fwait");
      return (1);
    }
  
  if (prefixes & 0x200 )
    dflag ^= 1;
  
  if (prefixes & 0x400 )
    {
      aflag ^= 1;
      oappend ("addr16 ");
    }
  
  if (*codep == 0x0f)
    {
      ((  codep + 2 ) <= ((struct dis_private *)( info ->private_data))->max_fetched ? 1 : fetch_data (( info ), (  codep + 2 ))) ;
      dp = &dis386_twobyte[*++codep];
      need_modrm = twobyte_has_modrm[*codep];
    }
  else
    {
      dp = &dis386[*codep];
      need_modrm = onebyte_has_modrm[*codep];
    }
  codep++;

  if (need_modrm)
    {
      ((  codep + 1 ) <= ((struct dis_private *)( info ->private_data))->max_fetched ? 1 : fetch_data (( info ), (  codep + 1 ))) ;
      mod = (*codep >> 6) & 3;
      reg = (*codep >> 3) & 7;
      rm = *codep & 7;
    }

  if (dp->name == ((void *)0)  && dp->bytemode1 == 50 )
    {
      dofloat (aflag, dflag);
    }
  else
    {
      if (dp->name == ((void *)0) )
	dp = &grps[dp->bytemode1][reg];
      
      putop (dp->name, aflag, dflag);
      
      obufp = op1out;
      op_ad = 2;
      if (dp->op1)
	(*dp->op1)(dp->bytemode1, aflag, dflag);
      
      obufp = op2out;
      op_ad = 1;
      if (dp->op2)
	(*dp->op2)(dp->bytemode2, aflag, dflag);
      
      obufp = op3out;
      op_ad = 0;
      if (dp->op3)
	(*dp->op3)(dp->bytemode3, aflag, dflag);
    }
  
  obufp = obuf + strlen (obuf);
  for (i = strlen (obuf); i < 6; i++)
    oappend (" ");
  oappend (" ");
  char_count += (*info->fprintf_func) (info->stream, "%s", obuf);
  
  /* enter instruction is printed with operands in the
   * same order as the intel book; everything else
   * is printed in reverse order 
   */
  if (enter_instruction)
    {
      first = op1out;
      second = op2out;
      third = op3out;
      op_ad = op_index[0];
      op_index[0] = op_index[2];
      op_index[2] = op_ad;
    }
  else
    {
      first = op3out;
      second = op2out;
      third = op1out;
    }
  needcomma = 0;
  if (*first)
    {
      if (op_index[0] != -1)
	(*info->print_address_func) (op_address[op_index[0]], info);
      else
	char_count += (*info->fprintf_func) (info->stream, "%s", first);
      needcomma = 1;
    }
  if (*second)
    {
      if (needcomma)
	char_count += (*info->fprintf_func) (info->stream, ",");
      if (op_index[1] != -1)
	(*info->print_address_func) (op_address[op_index[1]], info);
      else
	char_count += (*info->fprintf_func) (info->stream, "%s", second);
      needcomma = 1;
    }
  if (*third)
    {
      if (needcomma)
	char_count += (*info->fprintf_func) (info->stream, ",");
      if (op_index[2] != -1)
	(*info->print_address_func) (op_address[op_index[2]], info);
      else
	char_count += (*info->fprintf_func) (info->stream, "%s", third);
    }
  return (codep - inbuf);
}

static char *float_mem[] = {
  /* d8 */
  "fadds",
  "fmuls",
  "fcoms",
  "fcomps",
  "fsubs",
  "fsubrs",
  "fdivs",
  "fdivrs",
  /*  d9 */
  "flds",
  "(bad)",
  "fsts",
  "fstps",
  "fldenv",
  "fldcw",
  "fNstenv",
  "fNstcw",
  /* da */
  "fiaddl",
  "fimull",
  "ficoml",
  "ficompl",
  "fisubl",
  "fisubrl",
  "fidivl",
  "fidivrl",
  /* db */
  "fildl",
  "(bad)",
  "fistl",
  "fistpl",
  "(bad)",
  "fldt",
  "(bad)",
  "fstpt",
  /* dc */
  "faddl",
  "fmull",
  "fcoml",
  "fcompl",
  "fsubl",
  "fsubrl",
  "fdivl",
  "fdivrl",
  /* dd */
  "fldl",
  "(bad)",
  "fstl",
  "fstpl",
  "frstor",
  "(bad)",
  "fNsave",
  "fNstsw",
  /* de */
  "fiadd",
  "fimul",
  "ficom",
  "ficomp",
  "fisub",
  "fisubr",
  "fidiv",
  "fidivr",
  /* df */
  "fild",
  "(bad)",
  "fist",
  "fistp",
  "fbld",
  "fildll",
  "fbstp",
  "fistpll",
};

#define ST OP_ST, 0
#define STi OP_STi, 0

#define FGRPd9_2 NULL, NULL, 0
#define FGRPd9_4 NULL, NULL, 1
#define FGRPd9_5 NULL, NULL, 2
#define FGRPd9_6 NULL, NULL, 3
#define FGRPd9_7 NULL, NULL, 4
#define FGRPda_5 NULL, NULL, 5
#define FGRPdb_4 NULL, NULL, 6
#define FGRPde_3 NULL, NULL, 7
#define FGRPdf_4 NULL, NULL, 8

static struct dis386 float_reg[][8] = {
  /* d8 */
  {
    { "fadd",	OP_ST, 0 , OP_STi, 0  },
    { "fmul",	OP_ST, 0 , OP_STi, 0  },
    { "fcom",	OP_STi, 0  },
    { "fcomp",	OP_STi, 0  },
    { "fsub",	OP_ST, 0 , OP_STi, 0  },
    { "fsubr",	OP_ST, 0 , OP_STi, 0  },
    { "fdiv",	OP_ST, 0 , OP_STi, 0  },
    { "fdivr",	OP_ST, 0 , OP_STi, 0  },
  },
  /* d9 */
  {
    { "fld",	OP_STi, 0  },
    { "fxch",	OP_STi, 0  },
    { ((void *)0) , ((void *)0) , 0  },
    { "(bad)" },
    { ((void *)0) , ((void *)0) , 1  },
    { ((void *)0) , ((void *)0) , 2  },
    { ((void *)0) , ((void *)0) , 3  },
    { ((void *)0) , ((void *)0) , 4  },
  },
  /* da */
  {
    { "fcmovb",	OP_ST, 0 , OP_STi, 0  },
    { "fcmove",	OP_ST, 0 , OP_STi, 0  },
    { "fcmovbe",OP_ST, 0 , OP_STi, 0  },
    { "fcmovu",	OP_ST, 0 , OP_STi, 0  },
    { "(bad)" },
    { ((void *)0) , ((void *)0) , 5  },
    { "(bad)" },
    { "(bad)" },
  },
  /* db */
  {
    { "fcmovnb",OP_ST, 0 , OP_STi, 0  },
    { "fcmovne",OP_ST, 0 , OP_STi, 0  },
    { "fcmovnbe",OP_ST, 0 , OP_STi, 0  },
    { "fcmovnu",OP_ST, 0 , OP_STi, 0  },
    { ((void *)0) , ((void *)0) , 6  },
    { "fucomi",	OP_ST, 0 , OP_STi, 0  },
    { "fcomi",	OP_ST, 0 , OP_STi, 0  },
    { "(bad)" },
  },
  /* dc */
  {
    { "fadd",	OP_STi, 0 , OP_ST, 0  },
    { "fmul",	OP_STi, 0 , OP_ST, 0  },
    { "(bad)" },
    { "(bad)" },
    { "fsub",	OP_STi, 0 , OP_ST, 0  },
    { "fsubr",	OP_STi, 0 , OP_ST, 0  },
    { "fdiv",	OP_STi, 0 , OP_ST, 0  },
    { "fdivr",	OP_STi, 0 , OP_ST, 0  },
  },
  /* dd */
  {
    { "ffree",	OP_STi, 0  },
    { "(bad)" },
    { "fst",	OP_STi, 0  },
    { "fstp",	OP_STi, 0  },
    { "fucom",	OP_STi, 0  },
    { "fucomp",	OP_STi, 0  },
    { "(bad)" },
    { "(bad)" },
  },
  /* de */
  {
    { "faddp",	OP_STi, 0 , OP_ST, 0  },
    { "fmulp",	OP_STi, 0 , OP_ST, 0  },
    { "(bad)" },
    { ((void *)0) , ((void *)0) , 7  },
    { "fsubp",	OP_STi, 0 , OP_ST, 0  },
    { "fsubrp",	OP_STi, 0 , OP_ST, 0  },
    { "fdivp",	OP_STi, 0 , OP_ST, 0  },
    { "fdivrp",	OP_STi, 0 , OP_ST, 0  },
  },
  /* df */
  {
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { "(bad)" },
    { ((void *)0) , ((void *)0) , 8  },
    { "fucomip",OP_ST, 0 , OP_STi, 0  },
    { "fcomip", OP_ST, 0 , OP_STi, 0  },
    { "(bad)" },
  },
};


static char *fgrps[][8] = {
  /* d9_2  0 */
  {
    "fnop","(bad)","(bad)","(bad)","(bad)","(bad)","(bad)","(bad)",
  },

  /* d9_4  1 */
  {
    "fchs","fabs","(bad)","(bad)","ftst","fxam","(bad)","(bad)",
  },

  /* d9_5  2 */
  {
    "fld1","fldl2t","fldl2e","fldpi","fldlg2","fldln2","fldz","(bad)",
  },

  /* d9_6  3 */
  {
    "f2xm1","fyl2x","fptan","fpatan","fxtract","fprem1","fdecstp","fincstp",
  },

  /* d9_7  4 */
  {
    "fprem","fyl2xp1","fsqrt","fsincos","frndint","fscale","fsin","fcos",
  },

  /* da_5  5 */
  {
    "(bad)","fucompp","(bad)","(bad)","(bad)","(bad)","(bad)","(bad)",
  },

  /* db_4  6 */
  {
    "feni(287 only)","fdisi(287 only)","fNclex","fNinit",
    "fNsetpm(287 only)","(bad)","(bad)","(bad)",
  },

  /* de_3  7 */
  {
    "(bad)","fcompp","(bad)","(bad)","(bad)","(bad)","(bad)","(bad)",
  },

  /* df_4  8 */
  {
    "fNstsw","(bad)","(bad)","(bad)","(bad)","(bad)","(bad)","(bad)",
  },
};

static void
dofloat (aflag, dflag)
     int aflag;
     int dflag;
{
  struct dis386 *dp;
  unsigned char floatop;
  
  floatop = codep[-1];
  
  if (mod != 3)
    {
      putop (float_mem[(floatop - 0xd8) * 8 + reg], aflag, dflag);
      obufp = op1out;
      OP_E (2 , aflag, dflag);
      return;
    }
  codep++;
  
  dp = &float_reg[floatop - 0xd8][reg];
  if (dp->name == ((void *)0) )
    {
      putop (fgrps[dp->bytemode1][rm], aflag, dflag);
      /* instruction fnstsw is only one with strange arg */
      if (floatop == 0xdf
	  && ((  codep + 1 ) <= ((struct dis_private *)( the_info ->private_data))->max_fetched ? 1 : fetch_data (( the_info ), (  codep + 1 ))) 
	  && *codep == 0xe0)
	strcpy (op1out, "%eax");
    }
  else
    {
      putop (dp->name, aflag, dflag);
      obufp = op1out;
      if (dp->op1)
	(*dp->op1)(dp->bytemode1, aflag, dflag);
      obufp = op2out;
      if (dp->op2)
	(*dp->op2)(dp->bytemode2, aflag, dflag);
    }
}

/* ARGSUSED */
static int
OP_ST (ignore, aflag, dflag)
     int ignore;
     int aflag;
     int dflag;
{
  oappend ("%st");
  return (0);
}

/* ARGSUSED */
static int
OP_STi (ignore, aflag, dflag)
     int ignore;
     int aflag;
     int dflag;
{
  sprintf (scratchbuf, "%%st(%d)", rm);
  oappend (scratchbuf);
  return (0);
}


/* capital letters in template are macros */
static void
putop (template, aflag, dflag)
     char *template;
     int aflag;
     int dflag;
{
  char *p;
  
  for (p = template; *p; p++)
    {
      switch (*p)
	{
	default:
	  *obufp++ = *p;
	  break;
	case 'C':		/* For jcxz/jecxz */
	  if (aflag)
	    *obufp++ = 'e';
	  break;
	case 'N':
	  if ((prefixes & 0x800 ) == 0)
	    *obufp++ = 'n';
	  break;
	case 'S':
	  /* operand size flag */
	  if (dflag)
	    *obufp++ = 'l';
	  else
	    *obufp++ = 'w';
	  break;
	}
    }
  *obufp = 0;
}

static void
oappend (s)
     char *s;
{
  strcpy (obufp, s);
  obufp += strlen (s);
  *obufp = 0;
}

static void
append_prefix ()
{
  if (prefixes & 8 )
    oappend ("%cs:");
  if (prefixes & 0x20 )
    oappend ("%ds:");
  if (prefixes & 0x10 )
    oappend ("%ss:");
  if (prefixes & 0x40 )
    oappend ("%es:");
  if (prefixes & 0x80 )
    oappend ("%fs:");
  if (prefixes & 0x100 )
    oappend ("%gs:");
}

static int
OP_indirE (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  oappend ("*");
  return OP_E (bytemode, aflag, dflag);
}

static int
OP_E (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  int disp;

  /* skip mod/rm byte */
  codep++;

  if (mod == 3)
    {
      switch (bytemode)
	{
	case 1 :
	  oappend (names8[rm]);
	  break;
	case 3 :
	  oappend (names16[rm]);
	  break;
	case 2 :
	  if (dflag)
	    oappend (names32[rm]);
	  else
	    oappend (names16[rm]);
	  break;
	default:
	  oappend ("<bad dis table>");
	  break;
	}
      return 0;
    }

  disp = 0;
  append_prefix ();

  if (aflag) /* 32 bit address mode */
    {
      int havesib;
      int havebase;
      int base;
      int index;
      int scale;

      havesib = 0;
      havebase = 1;
      base = rm;

      if (base == 4)
	{
	  havesib = 1;
	  ((  codep + 1 ) <= ((struct dis_private *)( the_info ->private_data))->max_fetched ? 1 : fetch_data (( the_info ), (  codep + 1 ))) ;
	  scale = (*codep >> 6) & 3;
	  index = (*codep >> 3) & 7;
	  base = *codep & 7;
	  codep++;
	}

      switch (mod)
	{
	case 0:
	  if (base == 5)
	    {
	      havebase = 0;
	      disp = get32 ();
	    }
	  break;
	case 1:
	  ((  codep + 1 ) <= ((struct dis_private *)( the_info ->private_data))->max_fetched ? 1 : fetch_data (( the_info ), (  codep + 1 ))) ;
	  disp = *(char *)codep++;
	  break;
	case 2:
	  disp = get32 ();
	  break;
	}

      if (mod != 0 || base == 5)
	{
	  sprintf (scratchbuf, "0x%x", disp);
	  oappend (scratchbuf);
	}

      if (havebase || (havesib && (index != 4 || scale != 0)))
	{
	  oappend ("(");
	  if (havebase)
	    oappend (names32[base]);
	  if (havesib)
	    {
	      if (index != 4)
		{
		  sprintf (scratchbuf, ",%s", names32[index]);
		  oappend (scratchbuf);
		}
	      sprintf (scratchbuf, ",%d", 1 << scale);
	      oappend (scratchbuf);
	    }
	  oappend (")");
	}
    }
  else
    { /* 16 bit address mode */
      switch (mod)
	{
	case 0:
	  if (rm == 6)
	    disp = (short) get16 ();
	  break;
	case 1:
	  ((  codep + 1 ) <= ((struct dis_private *)( the_info ->private_data))->max_fetched ? 1 : fetch_data (( the_info ), (  codep + 1 ))) ;
	  disp = *(char *)codep++;
	  break;
	case 2:
	  disp = (short) get16 ();
	  break;
	}

      if (mod != 0 || rm == 6)
	{
	  sprintf (scratchbuf, "0x%x", disp);
	  oappend (scratchbuf);
	}

      if (mod != 0 || rm != 6)
	{
	  oappend ("(");
	  oappend (index16[rm]);
	  oappend (")");
	}
    }
  return 0;
}

static int
OP_G (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  switch (bytemode) 
    {
    case 1 :
      oappend (names8[reg]);
      break;
    case 3 :
      oappend (names16[reg]);
      break;
    case 4 :
      oappend (names32[reg]);
      break;
    case 2 :
      if (dflag)
	oappend (names32[reg]);
      else
	oappend (names16[reg]);
      break;
    default:
      oappend ("<internal disassembler error>");
      break;
    }
  return (0);
}

static int
get32 ()
{
  int x = 0;

  ((  codep + 4 ) <= ((struct dis_private *)( the_info ->private_data))->max_fetched ? 1 : fetch_data (( the_info ), (  codep + 4 ))) ;
  x = *codep++ & 0xff;
  x |= (*codep++ & 0xff) << 8;
  x |= (*codep++ & 0xff) << 16;
  x |= (*codep++ & 0xff) << 24;
  return (x);
}

static int
get16 ()
{
  int x = 0;

  ((  codep + 2 ) <= ((struct dis_private *)( the_info ->private_data))->max_fetched ? 1 : fetch_data (( the_info ), (  codep + 2 ))) ;
  x = *codep++ & 0xff;
  x |= (*codep++ & 0xff) << 8;
  return (x);
}

static void
set_op (op)
     int op;
{
  op_index[op_ad] = op_ad;
  op_address[op_ad] = op;
}

static int
OP_REG (code, aflag, dflag)
     int code;
     int aflag;
     int dflag;
{
  char *s;
  
  switch (code) 
    {
    case 150 : s = "(%dx)"; break;
	case 124 : case 125 : case 126 : case 127 :
	case 128 : case 129 : case 130 : case 131 :
		s = names16[code - 124 ];
		break;
	case 100 : case 102 : case 101 :
	case 103 : case 104 : case 105 :
		s = names_seg[code - 100 ];
		break;
	case 116 : case 120 : case 117 : case 121 :
	case 118 : case 122 : case 119 : case 123 :
		s = names8[code - 116 ];
		break;
	case 107 : case 108 : case 109 : case 110 :
	case 111 : case 112 : case 113 : case 114 :
      if (dflag)
	s = names32[code - 107 ];
      else
	s = names16[code - 107 ];
      break;
    default:
      s = "<internal disassembler error>";
      break;
    }
  oappend (s);
  return (0);
}

static int
OP_I (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  int op;
  
  switch (bytemode) 
    {
    case 1 :
      ((  codep + 1 ) <= ((struct dis_private *)( the_info ->private_data))->max_fetched ? 1 : fetch_data (( the_info ), (  codep + 1 ))) ;
      op = *codep++ & 0xff;
      break;
    case 2 :
      if (dflag)
	op = get32 ();
      else
	op = get16 ();
      break;
    case 3 :
      op = get16 ();
      break;
    default:
      oappend ("<internal disassembler error>");
      return (0);
    }
  sprintf (scratchbuf, "$0x%x", op);
  oappend (scratchbuf);
  return (0);
}

static int
OP_sI (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  int op;
  
  switch (bytemode) 
    {
    case 1 :
      ((  codep + 1 ) <= ((struct dis_private *)( the_info ->private_data))->max_fetched ? 1 : fetch_data (( the_info ), (  codep + 1 ))) ;
      op = *(char *)codep++;
      break;
    case 2 :
      if (dflag)
	op = get32 ();
      else
	op = (short)get16();
      break;
    case 3 :
      op = (short)get16 ();
      break;
    default:
      oappend ("<internal disassembler error>");
      return (0);
    }
  sprintf (scratchbuf, "$0x%x", op);
  oappend (scratchbuf);
  return (0);
}

static int
OP_J (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  int disp;
  int mask = -1;
  
  switch (bytemode) 
    {
    case 1 :
      ((  codep + 1 ) <= ((struct dis_private *)( the_info ->private_data))->max_fetched ? 1 : fetch_data (( the_info ), (  codep + 1 ))) ;
      disp = *(char *)codep++;
      break;
    case 2 :
      if (dflag)
	disp = get32 ();
      else
	{
	  disp = (short)get16 ();
	  /* for some reason, a data16 prefix on a jump instruction
	     means that the pc is masked to 16 bits after the
	     displacement is added!  */
	  mask = 0xffff;
	}
      break;
    default:
      oappend ("<internal disassembler error>");
      return (0);
    }
  disp = (start_pc + codep - start_codep + disp) & mask;
  set_op (disp);
  sprintf (scratchbuf, "0x%x", disp);
  oappend (scratchbuf);
  return (0);
}

/* ARGSUSED */
static int
OP_SEG (dummy, aflag, dflag)
     int dummy;
     int aflag;
     int dflag;
{
  static char *sreg[] = {
    "%es","%cs","%ss","%ds","%fs","%gs","%?","%?",
  };

  oappend (sreg[reg]);
  return (0);
}

static int
OP_DIR (size, aflag, dflag)
     int size;
     int aflag;
     int dflag;
{
  int seg, offset;
  
  switch (size) 
    {
    case 115 :
      if (aflag) 
	{
	  offset = get32 ();
	  seg = get16 ();
	} 
      else 
	{
	  offset = get16 ();
	  seg = get16 ();
	}
      sprintf (scratchbuf, "0x%x,0x%x", seg, offset);
      oappend (scratchbuf);
      break;
    case 2 :
      if (aflag)
	offset = get32 ();
      else
	offset = (short)get16 ();
      
      offset = start_pc + codep - start_codep + offset;
      set_op (offset);
      sprintf (scratchbuf, "0x%x", offset);
      oappend (scratchbuf);
      break;
    default:
      oappend ("<internal disassembler error>");
      break;
    }
  return (0);
}

/* ARGSUSED */
static int
OP_OFF (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  int off;

  append_prefix ();

  if (aflag)
    off = get32 ();
  else
    off = get16 ();
  
  sprintf (scratchbuf, "0x%x", off);
  oappend (scratchbuf);
  return (0);
}

/* ARGSUSED */
static int
OP_ESDI (dummy, aflag, dflag)
     int dummy;
     int aflag;
     int dflag;
{
  oappend ("%es:(");
  oappend (aflag ? "%edi" : "%di");
  oappend (")");
  return (0);
}

/* ARGSUSED */
static int
OP_DSSI (dummy, aflag, dflag)
     int dummy;
     int aflag;
     int dflag;
{
  oappend ("%ds:(");
  oappend (aflag ? "%esi" : "%si");
  oappend (")");
  return (0);
}



/* ARGSUSED */
static int
OP_C (dummy, aflag, dflag)
     int dummy;
     int aflag;
     int dflag;
{
  codep++; /* skip mod/rm */
  sprintf (scratchbuf, "%%cr%d", reg);
  oappend (scratchbuf);
  return (0);
}

/* ARGSUSED */
static int
OP_D (dummy, aflag, dflag)
     int dummy;
     int aflag;
     int dflag;
{
  codep++; /* skip mod/rm */
  sprintf (scratchbuf, "%%db%d", reg);
  oappend (scratchbuf);
  return (0);
}

/* ARGSUSED */
static int
OP_T (dummy, aflag, dflag)
     int dummy;
     int aflag;
     int dflag;
{
  codep++; /* skip mod/rm */
  sprintf (scratchbuf, "%%tr%d", reg);
  oappend (scratchbuf);
  return (0);
}

static int
OP_rm (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  switch (bytemode) 
    {
    case 4 :
      oappend (names32[rm]);
      break;
    case 3 :
      oappend (names16[rm]);
      break;
    }
  return (0);
}

static int
OP_MMX (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  sprintf (scratchbuf, "%%mm%d", reg);
  oappend (scratchbuf);
  return 0;
}

static int
OP_EM (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  if (mod != 3)
    return OP_E (bytemode, aflag, dflag);

  codep++;
  sprintf (scratchbuf, "%%mm%d", rm);
  oappend (scratchbuf);
  return 0;
}

static int
OP_MS (bytemode, aflag, dflag)
     int bytemode;
     int aflag;
     int dflag;
{
  ++codep;
  sprintf (scratchbuf, "%%mm%d", rm);
  oappend (scratchbuf);
  return 0;
}

static int	disassembler_initialized = 0;
static disassemble_info		disinfo;

extern FILE * x86_logfile;

static int
em86_read_memory(bfd_vma memaddr, bfd_byte *myaddr, int length,
		struct disassemble_info *info)
{
    memcpy(myaddr, memaddr, length);
    return(0);
}

static void
em86_memory_error(int status, bfd_vma memaddr, struct disassemble_info *info)
{
    (*info->fprintf_func)(info->stream, "Error reading memory @0x%x\n", memaddr);
}

static void
em86_print_address(bfd_vma addr, struct disassemble_info *info)
{
    char_count += (*info->fprintf_func)(info->stream, "%08x ", addr);
}

static void
init_disassembler()
{
    disinfo.fprintf_func = fprintf;
    disinfo.stream = x86_logfile;
    /* disinfo.application_data = ??? */
    disinfo.flavour = bfd_target_elf_flavour;
    disinfo.arch = bfd_arch_i386;
    disinfo.mach = bfd_mach_i386_i386;
    disinfo.endian = BFD_ENDIAN_LITTLE;
    disinfo.symbol = NULL;
    /* disinfo.flags = ??? */
    /* disinfo.private_data = ??? */
    disinfo.read_memory_func = em86_read_memory;
    disinfo.memory_error_func = em86_memory_error;
    disinfo.print_address_func = em86_print_address;
    /* disinfo.buffer = ??? */
    /* disinfo.buffer_vma = ??? */
    /* disinfo.buffer_length = ??? */
    disinfo.bytes_per_line = 80;
    disinfo.bytes_per_chunk = 4;
    disinfo.display_endian = BFD_ENDIAN_LITTLE;
    disinfo.insn_info_valid = 0;

    disassembler_initialized = 1;
} 

int
x86_disassemble(unsigned int pc)
{
    if(!disassembler_initialized) {
	init_disassembler();
    }
    return(print_insn_i386(pc, &disinfo));
}

void
x86_full_disassemble(unsigned int pc)
{
    int		len;
    int		i;
    unsigned char *ip;

    if(!disassembler_initialized) {
	init_disassembler();
    }

    char_count = (*disinfo.fprintf_func)(disinfo.stream, "%08x:  ", pc);
    len = print_insn_i386(pc, &disinfo);
    if(char_count < 40) {
        (*disinfo.fprintf_func)(disinfo.stream, "%*s", (40-char_count), "");
    }
    else {
        (*disinfo.fprintf_func)(disinfo.stream, "\n%40s", "");
    }
	
    
    ip = (unsigned char *)pc;
    for (i = 0; i < len; i++, ip++) {
        (*disinfo.fprintf_func)(disinfo.stream, "%02x ", (*ip & 0xff));
    }
    (*disinfo.fprintf_func)(disinfo.stream, "\n");
}
